Attribute VB_Name = "pipetypes"
Option Explicit
Public Const NMPWAIT_NOWAIT = 1
Public Const NMPWAIT_USE_DEFAULT_WAIT = 0
Public Const NMPWAIT_WAIT_FOREVER = -1

Public Const FILE_FLAG_WRITE_THROUGH = &H80000000
Public Const FILE_FLAG_OVERLAPPED = &H40000000
Public Const FILE_FLAG_NO_BUFFERING = &H20000000
Public Const FILE_FLAG_RANDOM_ACCESS = &H10000000
Public Const FILE_FLAG_SEQUENTIAL_SCAN = &H8000000
Public Const FILE_FLAG_DELETE_ON_CLOSE = &H4000000
Public Const FILE_FLAG_BACKUP_SEMANTICS = &H2000000
Public Const FILE_FLAG_POSIX_SEMANTICS = &H1000000

Public Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type

Public Type T_OVERLAPPED
    internal As Long
    internalHigh As Long
    Offset As Long
    offsetHigh As Long
    hEvent As Long
End Type

Public Declare Function CallNamedPipe Lib "kernel32" Alias _
      "CallNamedPipeA" ( _
      ByVal lpNamedPipeName As String, _
      lpInBuffer As Any, _
      ByVal nInBufferSize As Long, _
      lpOutBuffer As Any, _
      ByVal nOutBufferSize As Long, _
      lpBytesRead As Long, _
      ByVal nTimeout As Long) As Long
      
Public Declare Function GetLastError Lib "kernel32" () As Long

Public Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" _
(lpEventAttributes As SECURITY_ATTRIBUTES, ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpName As String) As Long

Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
        (ByVal lpFileName As String, ByVal _
        dwDesiredAccess As Long, ByVal dwShareMode As Long, _
        lpSecurityAttributes As SECURITY_ATTRIBUTES, _
        ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
        ByVal hTemplateFile As Long) As Long

Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Byte, _
                                                 ByVal nNumberOfBytesToRead As Long, _
                                                 lpNumberOfBytesRead As Long, _
                                                 lpOverlapped As T_OVERLAPPED) As Long

Public Declare Function ReadFileEx Lib "kernel32" (ByVal hFile As Long, lpBuffer As Byte, _
  ByVal nNumberOfBytesToRead As Long, _
  lpOverlapped As T_OVERLAPPED, _
  lpCompletionRoutine As Any) As Long

Public Declare Function WriteFile Lib "kernel32" _
                                         (ByVal hFile As Long, ByVal lpBuffer As String, _
                                          ByVal nNumberOfBytesToWrite As Long, _
                                          lpNumberOfBytesWritten As Long, _
                                          lpOverlapped As T_OVERLAPPED) As Long
                                          
Public Declare Function CloseHandle Lib "kernel32" _
                 (ByVal hObject As Long) As Long
      
Public Declare Function PeekNamedPipe Lib "kernel32" (ByVal hNamedPipe As Long, ByVal lpBufferNullPtr As Long, ByVal nBufferSize As Long, _
  ByVal lpBytesReadNullPtr As Long, TotalBytesAvail As Long, ByVal lpBytesLeftThisMessageNullPtr As Long) As Long

Public Declare Function WaitNamedPipe Lib "kernel32" Alias "WaitNamedPipeA" (ByVal lpNamedPipeName As String, ByVal nTimeout As Long) As Long

Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Public Const FILE_SHARE_READ = &H1
Public Const FILE_SHARE_WRITE = &H2
Public Const OPEN_EXISTING = 3
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000
Public Const GENERIC_EXECUTE = &H20000000
Public Const GENERIC_ALL = &H10000000

Global pipeReadBuffer(256) As Byte
Global pipeHasBeenRead As Boolean


