VERSION 5.00
Begin VB.Form ArchiveDbForm 
   BackColor       =   &H00008000&
   Caption         =   "Archive Database Manager"
   ClientHeight    =   8430
   ClientLeft      =   60
   ClientTop       =   855
   ClientWidth     =   13605
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   8430
   ScaleWidth      =   13605
   Begin VB.Frame BrowsingFrame 
      Caption         =   "Record Browsing"
      ForeColor       =   &H80000001&
      Height          =   8235
      Left            =   120
      TabIndex        =   73
      Top             =   120
      Width           =   5415
      Begin VB.Frame DatabaseFileFrame 
         Caption         =   "Database File"
         Height          =   585
         Left            =   3780
         TabIndex        =   80
         Top             =   240
         Width           =   1425
         Begin VB.TextBox dbFileText 
            Height          =   285
            Left            =   60
            TabIndex        =   81
            Text            =   "datapktr"
            Top             =   180
            Width           =   1245
         End
      End
      Begin VB.Frame ArchiveServerFrame 
         Caption         =   "Archive Server"
         Height          =   555
         Left            =   180
         TabIndex        =   76
         Top             =   240
         Width           =   1635
         Begin VB.ComboBox ArchiveServerCombo 
            Height          =   315
            Left            =   120
            Style           =   2  'Dropdown List
            TabIndex        =   79
            Top             =   180
            Width           =   1395
         End
      End
      Begin VB.Frame Frame8 
         Caption         =   "Database Entries (dbl-click to enable/disable)"
         Height          =   7035
         Left            =   120
         TabIndex        =   74
         Top             =   840
         Width           =   5145
         Begin VB.ListBox dbList 
            Height          =   6690
            Left            =   60
            TabIndex        =   75
            Top             =   210
            Width           =   4995
         End
      End
      Begin VB.Frame DatabasePathFrame 
         Caption         =   "Database Path"
         Height          =   585
         Left            =   120
         TabIndex        =   78
         Top             =   240
         Width           =   3615
         Begin VB.ComboBox dbPathCombo 
            Height          =   315
            Left            =   60
            Sorted          =   -1  'True
            TabIndex        =   77
            Text            =   "dbPath"
            Top             =   180
            Width           =   3465
         End
      End
   End
   Begin VB.Frame Frame9 
      Caption         =   "Assigned Keywords + Access and Archiving Criteria"
      ForeColor       =   &H80000001&
      Height          =   8235
      Left            =   5580
      TabIndex        =   0
      Top             =   120
      Width           =   7935
      Begin VB.CommandButton addNameCmd 
         Caption         =   "Add MCA Names"
         Height          =   315
         Left            =   1140
         TabIndex        =   88
         ToolTipText     =   "Add a names record for a selected multi-channel record"
         Top             =   1500
         Width           =   1515
      End
      Begin VB.CommandButton cloneCmd 
         Caption         =   "Clone"
         Height          =   315
         Left            =   180
         TabIndex        =   86
         ToolTipText     =   "Use same properties and devices and breakdown for another server (with/without pattern replacement)"
         Top             =   1500
         Width           =   855
      End
      Begin VB.OptionButton editOption 
         Caption         =   "Append"
         Height          =   315
         Index           =   1
         Left            =   4140
         TabIndex        =   85
         ToolTipText     =   "In Append Mode, changes or clicks to above combo box text will flush the Data Output List below!"
         Top             =   1500
         Width           =   1095
      End
      Begin VB.OptionButton editOption 
         Caption         =   "Edit"
         Height          =   315
         Index           =   0
         Left            =   3420
         TabIndex        =   84
         ToolTipText     =   "In Edit Mode, changes (not clicks!) to above combo box text will not flush the Data Output List below!"
         Top             =   1500
         Width           =   675
      End
      Begin VB.Frame Frame12 
         Caption         =   "Access Rate (interval)"
         Height          =   675
         Left            =   5460
         TabIndex        =   70
         Top             =   3720
         Width           =   2325
         Begin VB.TextBox AccessRateText 
            Height          =   315
            Left            =   180
            TabIndex        =   71
            Text            =   "1000"
            Top             =   240
            Width           =   1395
         End
         Begin VB.Label Label1 
            Caption         =   " msec"
            Height          =   255
            Left            =   1680
            TabIndex        =   72
            Top             =   300
            Width           =   615
         End
      End
      Begin VB.Frame Frame6 
         Caption         =   "Data Input"
         Height          =   2805
         Left            =   5460
         TabIndex        =   68
         Top             =   840
         Width           =   2325
         Begin VB.ComboBox infmtCombo 
            Height          =   315
            Left            =   840
            Style           =   2  'Dropdown List
            TabIndex        =   82
            Top             =   2400
            Width           =   1335
         End
         Begin VB.TextBox DataInputText 
            Height          =   2025
            Left            =   120
            MultiLine       =   -1  'True
            TabIndex        =   69
            Top             =   270
            Width           =   2115
         End
         Begin VB.Label Label13 
            Caption         =   "Format"
            Height          =   255
            Left            =   120
            TabIndex        =   83
            Top             =   2460
            Width           =   735
         End
      End
      Begin VB.CommandButton WriteDataBaseButton 
         Caption         =   "Update  DB"
         Height          =   525
         Left            =   6660
         TabIndex        =   67
         Top             =   240
         Width           =   1125
      End
      Begin VB.CommandButton AppendDatabase 
         Caption         =   "Update List"
         Height          =   525
         Left            =   5460
         TabIndex        =   66
         Top             =   240
         Width           =   1155
      End
      Begin VB.Frame Frame7 
         Caption         =   "Data Output List (select entry to edit or add new)"
         Height          =   3555
         Left            =   120
         TabIndex        =   34
         Top             =   4500
         Width           =   7665
         Begin VB.CheckBox globalsCheck 
            Caption         =   "Is Global Keywod"
            Height          =   375
            Left            =   780
            TabIndex        =   87
            Top             =   3120
            Visible         =   0   'False
            Width           =   1755
         End
         Begin VB.ListBox DataOutputList 
            Height          =   1425
            ItemData        =   "Form1.frx":0442
            Left            =   120
            List            =   "Form1.frx":0444
            TabIndex        =   53
            Top             =   240
            Width           =   7365
         End
         Begin VB.TextBox KeywordText 
            Height          =   315
            Left            =   120
            TabIndex        =   52
            Text            =   "Keyword"
            Top             =   1950
            Width           =   1550
         End
         Begin VB.ComboBox FormatCombo 
            Height          =   315
            Left            =   1700
            TabIndex        =   51
            Text            =   "FormatCombo"
            Top             =   1950
            Width           =   1215
         End
         Begin VB.TextBox SizeText 
            Height          =   315
            Left            =   2950
            TabIndex        =   50
            Text            =   "Size"
            Top             =   1950
            Width           =   555
         End
         Begin VB.TextBox UnitsText 
            Height          =   315
            Left            =   3600
            TabIndex        =   49
            Text            =   "Units"
            Top             =   1950
            Width           =   975
         End
         Begin VB.TextBox MaxText 
            Height          =   315
            Left            =   4620
            TabIndex        =   48
            Text            =   "Max"
            Top             =   1950
            Width           =   615
         End
         Begin VB.TextBox MinText 
            Height          =   315
            Left            =   5220
            TabIndex        =   47
            Text            =   "Min"
            Top             =   1950
            Width           =   615
         End
         Begin VB.TextBox ToleranceText 
            Height          =   315
            Left            =   5880
            TabIndex        =   46
            Text            =   "Tolerance"
            Top             =   1950
            Width           =   645
         End
         Begin VB.ComboBox PlotCombo 
            Height          =   315
            Left            =   6600
            TabIndex        =   45
            Text            =   "PlotCombo"
            Top             =   1950
            Width           =   900
         End
         Begin VB.TextBox DescriptionText 
            Height          =   345
            Left            =   1890
            TabIndex        =   44
            Text            =   "Comment"
            Top             =   2610
            Width           =   3375
         End
         Begin VB.CommandButton AddParam 
            Caption         =   "Add/Edit"
            Height          =   345
            Left            =   5280
            TabIndex        =   43
            Top             =   3060
            Width           =   1065
         End
         Begin VB.CommandButton RemoveParam 
            Caption         =   "Remove"
            Height          =   345
            Left            =   6420
            TabIndex        =   42
            Top             =   3060
            Width           =   1065
         End
         Begin VB.TextBox OffsetText 
            Height          =   345
            Left            =   150
            TabIndex        =   41
            Text            =   "Offset"
            Top             =   2610
            Width           =   795
         End
         Begin VB.TextBox ScaleText 
            Height          =   345
            Left            =   990
            TabIndex        =   40
            Text            =   "Scale"
            Top             =   2610
            Width           =   855
         End
         Begin VB.TextBox devLstText 
            Height          =   345
            Left            =   1530
            TabIndex        =   39
            Top             =   3120
            Width           =   1155
         End
         Begin VB.TextBox bindToText 
            Height          =   345
            Left            =   3930
            TabIndex        =   38
            Top             =   3090
            Width           =   1155
         End
         Begin VB.CheckBox devLstOption 
            Caption         =   "Associate :"
            Height          =   315
            Left            =   150
            TabIndex        =   37
            Top             =   3150
            Width           =   1125
         End
         Begin VB.CheckBox bindToOption 
            Caption         =   "Bind To :"
            Height          =   315
            Left            =   2820
            TabIndex        =   36
            Top             =   3120
            Width           =   1035
         End
         Begin VB.ComboBox SubSystemCombo 
            Height          =   315
            Left            =   5340
            TabIndex        =   35
            Text            =   "SubSystemCombo"
            Top             =   2610
            Width           =   2145
         End
         Begin VB.Label Label2 
            Caption         =   "Keyword"
            Height          =   225
            Left            =   240
            TabIndex        =   65
            Top             =   1740
            Width           =   705
         End
         Begin VB.Label Label3 
            Caption         =   "Data Format"
            Height          =   225
            Left            =   1800
            TabIndex        =   64
            Top             =   1710
            Width           =   1005
         End
         Begin VB.Label Label4 
            Caption         =   "Size"
            Height          =   195
            Left            =   3000
            TabIndex        =   63
            Top             =   1710
            Width           =   495
         End
         Begin VB.Label Label5 
            Caption         =   "Units"
            Height          =   225
            Left            =   3600
            TabIndex        =   62
            Top             =   1710
            Width           =   465
         End
         Begin VB.Label Label6 
            Caption         =   "Max"
            Height          =   225
            Left            =   4620
            TabIndex        =   61
            Top             =   1710
            Width           =   405
         End
         Begin VB.Label Label7 
            Caption         =   "Min"
            Height          =   225
            Left            =   5220
            TabIndex        =   60
            Top             =   1710
            Width           =   435
         End
         Begin VB.Label Label8 
            Caption         =   "Tolerance"
            Height          =   255
            Left            =   5760
            TabIndex        =   59
            Top             =   1710
            Width           =   765
         End
         Begin VB.Label Label9 
            Caption         =   "Plot Style"
            Height          =   255
            Left            =   6540
            TabIndex        =   58
            Top             =   1710
            Width           =   735
         End
         Begin VB.Label Label10 
            Caption         =   "Offset"
            Height          =   225
            Left            =   150
            TabIndex        =   57
            Top             =   2370
            Width           =   525
         End
         Begin VB.Label Label11 
            Caption         =   "Scale"
            Height          =   255
            Left            =   1050
            TabIndex        =   56
            Top             =   2340
            Width           =   495
         End
         Begin VB.Label Label12 
            Caption         =   "Description"
            Height          =   255
            Left            =   1920
            TabIndex        =   55
            Top             =   2340
            Width           =   975
         End
         Begin VB.Label SubSystemLabel 
            Caption         =   "Subsystem"
            Height          =   195
            Left            =   5340
            TabIndex        =   54
            Top             =   2340
            Width           =   855
         End
      End
      Begin VB.Frame Frame5 
         Caption         =   "Format"
         Height          =   555
         Left            =   3660
         TabIndex        =   32
         Top             =   840
         Width           =   1605
         Begin VB.ComboBox DataCallFormat 
            Height          =   315
            Left            =   90
            TabIndex        =   33
            Text            =   "DataCallFormat"
            Top             =   180
            Width           =   1395
         End
      End
      Begin VB.Frame Frame4 
         Caption         =   "Array Size"
         Height          =   555
         Left            =   2460
         TabIndex        =   30
         Top             =   840
         Width           =   1155
         Begin VB.TextBox ArraySizeText 
            Height          =   285
            Left            =   90
            TabIndex        =   31
            Top             =   180
            Width           =   945
         End
      End
      Begin VB.Frame Frame3 
         Caption         =   "Device Property"
         Height          =   555
         Left            =   60
         TabIndex        =   28
         Top             =   840
         Width           =   2355
         Begin VB.ComboBox DevicePropertyList 
            Height          =   315
            Left            =   60
            Sorted          =   -1  'True
            TabIndex        =   29
            Top             =   180
            Width           =   2205
         End
      End
      Begin VB.Frame FilterFrame 
         Caption         =   "Filter"
         Height          =   2535
         Left            =   60
         TabIndex        =   7
         Top             =   1860
         Width           =   5175
         Begin VB.CheckBox OptionCheck 
            Caption         =   "NEVER"
            Height          =   315
            Index           =   0
            Left            =   120
            TabIndex        =   27
            Top             =   240
            Width           =   1215
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "ALWAYS"
            Height          =   315
            Index           =   1
            Left            =   1380
            TabIndex        =   26
            Top             =   240
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "ONCE"
            Height          =   315
            Index           =   2
            Left            =   2520
            TabIndex        =   25
            Top             =   240
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "RUNNING"
            Height          =   315
            Index           =   3
            Left            =   3720
            TabIndex        =   24
            Top             =   240
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "RUNNO"
            Height          =   315
            Index           =   4
            Left            =   120
            TabIndex        =   23
            Top             =   720
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Fast"
            Height          =   315
            Index           =   5
            Left            =   1380
            TabIndex        =   22
            Top             =   720
            Width           =   1035
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Lumi"
            Height          =   315
            Index           =   6
            Left            =   2520
            TabIndex        =   21
            Top             =   720
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Once"
            Height          =   315
            Index           =   7
            Left            =   3720
            TabIndex        =   20
            Top             =   660
            Width           =   1275
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Global"
            Height          =   315
            Index           =   8
            Left            =   120
            TabIndex        =   19
            Top             =   1140
            Width           =   1155
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Ramping"
            Height          =   315
            Index           =   9
            Left            =   1380
            TabIndex        =   18
            Top             =   1140
            Width           =   1065
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Electrons"
            Height          =   315
            Index           =   10
            Left            =   2520
            TabIndex        =   17
            Top             =   1140
            Width           =   1155
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Protons"
            Height          =   315
            Index           =   11
            Left            =   3720
            TabIndex        =   16
            Top             =   1140
            Width           =   1245
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Fast Ramp"
            Height          =   315
            Index           =   12
            Left            =   120
            TabIndex        =   15
            Top             =   1620
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Injection"
            Height          =   315
            Index           =   13
            Left            =   1380
            TabIndex        =   14
            Top             =   1620
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "FAST"
            Height          =   315
            Index           =   14
            Left            =   2520
            TabIndex        =   13
            Top             =   1620
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "Slow"
            Height          =   315
            Index           =   15
            Left            =   3720
            TabIndex        =   12
            Top             =   1620
            Width           =   1245
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "FIXTIME"
            Height          =   315
            Index           =   16
            Left            =   120
            TabIndex        =   11
            Top             =   2100
            Width           =   1185
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "RUNNO"
            Height          =   315
            Index           =   17
            Left            =   1380
            TabIndex        =   10
            Top             =   2100
            Width           =   1095
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "RUNNO"
            Height          =   315
            Index           =   18
            Left            =   2520
            TabIndex        =   9
            Top             =   2100
            Width           =   1065
         End
         Begin VB.CheckBox OptionCheck 
            Caption         =   "RunNumber"
            Height          =   315
            Index           =   19
            Left            =   3720
            TabIndex        =   8
            Top             =   2100
            Width           =   1185
         End
      End
      Begin VB.Frame Frame2 
         Caption         =   "Device Name"
         Height          =   555
         Left            =   3300
         TabIndex        =   5
         Top             =   240
         Width           =   1965
         Begin VB.ComboBox DeviceNameList 
            Height          =   315
            Left            =   120
            TabIndex        =   6
            Top             =   180
            Width           =   1785
         End
      End
      Begin VB.Frame Frame1 
         Caption         =   "Device Server"
         Height          =   555
         Left            =   1440
         TabIndex        =   3
         Top             =   240
         Width           =   1845
         Begin VB.ComboBox DeviceServerList 
            Height          =   315
            Left            =   120
            Sorted          =   -1  'True
            TabIndex        =   4
            Text            =   "DeviceServerList"
            Top             =   180
            Width           =   1695
         End
      End
      Begin VB.Frame Frame11 
         Caption         =   "Device Context"
         Height          =   585
         Left            =   60
         TabIndex        =   1
         Top             =   240
         Width           =   1365
         Begin VB.ComboBox DeviceContextList 
            Height          =   315
            Left            =   30
            Sorted          =   -1  'True
            TabIndex        =   2
            Text            =   "DeviceContext"
            Top             =   210
            Width           =   1275
         End
      End
   End
   Begin VB.Menu opts 
      Caption         =   "&Options"
      Begin VB.Menu attachServer 
         Caption         =   "&Attach to Archive Server"
         Checked         =   -1  'True
      End
      Begin VB.Menu useFileSystem 
         Caption         =   "Use &File System"
      End
      Begin VB.Menu hstMap 
         Caption         =   "&Map History File"
      End
      Begin VB.Menu searchDbList 
         Caption         =   "&Search (use F3 repeat)"
      End
   End
   Begin VB.Menu configOpts 
      Caption         =   "&Configuration Options"
      Begin VB.Menu filterTableOpt 
         Caption         =   "Edit &Filter Table"
      End
      Begin VB.Menu archCfgOpt 
         Caption         =   "Edit &Archive Configurations"
      End
      Begin VB.Menu mcaEditOpts 
         Caption         =   "Edit &MCA Configurations"
      End
      Begin VB.Menu traceEditOpt 
         Caption         =   "Edit &Trace Configurations"
      End
   End
   Begin VB.Menu tgtOpts 
      Caption         =   "&Target"
      Begin VB.Menu tgtArchive 
         Caption         =   "Central &Archive"
         Checked         =   -1  'True
      End
      Begin VB.Menu tgtGlobals 
         Caption         =   "&Globals"
      End
   End
End
Attribute VB_Name = "ArchiveDbForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim dc() As String
Dim ndc As Integer
Dim ds() As String
Dim nds As Integer
Dim dn() As String
Dim ndev As Integer
Dim prp() As String, prpSiz() As Integer, prpTyp() As Integer
Dim prpDsc() As String
Dim prpMax() As Single, prpMin() As Single
Dim prpUnits() As String
Dim nprp As Integer
Dim dbPath$, dbFile$, curRecNo%, nxtRecNo%, inptFile$, hstFile$
Dim gContext As String
Dim isOpen As Boolean
Dim filterOptions(g_numFilterOptions) As String
Dim dbPathList(20) As String
Dim dbFileList(20) As String
Dim nDbFiles As Integer
Dim recs(1000) As DAQRECORD
Dim hrecs(1000) As HSTRECORD
Dim nrecs As Integer, nfixedrecs As Integer
Dim nhrecs As Integer
Dim paramsFilled As Boolean
Dim DeviceAndPropertySelected As Boolean
Dim editPreviousEntry As Boolean
Dim touchDeviceServer As Boolean
Dim databaseHasChanged As Boolean
Dim prpIndex As Integer
Dim dbListSearchString As String
'Dim defaultContext As String
'Dim filterTable(32) As String
'Dim filterTableTip(32) As String
'Dim daqFilterTable(32) As DAQFilter
'Dim sizFilterTable As Integer
Dim NeverIndex As Integer
Dim AlwaysIndex As Integer
Dim OnceIndex As Integer
Dim isUsingFileSystem As Boolean
Dim archiveServerContexts() As String
Dim nArchiveServerContexts As Integer
Dim lastDeviceContextListSelection As String
Dim paramsStale As Boolean
Dim prpsQueryPrecedence As Boolean
Dim devsQueryPrecedence As Boolean
Dim prpsQueried As Boolean
Dim prevRecord As Integer
Dim isGlobalsServer As Boolean
Dim dbServer As String
Dim glbKeywords(100) As String
Dim nGlbKeywords As Integer

Dim UseSimplePropFlag As Boolean
Dim numStaleDbRecords As Integer
Sub AppendDaqInptData(ByVal i As Integer)
Dim tok$, s$, fn$
If Len(DataInputText.text) > 0 Then
    s$ = Trim$(DataInputText.text)
    If InStr(s$, ",") Then tok$ = "," Else tok$ = " "
    fn$ = recs(i).fn_key
    recs(i).fn_inp = recs(i).fn_key
    
    Dim v() As Integer
    Dim vstr() As String
    vstr = Split(s$, tok$)
    Dim n As Integer, K As Integer, rc As Integer
    n = UBound(vstr) - LBound(vstr) + 1
    ReDim v(n)
    For i = 0 To n - 1
      v(K) = Int(vstr(K))
    Next
    Dim dbout As DBLK, dbin As DBLK
    Dim DevName As String
RetrySendInpt:
    DevName = "/" + ArchiveServerCombo.text + "/" + dbServer + "/" + recs(i).fn_inp
    dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
    dbin.dArrayLength = n: dbin.dFormat = CF_SHORT
    rc = T_EXECLINK(DevName, "KEYWORK.INPT", dbout, 0, dbin, v(0), CA_WRITE, 1000)
    If rc <> 0 Then
      rc = MsgBox("could not send input data to " + DevName + vbNewLine + RPCERROR(rc), vbRetryCancel)
      If rc = vbRetry Then GoTo RetrySendInpt
    End If
End If
DataInputText.text = ""

End Sub

Sub AppendDaqKeyParameters()
Dim i As Integer, n As Integer, alen As Integer
Dim rectxt As String
Dim hdr As String
Dim stale As Boolean

If dbList.ListIndex < 0 Then editPreviousEntry = False
If editPreviousEntry Then
  i = dbList.ListIndex
  sfile$ = recs(i).fn_key
  curRecNo% = recs(i).rec
Else
  i = getActiveEntry()
  If i >= 0 Then
    editPreviousEntry = True
    sfile$ = recs(i).fn_key
    curRecNo% = recs(i).rec
  Else
    If Not isAllowedNewEntry() Then
       MsgBox "An attempt to use the calling characteristics of record " + STR(prevRecord) + " refused!"
       Exit Sub
    End If
    sfile$ = GetValidKeyFileName(DevicePropertyList.text)
    curRecNo% = GetNextRecordNumber()
    i = nrecs
    stale = True
  End If
End If

Filtr$ = getFilterOption(recs(i).ftr)
If Len(Filtr$) = 0 Then
  MsgBox "Please select at least one filter option!", vbOKOnly
  Exit Sub
End If
stale = recs(i).stale
If recs(i).ftr <> Filtr$ Then stale = True
recs(i).ftr = Filtr$
If recs(i).rec <> curRecNo% Then stale = True
recs(i).rec = curRecNo%
If recs(i).con <> DeviceContextList.text Then stale = True
If DeviceContextList.text <> "DEFAULT" Then recs(i).con = DeviceContextList.text
If recs(i).srv <> DeviceServerList.text Then stale = True
recs(i).srv = DeviceServerList.text
If recs(i).prp <> DevicePropertyList.text Then stale = True
recs(i).prp = DevicePropertyList.text
If recs(i).dev <> DeviceNameList.text Then stale = True
recs(i).dev = DeviceNameList.text
alen = Val(ArraySizeText.text)
If recs(i).len <> alen Then stale = True
recs(i).len = alen
If recs(i).fmt <> DataCallFormat.text Then stale = True
recs(i).fmt = DataCallFormat.text
If recs(i).fn_inp <> inptFile$ Then stale = True
recs(i).fn_inp = inptFile$
recs(i).hbt = 900
alen = Val(AccessRateText.text)
If alen <= 0 Then alen = 1000
If recs(i).tmr <> alen Then stale = True
recs(i).tmr = alen
If recs(i).fn_key <> sfile$ Then stale = True
recs(i).fn_key = sfile$
recs(i).active = 1
recs(i).stale = stale
If stale Then numStaleDbRecords = numStaleDbRecords + 1
Call checkStaleThreshold
If Not stale And Not paramsStale Then Exit Sub
n = checkStructureFile(i)
If n <> 0 Then
  paramsFilled = False
  Dim rsiz As Integer
  Dim s$
  rsiz = CLng(FmtSizeOf(recs(i).fmt))
  If rsiz > 0 Then
    n = n / rsiz
    If n > 0 And DataOutputList.ListIndex = DataOutputList.ListCount - 1 Then
      keywordText.text = keywordText.text + ".add" + Trim(STR$(DataOutputList.ListIndex + 1))
      SizeText.text = STR(n)
      s$ = GetOutputListString()
      DataOutputList.AddItem s$
      DataOutputList.ListIndex = DataOutputList.ListIndex + 1
    End If
  End If
  MsgBox "Record length does not match Keyword Parameter sizes : " + STR$(n * rsiz) + " bytes difference" + _
     vbNewLine + "Please continue adding (or removing) paramters for this record"
  Exit Sub
End If

Dim inf() As DAQPrmInfo
Dim dbout As DBLK, dbin As DBLK
Dim np As Integer, rc As Integer
Dim keystrs() As String
'hdr = "keyword,Format,size,Units,Maximum,Minimum,Tolerance,Plot,Scale,Offset,comment,devices,bind,subsystem"
np = DataOutputList.ListCount
ReDim inf(np)
For n = 0 To np - 1
  keystrs = Split(DataOutputList.List(n), ",")
  BARR inf(n).key, keystrs(0)
  inf(n).fmt = CF_DOUBLE + getFormatFromString(keystrs(1))
  inf(n).size = Int(keystrs(2))
  BARR inf(n).units, keystrs(3)
  inf(n).maximum = Val(keystrs(4))
  inf(n).minimum = Val(keystrs(5))
  inf(n).aTolerance = GetAbsTolerance(keystrs(6))
  inf(n).pTolerance = GetPcntTolerance(keystrs(6)) / 100#
  BARR inf(n).plot, keystrs(7)
  inf(n).scaleFactor = Val(keystrs(8))
  inf(n).scaleOffset = Val(keystrs(9))
  BARR inf(n).desc, keystrs(10)
  BARR inf(n).assoc, keystrs(11)
  BARR inf(n).boundTo, keystrs(12)
  BARR inf(n).subs, keystrs(13)
Next
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
dbin.dArrayLength = np: dbin.dFormat = CF_STRUCT: BARR dbin.dTag, "DAQPrm"

Dim DevName As String
DevName = "/" + ArchiveServerCombo.text + "/" + dbServer + "/" + sfile$
retrySend:
rc = T_EXECLINK(DevName, "KEYWORD.INFO", dbout, 0, dbin, inf(0), CA_WRITE, 3000)
If rc Then
  rc = MsgBox("Unable to send archive record information to " + DevName + "!" + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retrySend
  Exit Sub
End If

paramsFilled = False

AppendDaqInptData i

If Not editPreviousEntry Then
    nrecs = nrecs + 1
    curRecNo% = curRecNo% + 1
    nxtRecNo% = curRecNo%
    rectxt = STR$(recs(i).rec)
    If recs(i).active = 0 Then rectxt = " X "
    If recs(i).active < 0 Then rectxt = "<" + Trim$(STR$(recs(i).rec)) + ">"
    If Len(recs(i).dev) > 0 Then
      addtext$ = "[" + rectxt + "] " + recs(i).srv + "/" + recs(i).dev + " : " + recs(i).prp
    Else
      addtext$ = "[" + rectxt + "] " + recs(i).srv + " : " + recs(i).prp
    End If
    dbList.AddItem addtext$
    dbList.text = addtext$ ' sets listIndex
    databaseHasChanged = True
Else
  'pushInputFileToList (recs(i).fn_inp)
  If recs(i).stale Then
    rectxt = STR$(recs(i).rec)
    If recs(i).active = 0 Then rectxt = " X "
    If recs(i).active < 0 Then rectxt = "<" + Trim$(STR$(recs(i).rec)) + ">"
    If Len(recs(i).dev) > 0 Then
      addtext$ = "[" + rectxt + "] " + recs(i).srv + "/" + recs(i).dev + " : " + recs(i).prp
    Else
      addtext$ = "[" + rectxt + "] " + recs(i).srv + " : " + recs(i).prp
    End If
    dbList.List(i) = addtext$
    databaseHasChanged = True
  End If
  curRecNo% = nxtRecNo%
End If
editPreviousEntry = True: touchDeviceServer = False

End Sub
Sub AppendKeyDatabaseFile()
Dim i As Integer, n As Integer
Dim rectxt As String
Dim hdr As String

On Error GoTo AppendDatabaseError
If dbList.ListIndex < 0 Then editPreviousEntry = False
If editPreviousEntry Then
  i = dbList.ListIndex
  sfile$ = recs(i).fn_key
  subdbFile$ = dbPath$ + "info\" + sfile$
  curRecNo% = recs(i).rec
Else
  i = getActiveEntry()
  If i >= 0 Then
    editPreviousEntry = True
    sfile$ = recs(i).fn_key
    subdbFile$ = dbPath$ + "info\" + sfile$
    curRecNo% = recs(i).rec
  Else
    sfile$ = DevicePropertyList.text + ".csv"
    For i = 0 To 100
     subdbFile$ = dbPath$ + "info\" + sfile$
     If Len(Dir$(subdbFile$)) = 0 Then Exit For
     sfile$ = DevicePropertyList.text + Trim$(STR$(i)) + ".csv"
    Next
    i = nrecs
  End If
End If
Filtr$ = getFilterOption(recs(i).ftr)
recs(i).rec = curRecNo%
If DeviceContextList.text <> "DEFAULT" Then recs(i).con = DeviceContextList.text
recs(i).srv = DeviceServerList.text
recs(i).prp = DevicePropertyList.text
recs(i).dev = DeviceNameList.text
recs(i).len = Val(ArraySizeText.text)
recs(i).fmt = DataCallFormat.text
recs(i).fn_inp = inptFile$
recs(i).hbt = 900
recs(i).tmr = Val(AccessRateText.text)
recs(i).ftr = Filtr$
recs(i).fn_key = sfile$
recs(i).active = 1
n = checkStructureFile(i)
If n <> 0 Then
  MsgBox "Record length does not match Keyword Parameter sizes : " + STR$(n) + " bytes"
  Exit Sub
End If
hdr = "keyword,Format,size,Units,Maximum,Minimum,Tolerance,Plot,Scale,Offset,Description,devices,bind,subsystem"
Open subdbFile$ For Output As 2
Print #2, hdr
For n = 0 To DataOutputList.ListCount - 1
  Print #2, DataOutputList.List(n)
Next
Close 2

paramsFilled = False
fillInputdata (i)

If Not editPreviousEntry Then
    nrecs = nrecs + 1
    curRecNo% = curRecNo% + 1
    nxtRecNo% = curRecNo%
    rectxt = STR$(recs(i).rec)
    If recs(i).active = 0 Then rectxt = " X "
    If recs(i).active < 0 Then rectxt = "<" + Trim$(STR$(recs(i).rec)) + ">"
    If Len(recs(i).dev) > 0 Then
      addtext$ = "[" + rectxt + "] " + recs(i).srv + "/" + recs(i).dev + " : " + recs(i).prp
    Else
      addtext$ = "[" + rectxt + "] " + recs(i).srv + " : " + recs(i).prp
    End If
    dbList.AddItem addtext$
    dbList.text = addtext$ ' sets listIndex
    databaseHasChanged = True
Else
  pushInputFileToList (recs(i).fn_inp)
  curRecNo% = nxtRecNo%
End If
editPreviousEntry = True: touchDeviceServer = False
Exit Sub
AppendDatabaseError:
makeDBPathStructure
Resume

End Sub

Sub checkStaleThreshold()
  If numStaleDbRecords > 90 Then
    Dim msg As String
    msg = "You appear to have made " + STR(numStaleDbRecords) + " database changes so far" + vbNewLine
    msg = "You should click " + WriteDataBaseButton.Caption + " as soon as possible" + vbNewLine
    msg = "Otherwise you risk overwhelming the remote resources and losing your work !"
    MsgBox msg, vbOKOnly, "Important Message"
  End If
End Sub

Sub fillExistingHistory()
Dim idx_col As Integer, nam_col As Integer, prp_col As Integer, dev_col As Integer
Dim len_col As Integer, fmt_col As Integer, tol_col As Integer, hbt_col As Integer
Dim rat_col As Integer
Dim rectxt As String
If Len(Dir$(hstFile$)) = 0 Then Exit Sub
On Error GoTo fillExistingHistoryError
Open hstFile$ For Input Access Read Shared As #1
i = 0
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not done Then
      idx_col = colptr(a$, "Index")
      nam_col = colptr(a$, "Export Name")
      prp_col = colptr(a$, "Property")
      dev_col = colptr(a$, "Device")
      len_col = colptr(a$, "Data Length")
      fmt_col = colptr(a$, "Format")
      hbt_col = colptr(a$, "Heartbeat")
      rat_col = colptr(a$, "Polling Rate")
      tol_col = colptr(a$, "Tolerance")
      done = True
    Else
      hrecs(i).idx = Val(getcol(a$, idx_col))
      hrecs(i).srv = getcol(a$, nam_col)
      hrecs(i).prp = getcol(a$, prp_col)
      hrecs(i).dev = getcol(a$, dev_col)
      hrecs(i).len = Val(getcol(a$, len_col))
      hrecs(i).fmt = getcol(a$, fmt_col)
      hrecs(i).hbt = Val(getcol(a$, hbt_col))
      hrecs(i).tmr = Val(getcol(a$, rat_col))
      hrecs(i).tol = getcol(a$, tol_col)
      i = i + 1
    End If
  End If
Loop While Not EOF(1)
Close 1
nhrecs = i
Exit Sub
fillExistingHistoryError:
nhrecs = 0
MsgBox "Cannot open " + hstFile$
End Sub
Private Sub findNextItemInDb()
Dim i As Integer
StartSearch:
For i = dbList.ListIndex + 1 To dbList.ListCount - 1
  If InStr(dbList.List(i), dbListSearchString) > 0 Then
    dbList.ListIndex = i
    Exit Sub
  End If
Next
If dbList.ListIndex = 0 Then
  MsgBox dbListSearchString + " not found in any record entries", vbOKOnly, "Search Records"
Else
  dbList.ListIndex = 0
  GoTo StartSearch
End If
End Sub

Function GetAbsTolerance(ByVal toleranceString) As Single
Dim p As Integer, p1 As Integer
p = InStr(toleranceString, "%")
If p = 0 Then
  GetAbsTolerance = Val(toleranceString)
Else
  p1 = InStr(toleranceString, "+")
  If p1 = 0 Then
    GetAbsTolerance = 0
  Else
    If p1 < p Then
      GetAbsTolerance = Val(Left$(toleranceString, p1 - 1))
    Else
      GetAbsTolerance = Val(Right$(toleranceString, Len(toleranceString) - p1))
    End If
  End If
End If
End Function
Sub GetArchiveServerContexts(ByVal SrvName As String)
Dim rc As Integer, i As Integer
rc = GetEquipmentDeviceContextsForServer(SrvName, archiveServerContexts, nArchiveServerContexts)
If rc <> 0 Then
  MsgBox "Cannot acquire archive server context information!" + vbNewLine + RPCERROR(rc), vbOKOnly, "GetArchiveServerContexts"
  useFileSystem.Checked = True
  attachServer.Checked = False
  attachServer.Enabled = False
  useFileSystem.Enabled = False
  isUsingFileSystem = True
  Exit Sub
End If
ArchiveServerCombo.Clear
For i = 0 To nArchiveServerContexts - 1
  ArchiveServerCombo.AddItem archiveServerContexts(i)
Next
ArchiveServerCombo.ListIndex = 0
End Sub

Function getFilterOptionCode(ByVal filterString As String) As Long
Dim i As Integer
Dim v As Long
For i = 0 To sizFilterTable - 1 Step 1
  If InStr(filterString, filterTable(i)) > 0 Then
    v = v + 2 ^ i
  End If
Next
getFilterOptionCode = v
End Function

Function GetFilterString(ByVal filterOptions As Long) As String
  Dim i As Long
  Dim filterString As String
  For i = 0 To sizFilterTable - 1 Step 1
    If GET32BIT(filterOptions, i) <> 0 Then
    'If GetBit(filterOptions, i) <> 0 Then
       If Len(filterString) > 0 Then filterString = filterString + "|"
       filterString = filterString + filterTable(i)
    End If
  Next
  GetFilterString = filterString
End Function

Sub GetFilterTable()
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim rc As Integer
Dim dev As String
Dim nm(32) As NAME64

If isGlobalsServer Then Exit Sub
retryGetFilterTable:
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 32: dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "DAQFltr"
dev = "/" + defaultContext + "/" + dbServer
rc = T_EXECLINK(dev, "FILTERTABLE", dbout, daqFilterTable(0).tag(0), dbin, Null, CA_READ + CA_MUTABLE, 800)
If rc = link_not_open Or rc = connection_timeout Then
  If MsgBox("Could not acquire Filter Table : " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
    GoTo retryGetFilterTable
  End If
  Exit Sub
End If
If rc = illegal_format Then
  dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
  dbout.dArrayLength = 32: dbout.dFormat = CF_NAME64
  dev = "/" + defaultContext + "/" + dbServer
  rc = T_EXECLINK(dev, "FILTERTABLE", dbout, nm(0).nam(0), dbin, Null, CA_READ + CA_MUTABLE, 800)
  If rc Then GoTo exitSub
  n = dbout.dArrayLength
  For i% = 0 To n - 1
    filterTable(i%) = BSTR(nm(i%).nam)
  Next
Else
  n = dbout.dArrayLength
  For i% = 0 To n - 1
    filterTable(i%) = BSTR(daqFilterTable(i%).tag)
    filterTableTip(i%) = BSTR(daqFilterTable(i%).desc)
    If Len(filterTable(i%)) = 0 Then
      n = i% - 1
      Exit For
    End If
  Next
End If
For i% = 0 To n - 1
  If UCase(filterTable(i%)) = "NEVER" Then
    NeverIndex = i%
  ElseIf UCase(filterTable(i%)) = "ALWAYS" Then
    AlwaysIndex = i%
  ElseIf UCase(filterTable(i%)) = "ONCE" Then
    OnceIndex = i%
  End If
Next
exitSub:
sizFilterTable = n


End Sub

Function GetNextRecordNumber() As Integer
Dim i As Integer, n As Integer
For i = 0 To nrecs - 1
  If recs(i).rec > n Then n = recs(i).rec
Next
GetNextRecordNumber = n + 1
End Function

Private Function GetOutputListString() As String
Dim s$
s$ = ""
s$ = s$ + keywordText.text
s$ = s$ + "," + FormatCombo.text
s$ = s$ + "," + SizeText.text
s$ = s$ + "," + UnitsText.text
s$ = s$ + "," + MaxText.text
s$ = s$ + "," + MinText.text
s$ = s$ + "," + ToleranceText.text
s$ = s$ + "," + PlotCombo.text
s$ = s$ + "," + ScaleText.text
s$ = s$ + "," + OffsetText.text
s$ = s$ + "," + descriptionText.text
s$ = s$ + "," + devLstText.text
s$ = s$ + "," + bindToText.text
s$ = s$ + "," + SubSystemCombo.text
GetOutputListString = s
End Function

Function GetPcntTolerance(ByVal toleranceString) As Single
Dim p As Integer, p1 As Integer
p = InStr(toleranceString, "%")
If p = 0 Then
  GetPcntTolerance = 0
Else
  p1 = InStr(toleranceString, "+")
  If p1 = 0 Then
    'GetPcntTolerance = Val(toleranceString) ' 10Feb2011 Added the p-1
    GetPcntTolerance = Val(Left$(toleranceString, p - 1))
  Else
    If p < p1 Then
      GetPcntTolerance = Val(Left$(toleranceString, p - 1))
    Else
      GetPcntTolerance = Val(Right$(toleranceString, Len(toleranceString) - p))
    End If
  End If
End If

End Function

Function GetToleranceAsString(ByVal aTolerance As Single, ByVal pTolerance As Single)
Dim tolstr As String
If (aTolerance = 0) And (pTolerance = 0) Then
  GetToleranceAsString = "0"
  Exit Function
End If
aTolerance = Abs(aTolerance)
pTolerance = Abs(pTolerance) * 100
If aTolerance > 0 Then tolstr = STR(aTolerance)
If pTolerance > 0 Then
  If Len(tolstr) > 0 Then tolstr = tolstr + " + "
  tolstr = tolstr + STR(pTolerance) + "%"
End If
GetToleranceAsString = tolstr
End Function

Function GetValidDescription(ByVal dsc As String) As String
Dim p As Integer
p = InStr(dsc, ",")
While p > 0
  dsc = Left$(dsc, p - 1) + " " + Right$(dsc, Len(dsc) - p)
  p = InStr(dsc, ",")
Wend
GetValidDescription = dsc
End Function

Function GetValidKeyFileName(ByVal fn As String) As String
Dim kn As String
Dim i As Integer, n As Integer

kn = fn + ".csv"
retryScan:
For i = 0 To nrecs - 1
  If recs(i).fn_key = kn Then
    n = n + 1
    kn = fn + Trim(STR$(n)) + ".csv"
    GoTo retryScan
  End If
Next
GetValidKeyFileName = kn
End Function

Sub histToArc()
Dim i As Integer, n As Integer, rc As Integer
Dim usr As String, hdr As String, dsc As String
Dim sfile$, s$
Dim minstr$, maxstr$, egustr$, egutyp As Integer
Dim pqx As PropertyQueryEx

usr = Environ$("USERNAME")
For i = 0 To nhrecs - 1
  recs(i).active = 1
  recs(i).dev = hrecs(i).dev
  recs(i).fmt = hrecs(i).fmt
  recs(i).ftr = "ALWAYS"
  recs(i).hbt = hrecs(i).hbt
  recs(i).len = hrecs(i).len
  recs(i).prp = hrecs(i).prp
  recs(i).tmr = hrecs(i).tmr
  recs(i).rec = i + 1
  recs(i).srv = hrecs(i).srv
  recs(i).fn_key = hrecs(i).prp + ".csv"
Next
n = nhrecs
For i = 0 To nhrecs - 1
  If hrecs(i).len > 1 Then
    recs(n).active = 1
    recs(n).dev = hrecs(i).dev
    recs(n).fmt = "NAME32"
    recs(n).ftr = "ONCE"
    recs(n).hbt = hrecs(i).hbt
    recs(n).len = hrecs(i).len
    recs(n).prp = hrecs(i).prp + ".NAM"
    recs(n).tmr = hrecs(i).tmr
    recs(n).rec = n + 1
    recs(n).srv = hrecs(i).srv
    recs(n).fn_key = hrecs(i).prp + "-NAM.csv"
    n = n + 1
  End If
Next

nrecs = n
Call writeDBFile

hdr = "keyword,Format,size,Units,Maximum,Minimum,Tolerance,Plot,Scale,Offset,comment,devices,bind,subsystem"

For i = 0 To nhrecs - 1
  rc = GetPropertyInformationEx(hrecs(i).srv, hrecs(i).prp, pqx)
  'rc = GetEquipmentExtEGU(hrecs(i).srv, hrecs(i).prp, minval!, maxval!, egustr$, egutyp)
  s$ = ""
  s$ = s$ + hrecs(i).prp
  s$ = s$ + "," + hrecs(i).fmt
  s$ = s$ + "," + STR(hrecs(i).len)
  s$ = s$ + "," + BSTR(pqx.prpUnits)
  s$ = s$ + "," + STR(pqx.prpMaxValue)
  s$ = s$ + "," + STR(pqx.prpMinValue)
  s$ = s$ + "," + hrecs(i).tol
  s$ = s$ + "," + "LIN"
  s$ = s$ + "," + "1.0"
  s$ = s$ + "," + "0.0"
  dsc = BSTR(pqx.prpDesc)
  If InStr(dsc, ",") > 0 Then dsc = Chr(34) + dsc + Chr(34)
  s$ = s$ + "," + dsc
  If hrecs(i).len > 1 Then
    s$ = s$ + "," + hrecs(i).prp + ".NAM"
  Else
    s$ = s$ + "," + ""
  End If
  s$ = s$ + "," + ""
  s$ = s$ + "," + "RF"
  sfile$ = recs(i).fn_key
  subdbFile$ = dbPath$ + "info\" + sfile$
  Open subdbFile$ For Output As 2
  Print #2, hdr
  Print #2, s$
  Close 2
  If hrecs(i).len > 1 Then
    s$ = ""
    s$ = s$ + hrecs(i).prp + ".NAM"
    s$ = s$ + "," + "NAME32"
    s$ = s$ + "," + STR(hrecs(i).len)
    s$ = s$ + "," + "none"
    s$ = s$ + "," + ""
    s$ = s$ + "," + ""
    s$ = s$ + "," + "0"
    s$ = s$ + "," + "LIN"
    s$ = s$ + "," + "1.0"
    s$ = s$ + "," + "0.0"
    s$ = s$ + "," + BSTR(pqx.prpDesc) + " device names"
    s$ = s$ + "," + ""
    s$ = s$ + "," + ""
    s$ = s$ + "," + "RF"
    sfile$ = hrecs(i).prp + "-NAM.csv"
    subdbFile$ = dbPath$ + "info\" + sfile$
    Open subdbFile$ For Output As 2
    Print #2, hdr
    Print #2, s$
    Close 2
  End If
Next
Exit Sub
histToArcError:
MsgBox "Cannot make Archive database"
End Sub
Function isAllowedNewEntry() As Boolean
Dim i As Integer
prevRecord = -1
isAllowedNewEntry = True
If nrecs = 0 Then Exit Function
For i = 0 To nrecs - 1
    If StringsEqual(recs(i).con, DeviceContextList.text) And _
       StringsEqual(recs(i).srv, DeviceServerList.text) And _
       StringsEqual(recs(i).prp, DevicePropertyList.text) And _
       StringsEqual(recs(i).dev, DeviceNameList.text) And _
       (recs(i).active > 0) Then
      If (recs(i).len <> Val(ArraySizeText.text)) Or _
          Not StringsEqual(recs(i).fmt, DataCallFormat.text) Then
        If InStr(recs(i).ftr, "ONCE") = 0 And OptionCheck(1).Value = 0 Then
        prevRecord = i
        isAllowedNewEntry = False
        End If
      End If
      Exit For
    End If
Next
End Function

Sub pushKeyInptToList(ByVal ifn As String)
Dim dbin As DBLK, dbout As DBLK
Dim n As Integer
Dim DevName As String, tmp As String
Dim rc As Integer, i As Integer
Dim inpt(100) As Integer

retryInptAcq:
dbout.dArrayLength = 100: dbout.dFormat = CF_SHORT
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
DevName = "/" + ArchiveServerCombo.text + "/" + dbServer + "/" + ifn

rc = T_EXECLINK(DevName, "KEYWORD.INPT", dbout, inpt(0), dbin, 0, CA_READ + CA_RETRY, 1000)
If rc <> 0 Then
  rc = MsgBox("Cannot acquire keyword information from " + DevName + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retryInptAcq
  Exit Sub
End If
n = dbout.dArrayLength

s$ = ""
For i = 0 To n - 1
  s$ = s$ + STR$(inpt(i)) + " "
Next
DataInputText.text = s$
End Sub

Sub registerStructs()
AddFieldToStruct "DAQRec", 0, 80, CF_TEXT, "fn_key"
AddFieldToStruct "DAQRec", 80, 80, CF_TEXT, "fn_inp"
AddFieldToStruct "DAQRec", 160, 32, CF_TEXT, "ctx"
AddFieldToStruct "DAQRec", 192, 32, CF_TEXT, "srv"
AddFieldToStruct "DAQRec", 224, 64, CF_TEXT, "prp"
AddFieldToStruct "DAQRec", 288, 64, CF_TEXT, "dev"
AddFieldToStruct "DAQRec", 352, 1, CF_LONG, "len"
AddFieldToStruct "DAQRec", 356, 1, CF_LONG, "fmt"
AddFieldToStruct "DAQRec", 360, 1, CF_LONG, "hbt"
AddFieldToStruct "DAQRec", 364, 1, CF_LONG, "tmr"
AddFieldToStruct "DAQRec", 368, 1, CF_LONG, "infmt"
AddFieldToStruct "DAQRec", 372, 1, CF_LONG, "inlen"
AddFieldToStruct "DAQRec", 376, 1, CF_LONG, "opt"
AddFieldToStruct "DAQRec", 380, 1, CF_LONG, "active"
AddFieldToStruct "DAQRec", 384, 1, CF_LONG, "rec"
SealTaggedStruct "DAQRec", 388, 1000

AddFieldToStruct "DAQPrm", 0, 64, CF_TEXT, "key"
AddFieldToStruct "DAQPrm", 64, 16, CF_TEXT, "units"
AddFieldToStruct "DAQPrm", 80, 64, CF_TEXT, "desc"
AddFieldToStruct "DAQPrm", 144, 16, CF_TEXT, "plot"
AddFieldToStruct "DAQPrm", 160, 64, CF_TEXT, "boundTo"
AddFieldToStruct "DAQPrm", 224, 16, CF_TEXT, "sub"
AddFieldToStruct "DAQPrm", 240, 64, CF_TEXT, "assoc"
AddFieldToStruct "DAQPrm", 304, 1, CF_LONG, "fmt"
AddFieldToStruct "DAQPrm", 308, 1, CF_LONG, "siz"
AddFieldToStruct "DAQPrm", 312, 1, CF_FLOAT, "scaleFactor"
AddFieldToStruct "DAQPrm", 316, 1, CF_FLOAT, "scaleOffset"
AddFieldToStruct "DAQPrm", 320, 1, CF_FLOAT, "maximim"
AddFieldToStruct "DAQPrm", 324, 1, CF_FLOAT, "minimum"
AddFieldToStruct "DAQPrm", 328, 1, CF_FLOAT, "aTolerance"
AddFieldToStruct "DAQPrm", 332, 1, CF_FLOAT, "pTolerance"
SealTaggedStruct "DAQPrm", 336, 25

AddFieldToStruct "DAQFltr", 0, 64, CF_TEXT, "tag"
AddFieldToStruct "DAQFltr", 64, 64, CF_TEXT, "key"
AddFieldToStruct "DAQFltr", 128, 64, CF_TEXT, "desc"
AddFieldToStruct "DAQFltr", 192, 64, CF_TEXT, "sValid"
AddFieldToStruct "DAQFltr", 256, 1, CF_LONG, "mask"
AddFieldToStruct "DAQFltr", 260, 1, CF_LONG, "valid"
AddFieldToStruct "DAQFltr", 264, 1, CF_LONG, "active"
AddFieldToStruct "DAQFltr", 268, 1, CF_LONG, "sValidCmp"
AddFieldToStruct "DAQFltr", 272, 1, CF_LONG, "fmtValidMin"
AddFieldToStruct "DAQFltr", 276, 1, CF_LONG, "fmtValidMax"
AddFieldToStruct "DAQFltr", 280, 1, CF_DOUBLE, "fValidMin"
AddFieldToStruct "DAQFltr", 288, 1, CF_DOUBLE, "fValidMax"
SealTaggedStruct "DAQFltr", 296, 32

End Sub

Sub ReLoadDaqDatabase()
Dim dbout As DBLK, dbin As DBLK
Dim rc As Integer
DevName = "/" + ArchiveServerCombo.text + "/" + dbServer
retrySendReload1:
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
rc = T_EXECLINK(DevName, "DB.RELOAD", dbout, 0, dbin, 0, CA_WRITE, 3000)
If rc <> 0 Then
  rc = MsgBox("Could not reload database on " + DevName + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retrySendReload1
End If
If isGlobalsServer Then Exit Sub
DevName = "/" + ArchiveServerCombo.text + "/ARCHIVER"
retrySendReload2:
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
rc = T_EXECLINK(DevName, "DB.RELOAD", dbout, 0, dbin, 0, CA_WRITE, 3000)
If rc <> 0 Then
  rc = MsgBox("Could not reload database on " + DevName + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retrySendReload2
End If

End Sub

Sub SetBrowsingCombos()
If isUsingFileSystem Then
  ArchiveServerFrame.Visible = False
  DatabasePathFrame.Visible = True
  DatabaseFileFrame.Visible = True
  BrowsingFrame.Caption = "Record Browsing (File System)"
  WriteDataBaseButton.ToolTipText = "write all database changes to file system"
Else
  ArchiveServerFrame.Visible = True
  DatabasePathFrame.Visible = False
  DatabaseFileFrame.Visible = False
  BrowsingFrame.Caption = "Record Browsing (Archive Server Direct Access)"
  WriteDataBaseButton.ToolTipText = "update and reload all database changes remotely"
End If
End Sub

Function StringsEqual(ByVal Str1 As String, ByVal Str2 As String) As Boolean
Dim s1 As String, s2 As String
s1 = UCase(Str1)
s2 = UCase(Str2)
If s1 = s2 Then StringsEqual = True Else StringsEqual = False
End Function

Function updateDaqDatabase() As Integer
Dim i As Integer, n As Integer, rc As Integer
Dim daqr(100) As DAQRecInfo
Dim dbout As DBLK, dbin As DBLK
Dim DevName As String

For i = 0 To nrecs - 1
  If recs(i).stale Then
    daqr(n).active = recs(i).active
    BARR daqr(n).ctx, recs(i).con
    BARR daqr(n).srv, recs(i).srv
    BARR daqr(n).prp, recs(i).prp
    BARR daqr(n).dev, recs(i).dev
    BARR daqr(n).fn_inp, recs(i).fn_inp
    BARR daqr(n).fn_key, recs(i).fn_key
    daqr(n).fmt = CF_DOUBLE + tine.getFormatFromString(recs(i).fmt)
    daqr(n).hbt = recs(i).hbt
    daqr(n).len = recs(i).len
    daqr(n).opt = getFilterOptionCode(recs(i).ftr)
    daqr(n).rec = recs(i).rec
    daqr(n).tmr = recs(i).tmr
    daqr(n).inlen = recs(i).inlen
    daqr(n).infmt = CF_DOUBLE + tine.getFormatFromString(recs(i).infmt)
    recs(i).stale = False
'Debug.Print recs(i).con, recs(i).srv, recs(i).dev, recs(i).prp
    n = n + 1
  End If
Next
If n = 0 Then
  updateDaqDatabase = tine.already_assigned
  Exit Function
End If
DevName = "/" + ArchiveServerCombo.text + "/" + dbServer
retrySendUpdate:
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
dbin.dArrayLength = n: dbin.dFormat = CF_STRUCT: BARR dbin.dTag, "DAQRec"
rc = T_EXECLINK(DevName, "RECORD.INFO", dbout, 0, dbin, daqr(0), CA_WRITE, 3000)
If rc <> 0 Then
  rc = MsgBox("Could not update database on " + DevName + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retrySendUpdate
End If
numStaleDbRecords = 0
If isGlobalsServer Then
Dim n64(99) As NAME64
  If nGlbKeywords = 0 Then
    rc = MsgBox("no globals keywords are registered! (Did you remember to check the 'is Global Keyword' checkbox?)", vbOKOnly)
    updateDaqDatabase = configuration_error
    Exit Function
  End If
retryGlbPut:
  dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
  dbin.dArrayLength = nGlbKeywords: dbin.dFormat = CF_NAME64: BARR dbin.dTag, ""
  For i = 0 To nGlbKeywords - 1
    BARR n64(i).nam, glbKeywords(i)
  Next
  rc = T_EXECLINK(DevName, "GLOBALS", dbout, 0, dbin, n64(0).nam(0), CA_WRITE, 3000)
  If rc Then
    rc = MsgBox("Unable to update globals information on " + DevName + "!" + vbNewLine + RPCERROR(rc), vbRetryCancel)
    If rc = vbRetry Then GoTo retryGlbPut
  End If
End If

updateDaqDatabase = rc
End Function
Sub updateFilterOptions()
If isGlobalsServer Then Exit Sub
If Len(defaultContext) > 0 Then
  GetFilterTable
Else
  loadFilterOptions
End If
Dim i As Integer
For i = 0 To sizFilterTable - 1 Step 1
  OptionCheck(i).Visible = True
  OptionCheck(i).Caption = filterTable(i)
Next
For i = sizFilterTable To 19 Step 1
  OptionCheck(i).Visible = False
Next
End Sub

Sub writeDBFile()
Dim i As Integer
On Error GoTo writeDBFileError
Open dbFile$ For Output As 1
Print #1, "Record, Context, Server, Device, Property, Length, Format, Input, Heartbeat, Poll, Filter,  Structure, Active"
For i = 0 To nrecs - 1
  If (i > nfixedrecs) And (recs(i).active = 0) Then
    Debug.Print "skipping deleted record : " & recs(i).srv & " " & recs(i).prp
  Else
    Print #1, STR$(recs(i).rec) & "," & recs(i).con & "," & recs(i).srv & "," & recs(i).dev _
      & "," & recs(i).prp & "," & STR$(recs(i).len) & "," & recs(i).fmt _
      & "," & recs(i).fn_inp & "," & STR$(recs(i).hbt) & "," & STR$(recs(i).tmr) _
      & "," & recs(i).ftr & "," & recs(i).fn_key _
      & "," & STR$(recs(i).active)
  End If
Next
Close 1

If Not isInConfigFileList(dbPath$, dbFileText.text) Then
  If nDbFiles < 20 Then
    dbPathList(nDbFiles) = dbPath$
    dbFileList(nDbFiles) = dbFileText.text
    nDbFiles = nDbFiles + 1
    writeDbPathInfo
  End If
End If
Exit Sub
writeDBFileError:
makeDBPathStructure
Resume
End Sub

Private Sub addNameCmd_Click()
Dim s As String, pat1 As String, pat2 As String
Dim keyprts() As String
Dim i As Integer, sz As Integer

i = dbList.ListIndex
If i < 0 Then
  MsgBox "Please select a multi-channel array record !"
  Exit Sub
End If
If Val(ArraySizeText.text) = 1 Then
  MsgBox "this record is not an array !"
  Exit Sub
End If

s = DevicePropertyList.text
If Right$(s, 4) = ".NAM" Then
  MsgBox "This record is already an MCA names record !"
  Exit Sub
End If
DevicePropertyList.text = s + ".NAM"
editPreviousEntry = False

DataCallFormat.text = "NAME64"
OptionCheck(1).Value = 1

On Error Resume Next
For i = 0 To DataOutputList.ListCount - 1
  a$ = DataOutputList.List(i%)
  s = getcol(a$, 0)
  keywordText.text = keywordText.text + ".NAM"
  FormatCombo.text = DataCallFormat.text
  SizeText.text = getcol(a$, 2)
  UnitsText.text = getcol(a$, 3)
  MaxText.text = getcol(a$, 4)
  MinText.text = getcol(a$, 5)
  ToleranceText.text = getcol(a$, 6)
  PlotCombo.text = getcol(a$, 7)
  ScaleText.text = getcol(a$, 8)
  OffsetText.text = getcol(a$, 9)
  descriptionText.text = GetValidDescription(getcol(a$, 10)) + " names"
  devLstText.text = getcol(a$, 11)
  bindToText.text = ""
  SubSystemCombo.text = getcol(a$, 13)
  devLstOption.Enabled = False
  devLstText.text = ""
  bindToOption.Value = 0
  s$ = GetOutputListString()
  DataOutputList.List(i) = s$
Next

End Sub

Private Sub AddParam_Click()
Dim i As Integer

s$ = GetOutputListString()
i = DataOutputList.ListIndex
If i >= 0 And i < DataOutputList.ListCount Then
  Dim oldItem  As String
  oldItem = DataOutputList.List(i)
  If oldItem = s$ Then Exit Sub
  DataOutputList.List(i) = s$
  paramsStale = True
  If editPreviousEntry Then
    Call AppendDatabase_Click
  End If
  Exit Sub
End If
If paramsFilled Then
  MsgBox "Please select a new record"
  Exit Sub
End If
If Len(keywordText.text) = 0 Then
  MsgBox "Please fill in Key word parameters"
  Exit Sub
End If

DataOutputList.AddItem s$
DeviceAndPropertySelected = True
fillInSubParams
paramsStale = True
End Sub
Sub fillInputdata(i As Integer)
Dim tok$, s$, fn$
If Len(DataInputText.text) > 0 Then
    s$ = Trim$(DataInputText.text)
    If InStr(s$, ",") Then tok$ = "," Else tok$ = " "
    fn$ = recs(i).fn_key
    fn$ = dbPath$ + "input\" + recs(i).fn_key
    recs(i).fn_inp = recs(i).fn_key
    Open fn$ For Output As 1
    Print #1, "Data"
    Do
      p% = InStr(s$, tok$)
      If p% = 0 Then
        p% = Len(s$): v$ = s$: s$ = ""
      Else
        v$ = s$: s$ = Right$(s$, Len(s$) - p%): s$ = LTrim$(s$)
      End If
      Print #1, Left$(v$, p%)
    Loop While Len(s$) > 0
    Close 1
End If
DataInputText.text = ""

End Sub
Function checkStructureFile(rec As Integer) As Long
Dim nbytesRecord As Long, nBytes As Long, i As Integer
Dim n As Long, f As String, ln$

On Error GoTo ErrorRoutine

nbytesRecord = CLng(recs(rec).len) * CLng(FmtSizeOf(recs(rec).fmt))

For i = 0 To DataOutputList.ListCount - 1
  ln$ = DataOutputList.List(i%)
  n = Val(getcol(ln$, 2)): f = getcol(ln$, 1)
  nBytes = nBytes + n * FmtSizeOf(f)
Next
checkStructureFile = nbytesRecord - nBytes
Exit Function
ErrorRoutine:
Resume Next
End Function
Function getActiveEntry() As Integer
Dim i As Integer
getActiveEntry = -1
If nrecs = 0 Then Exit Function
For i = 0 To nrecs - 1
    If StringsEqual(recs(i).con, DeviceContextList.text) And _
       StringsEqual(recs(i).srv, DeviceServerList.text) And _
       StringsEqual(recs(i).prp, DevicePropertyList.text) And _
       StringsEqual(recs(i).dev, DeviceNameList.text) And _
       (recs(i).len = Val(ArraySizeText.text)) And _
       StringsEqual(recs(i).fmt, DataCallFormat.text) And _
       (recs(i).active > 0) Then
      Exit For
    End If
Next
If i < nrecs Then getActiveEntry = i
End Function
Private Sub makeDBPathStructure()
Dim p$, sd() As String
On Error GoTo makeDBPathStructure
sd = Split(dbPath$, "\")
p$ = sd(0)
For i = 1 To UBound(sd) - 1
  p$ = p$ + "\" + sd(i)
  MkDir p$
Next
MkDir p$ + "\info"
MkDir p$ + "\input"
Exit Sub
makeDBPathStructure:
MsgBox "Error in makeDBPathStructure " + Err.Description
'Resume Next
End Sub

Private Sub AppendDatabase_Click()
If isUsingFileSystem Then
  AppendKeyDatabaseFile
Else
  AppendDaqKeyParameters
End If
End Sub

Private Sub archCfgOpt_Click()
Shell App.path + "\cfgMgr.exe " + ArchiveServerCombo.text, vbNormalFocus
End Sub

Private Sub ArchiveServerCombo_Click()
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim inf() As DAQRecInfo
Dim DevName As String
Dim rc As Integer, i As Integer
Dim addtext As String, rectxt As String
defaultContext = ArchiveServerCombo.text
updateFilterOptions
DevName = "/" + ArchiveServerCombo.text + "/" + dbServer
ReDim inf(1000)
retryRecAcq:
dbin.dFormat = CF_NULL
dbout.dArrayLength = 1000: dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "DAQRec"
rc = T_EXECLINK(DevName, "RECORD.INFO", dbout, inf(0), dbin, 0, CA_READ + CA_RETRY, 3000)
If rc Then
  rc = MsgBox("Unable to acquire archive record information from " + DevName + "!" + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retryRecAcq
  Exit Sub
End If
nrecs = dbout.dArrayLength
numStaleDbRecords = 0
dbList.Clear
For i = 0 To nrecs - 1
  recs(i).con = BSTR(inf(i).ctx)
  recs(i).srv = BSTR(inf(i).srv)
  recs(i).prp = BSTR(inf(i).prp)
  recs(i).dev = BSTR(inf(i).dev)
  recs(i).fn_inp = BSTR(inf(i).fn_inp)
  recs(i).fn_key = BSTR(inf(i).fn_key)
  recs(i).active = inf(i).active
  recs(i).fmt = tine.GetFormatAsString(inf(i).fmt)
  recs(i).len = inf(i).len
  recs(i).ftr = GetFilterString(inf(i).opt)
  recs(i).hbt = inf(i).hbt
  recs(i).infmt = tine.GetFormatAsString(inf(i).infmt)
  recs(i).inlen = inf(i).inlen
  recs(i).rec = inf(i).rec
  recs(i).tmr = inf(i).tmr
  recs(i).stale = False
  
  If recs(i).active = 0 Then
    rectxt = " X "
  ElseIf recs(i).active < 0 Then
    rectxt = "<" + Trim$(STR$(recs(i).rec)) + ">"
  Else
    rectxt = STR(recs(i).rec)
  End If
  If Len(recs(i).dev) > 0 Then
    addtext = "[" + rectxt + "] " + recs(i).srv + "/" + recs(i).dev + " : " + recs(i).prp
  Else
    addtext = "[" + rectxt + "] " + recs(i).srv + " : " + recs(i).prp
  End If
  dbList.AddItem addtext
Next
paramsStale = False

If isGlobalsServer Then
Dim n64(99) As NAME64
retryGlbAcq:
  dbin.dFormat = CF_NULL
  dbout.dArrayLength = 100: dbout.dFormat = CF_NAME64
  rc = T_EXECLINK(DevName, "GLOBALS", dbout, n64(0).nam(0), dbin, 0, CA_READ + CA_RETRY, 3000)
  If rc Then
    rc = MsgBox("Unable to acquire globals information from " + DevName + "!" + vbNewLine + RPCERROR(rc), vbRetryCancel)
    If rc = vbRetry Then GoTo retryGlbAcq
    Exit Sub
  End If
  nGlbKeywords = dbout.dArrayLength
  For i = 0 To nGlbKeywords - 1
    glbKeywords(i) = BSTR(n64(i).nam)
    'Debug.Print glbKeywords(i)
  Next
End If
End Sub

Private Sub ArraySizeText_Change()
editPreviousEntry = False
End Sub

Private Sub attachServer_Click()
attachServer.Checked = Not attachServer.Checked
useFileSystem.Checked = Not attachServer.Checked
isUsingFileSystem = useFileSystem.Checked
SetBrowsingCombos
End Sub

Private Sub bindToOption_Click()
  bindToText.Enabled = bindToOption.Value
  bindToText.text = ""
End Sub

Private Sub bindToOption_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
bindToOption.ToolTipText = "When this keyword entry is archived also archive the entered keyword"

End Sub


Private Sub bindToText_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If bindToOption.Enabled = False Then Exit Sub
bindToText.ToolTipText = "This keyword entry should be archived whenever the entered keyword is archived"
End Sub


Private Sub cloneCmd_Click()
Dim s As String, a As String, pat1 As String, pat2 As String
Dim keyprts() As String
Dim i As Integer, dif As Integer, sz As Integer

i = dbList.ListIndex
If i < 0 Then
  MsgBox "Please select a record to clone !"
  Exit Sub
End If

CloneDialog.serverText.text = DeviceServerList.text
CloneDialog.Label2.Caption = "In keyword " + keywordText.text + " and others replace :"
CloneDialog.Show 1
s = CloneDialog.serverText.text
If Len(s) = 0 Then Exit Sub
's = InputBox("New Server Name: ", "Clone Record for different Server", DeviceServerList.text)
If s = DeviceServerList.text Then Exit Sub
DeviceServerList.text = s
editPreviousEntry = False

pat1 = CloneDialog.keywordText.text
pat2 = CloneDialog.repText.text

dif = recs(i).len - Val(ArraySizeText.text)

On Error Resume Next
For i = 0 To DataOutputList.ListCount - 1
  a$ = DataOutputList.List(i%)
  s = getcol(a$, 0)
  keyprts = Split(s, pat1)
  keywordText.text = keyprts(0) + pat2 + keyprts(1)
'  keywordText.text = getcol(a$, 0)
  FormatCombo.text = getcol(a$, 1)
  sz = Val(getcol(a$, 2))
  If i = 0 Then sz = sz - dif
  SizeText.text = STR(sz)
  UnitsText.text = getcol(a$, 3)
  MaxText.text = getcol(a$, 4)
  MinText.text = getcol(a$, 5)
  ToleranceText.text = getcol(a$, 6)
  PlotCombo.text = getcol(a$, 7)
  ScaleText.text = getcol(a$, 8)
  OffsetText.text = getcol(a$, 9)
  descriptionText.text = GetValidDescription(getcol(a$, 10))
  devLstText.text = getcol(a$, 11)
  bindToText.text = getcol(a$, 12)
  SubSystemCombo.text = getcol(a$, 13)
  If Val(SizeText.text) > 1 Then
    devLstOption.Enabled = True
    devLstOption.Value = IIf(Len(devLstText.text) > 0, 1, 0)
  Else
    devLstOption.Enabled = False
    devLstText.text = ""
  End If
  bindToOption.Value = IIf(Len(bindToText.text) > 0, 1, 0)
  
  'keywordText.text = s + "-key"   'getcol(oldItem, 0)
  s$ = GetOutputListString()
  DataOutputList.List(i) = s$
Next
End Sub

Private Sub DataCallFormat_Click()
editPreviousEntry = False
End Sub

Private Sub DataOutputList_Click()
Dim a$, i%
    
i% = DataOutputList.ListIndex
If i% < 0 Then Exit Sub

a$ = DataOutputList.List(i%)
On Error GoTo DataOutputList_clickError
keywordText.text = getcol(a$, 0)
FormatCombo.text = getcol(a$, 1)
SizeText.text = getcol(a$, 2)
UnitsText.text = getcol(a$, 3)
MaxText.text = getcol(a$, 4)
MinText.text = getcol(a$, 5)
ToleranceText.text = getcol(a$, 6)
PlotCombo.text = getcol(a$, 7)
ScaleText.text = getcol(a$, 8)
OffsetText.text = getcol(a$, 9)
descriptionText.text = GetValidDescription(getcol(a$, 10))
devLstText.text = getcol(a$, 11)
bindToText.text = getcol(a$, 12)
SubSystemCombo.text = getcol(a$, 13)
If Val(SizeText.text) > 1 Then
  devLstOption.Enabled = True
  devLstOption.Value = IIf(Len(devLstText.text) > 0, 1, 0)
Else
  devLstOption.Enabled = False
  devLstText.text = ""
End If
bindToOption.Value = IIf(Len(bindToText.text) > 0, 1, 0)

If isGlobalsServer Then
  globalsCheck.Value = 0
  For i = 0 To nGlbKeywords - 1
    If glbKeywords(i) = keywordText.text Then
      globalsCheck.Value = 1
      Exit For
    End If
  Next
End If
Exit Sub
DataOutputList_clickError:
Resume Next
End Sub
Sub pushInputFileToList(ifn As String)
Dim dat_col As Integer
Dim s$
DataInputText.text = ""

If Len(ifn) = 0 Or Len(Dir$(dbPath$ + "input\" + ifn)) = 0 Then
  Exit Sub
End If
Open dbPath$ + "input\" + ifn For Input Access Read Shared As #1
s$ = ""
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If Len(a$) > 0 And tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not done Then
      dat_col = colptr(a$, "data")
      done = True
    Else
      subs$ = getcol(a$, dat_col)
      s$ = s$ + subs$ + " "
    End If
  End If
Loop While Not EOF(1)
DataInputText.text = s$
pushInputFileToListError:
Close 1
End Sub
Sub pushStructureFileToList(sfn As String)
Dim key_col As Integer, fmt_col As Integer, siz_col As Integer, uni_col As Integer, max_col As Integer
Dim min_col As Integer, tol_col As Integer, plt_col As Integer, cmt_col As Integer
Dim off_col As Integer, sca_col As Integer, dev_col As Integer, bnd_col As Integer
Dim sub_col As Integer
Dim ln$
DataOutputList.Clear
On Error GoTo pushStructureFileToListError
Open dbPath$ + "info\" + sfn For Input Access Read Shared As #1
ln$ = ""
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If Len(a$) > 0 And tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not done Then
      key_col = colptr(a$, "keyword")
      fmt_col = colptr(a$, "Format")
      siz_col = colptr(a$, "size")
      uni_col = colptr(a$, "Units")
      max_col = colptr(a$, "Maximum")
      min_col = colptr(a$, "Minimum")
      tol_col = colptr(a$, "Tolerance")
      plt_col = colptr(a$, "Plot")
      sca_col = colptr(a$, "Scale")
      off_col = colptr(a$, "Offset")
      cmt_col = colptr(a$, "Description")
      If cmt_col < 0 Then cmt_col = colptr(a$, "comment")
      dev_col = colptr(a$, "devices")
      bnd_col = colptr(a$, "bind")
      sub_col = colptr(a$, "subsystem")
      done = True
    Else
      subs$ = getcol(a$, key_col)
      keywordText.text = subs$
      ln$ = ln$ + subs$ + ","
      subs$ = getcol(a$, fmt_col)
      FormatCombo.text = subs$
      ln$ = ln$ + subs$ + ","
      subs$ = getcol(a$, siz_col)
      SizeText.text = subs$
      ln$ = ln$ + subs$ + ","
      subs$ = getcol(a$, uni_col)
      UnitsText.text = subs$
      ln$ = ln$ + subs$ + ","
      subs$ = getcol(a$, max_col)
      MaxText.text = subs$
      ln$ = ln$ + subs$ + ","
      subs$ = getcol(a$, min_col)
      MinText.text = subs$
      ln$ = ln$ + subs$ + ","
      subs$ = getcol(a$, tol_col)
      ToleranceText.text = subs$
      ln$ = ln$ + subs$ + ","
      subs$ = getcol(a$, plt_col)
      PlotCombo.text = subs$
      ln$ = ln$ + subs$ + ","
      If sca_col >= 0 Then
        subs$ = getcol(a$, sca_col)
      Else
        subs$ = "1"
      End If
      ScaleText.text = subs$
      ln$ = ln$ + subs$ + ","
      If off_col >= 0 Then
        subs$ = getcol(a$, off_col)
      Else
        subs$ = "0"
      End If
      OffsetText.text = subs$
      ln$ = ln$ + subs$ + ","
      subs$ = getcol(a$, cmt_col)
      descriptionText.text = GetValidDescription(subs$)
      ln$ = ln$ + subs$
      If dev_col >= 0 Then
        devLstOption.Enabled = True
        devLstOption.Value = 1
        subs$ = getcol(a$, dev_col)
        devLstText.text = subs
      Else
        devLstOption.Enabled = False
        devLstOption.Value = 0
        devLstText.text = ""
        subs$ = ""
      End If
      ln$ = ln$ + "," + subs$
      If bnd_col >= 0 Then
        bindToOption.Value = 1
        subs$ = getcol(a$, bnd_col)
        bindToText.text = subs
      Else
        bindToOption.Value = 0
        subs$ = ""
      End If
      ln$ = ln$ + "," + subs$
      If sub_col >= 0 Then
        subs$ = getcol(a$, sub_col)
        If (Len(subs$) > 0) And subs$ <> "Dummy" Then
          SubSystemCombo.text = subs$
        Else
          SubSystemCombo.text = "Diagnostics"
          subs$ = ""
        End If
      Else
        SubSystemCombo.text = "Diagnostics"
        subs$ = ""
      End If
      ln$ = ln$ + "," + subs$
      DataOutputList.AddItem ln$
      ln$ = ""
    End If
  End If
Loop While Not EOF(1)
pushStructureFileToListError:
Close 1

End Sub
Sub pushKeyInfoToList(sfn As String)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim DevName As String, tmp As String
Dim rc As Integer, i As Integer
Dim inf(100) As DAQPrmInfo

retryAcq:
dbout.dArrayLength = 100: dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "DAQPrm"
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
DevName = "/" + ArchiveServerCombo.text + "/" + dbServer + "/" + sfn

rc = T_EXECLINK(DevName, "KEYWORD.INFO", dbout, inf(0), dbin, 0, CA_READ + CA_RETRY, 1000)
If rc <> 0 Then
  rc = MsgBox("Cannot acquire keyword information from " + DevName + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retryAcq
  Exit Sub
End If
n = dbout.dArrayLength

Dim ln$
DataOutputList.Clear
For i = 0 To n - 1
  ln$ = ""
  keywordText.text = BSTR(inf(i).key)
  ln$ = ln$ + keywordText.text + ","
  FormatCombo.text = tine.GetFormatAsString(inf(i).fmt)
  ln$ = ln$ + FormatCombo.text + ","
  SizeText.text = STR$(inf(i).size)
  ln$ = ln$ + SizeText.text + ","
  UnitsText.text = BSTR(inf(i).units)
  ln$ = ln$ + UnitsText.text + ","
  MaxText.text = STR$(inf(i).maximum)
  ln$ = ln$ + MaxText.text + ","
  MinText.text = STR$(inf(i).minimum)
  ln$ = ln$ + MinText.text + ","
  ToleranceText.text = GetToleranceAsString(inf(i).aTolerance, inf(i).pTolerance)
  ln$ = ln$ + ToleranceText.text + ","
  PlotCombo.text = BSTR(inf(i).plot)
  ln$ = ln$ + PlotCombo.text + ","
  ScaleText.text = STR$(inf(i).scaleFactor)
  ln$ = ln$ + ScaleText.text + ","
  OffsetText.text = STR$(inf(i).scaleOffset)
  ln$ = ln$ + OffsetText.text + ","
  descriptionText.text = GetValidDescription(BSTR$(inf(i).desc))
  ln$ = ln$ + descriptionText.text + ","
  tmp = BSTR$(inf(i).assoc)
  If Len(tmp) = 0 Then
    devLstOption.Enabled = False
    devLstOption.Value = 0
  Else
    devLstOption.Value = 1
    devLstOption.Enabled = True
  End If
  devLstText.text = BSTR$(inf(i).assoc)
  ln$ = ln$ + devLstText.text + ","
  tmp = BSTR(inf(i).boundTo)
  If Len(tmp) = 0 Then
    bindToOption.Value = 0
  Else
    bindToOption.Value = 1
  End If
  bindToText.text = tmp
  ln$ = ln$ + bindToText.text + ","
  tmp = BSTR$(inf(i).subs)
  If Len(tmp) = 0 Then tmp = "Diagnostics"
  SubSystemCombo.text = tmp
  ln$ = ln$ + SubSystemCombo.text
  DataOutputList.AddItem ln$
Next

End Sub
Private Sub dbFileText_Change()
Dim result
On Error GoTo dbFileTextErr
If databaseHasChanged Then
  result = MsgBox("Do you want to save your changes?", vbYesNo, "Select new Database")
  If result = vbYes Then Call WriteDataBaseButton_Click
End If
dbPath$ = dbPathCombo.text
If Right$(dbPath$, 1) <> "\" Then dbPath$ = dbPath$ + "\"
dbFile$ = dbPath$ + dbFileText.text
If LCase(Right$(dbFile$, 4)) <> ".csv" Then dbFile$ = dbFile$ + ".csv"

If Len(Dir$(dbFile$)) > 0 Then
  initDatabase
ElseIf dbList.ListCount > 0 Then
  initDatabase
End If
dbFileTextErr:
Exit Sub
End Sub

Private Sub dbList_Click()
Dim i As Integer
Dim fltr As String
i = dbList.ListIndex
If i < 0 Then Exit Sub
If Len(recs(i).con) > 0 Then
  DeviceContextList.text = recs(i).con
End If
DeviceServerList.text = recs(i).srv
DeviceNameList.text = recs(i).dev
DevicePropertyList.text = recs(i).prp
ArraySizeText.text = STR$(recs(i).len)
DataCallFormat.text = recs(i).fmt
AccessRateText.text = STR(recs(i).tmr)
fltr = recs(i).ftr
For i = 0 To sizFilterTable - 1 Step 1
  OptionCheck(i).Value = 0
  If InStr(fltr$, filterTable(i)) > 0 Then
    OptionCheck(i).Value = 1
  End If
Next
DataOutputList.Clear
If isGlobalsServer Then globalsCheck.Value = 0
i = dbList.ListIndex
If isUsingFileSystem Then
  pushStructureFileToList recs(i).fn_key
  pushInputFileToList recs(i).fn_inp
Else
  pushKeyInfoToList recs(i).fn_key
  If Len(recs(i).fn_inp) > 0 Then pushKeyInptToList recs(i).fn_inp
End If
paramsFilled = True
editPreviousEntry = True: touchDeviceServer = False
editOption(0).Value = True
End Sub

Private Sub dbList_DblClick()
Dim i As Integer
If dbList.ListCount > 0 Then
  i = dbList.ListIndex
  If recs(i).active <> 0 Then
    rslt = MsgBox("Disable Entry : " + dbList.List(i), vbOKCancel, "Disable Database entry")
    If rslt = vbCancel Then Exit Sub
    databaseHasChanged = True
    recs(i).stale = True
    recs(i).active = 0
    'dbList.RemoveItem (i)
    'If dbList.ListCount > 0 Then dbList.ListIndex = 0
    If recs(i).active = 0 Then rectxt = " X "
  Else
    rslt = MsgBox("Enable Entry : " + dbList.List(i) + " (Yes = active, No = inactive but visible)", vbYesNoCancel, "Enable Database entry")
    If rslt = vbCancel Then Exit Sub
    databaseHasChanged = True
    recs(i).stale = True
    If rslt = vbYes Then
      recs(i).active = 1
      rectxt = STR$(recs(i).rec)
    Else
      recs(i).active = -1
      rectxt = "<" + Trim$(STR$(recs(i).rec)) + ">"
    End If
  End If
  numStaleDbRecords = numStaleDbRecords + 1
  Call checkStaleThreshold
  If Len(recs(i).dev) > 0 Then
    addtext$ = "[" + rectxt + "] " + recs(i).srv + "/" + recs(i).dev + " : " + recs(i).prp
  Else
    addtext$ = "[" + rectxt + "] " + recs(i).srv + " : " + recs(i).prp
  End If
  dbList.List(i) = addtext$
  databaseHasChanged = True
End If

End Sub

Private Sub dbPathText_Change()
dbPath$ = dbPathText.text
If Right$(dbPath$, 1) <> "\" Then dbPath$ = dbPath$ + "\"
dbFile$ = dbPath$ + dbFileText.text
If LCase(Right$(dbFile$, 4)) <> ".csv" Then dbFile$ = dbFile$ + ".csv"

If Len(Dir$(dbFile$)) > 0 Then
  initDatabase
End If

End Sub

Private Sub dbList_KeyDown(KeyCode As Integer, Shift As Integer)
  If KeyCode = vbKeyF3 Then
    Call findNextItemInDb
  End If
End Sub

Private Sub dbPathCombo_Change()
Dim i As Integer
On Error GoTo dbPathComboErr
dbPath$ = dbPathCombo.text
If dbPathCombo.ListIndex >= 0 Then
  dbFileText.text = Trim$(dbFileList(dbPathCombo.ListIndex))
End If
If Right$(dbPath$, 1) <> "\" Then dbPath$ = dbPath$ + "\"
dbFile$ = dbPath$ + dbFileText.text
If LCase(Right$(dbFile$, 4)) <> ".csv" Then dbFile$ = dbFile$ + ".csv"

For i = 0 To DeviceContextList.ListCount - 1
  If InStr(1, dbFile$, DeviceContextList.List(i), vbTextCompare) > 0 Then
    gContext = DeviceContextList.List(i)
    DeviceContextList.text = gContext
    DeviceContextList.ListIndex = i
    Exit For
  End If
Next

If Len(Dir$(dbFile$)) > 0 Then
  initDatabase
ElseIf dbList.ListCount > 0 Then
  initDatabase
End If
dbPathComboErr:
Exit Sub
End Sub

Private Sub dbPathCombo_Click()
Call dbPathCombo_Change
End Sub
Private Sub DeviceContextList_Change()
If editOption(0).Value Then Exit Sub
If lastDeviceContextListSelection <> DeviceContextList.text Then
  Call DeviceContextList_Click
End If
DeviceAndPropertySelected = False
paramsFilled = False
End Sub

Private Sub DeviceContextList_Click()
rc% = GetEquipmentDeviceServers(DeviceContextList.text, "", ds(), nds)
If rc% Then Exit Sub
DeviceServerList.Clear
For i = 0 To nds - 1
  DeviceServerList.AddItem ds(i)
Next
DeviceServerList.ListIndex = 0
lastDeviceContextListSelection = DeviceContextList.text
End Sub

Private Sub DeviceNameList_Change()
If editOption(0).Value Then Exit Sub
DeviceNameList_Click
If editOption(0).Value Then Exit Sub
DeviceAndPropertySelected = False
paramsFilled = False
End Sub

Private Sub DeviceNameList_Click()
Dim devnam As String, n As Integer

If prpsQueryPrecedence And prpsQueried Then Exit Sub
If Left$(DeviceNameList.text, 1) = "*" Then
  Exit Sub
End If
DevicePropertyList.Clear
If Left$(DeviceNameList.text, 1) = "#" Then
  devnam = "/" & DeviceContextList.text & "/" & DeviceServerList.text & "/#0"
Else
  devnam = "/" & DeviceContextList.text & "/" & DeviceServerList.text & "/" & DeviceNameList.text
End If

'UseSimplePropFlag = True
If UseSimplePropFlag Then
    ' Just get list of NAMES - if the number of properties is too large! (>150)
    ' Get the Prop-Info in the click-event!
    rc% = GetEquipmentDeviceProperties(devnam, prp, nprp)
    If rc% = 0 Then
        ReDim Properties(nprp): ReDim prpSiz(nprp): ReDim prpTyp(nprp)
        ReDim prpDsc(nprp)
        ReDim prpMax(nprp): ReDim prpMin(nprp)
        ReDim prpUnits(nprp)
    End If
Else
    rc% = GetEquipmentDevicePropertyInformationExt(devnam, prp(), prpSiz(), prpTyp(), prpDsc(), prpMax(), prpMin(), prpUnits(), nprp)
End If
If rc% Then
    n = 200
    ReDim prp(n)
    ReDim Properties(n): ReDim prpSiz(n): ReDim prpTyp(n)
    ReDim prpDsc(n)
    ReDim prpMax(n): ReDim prpMin(n)
    ReDim prpUnits(n)
    
    Exit Sub
End If

prpsQueried = True
For i = 0 To nprp - 1
  DevicePropertyList.AddItem prp(i)
Next
If nprp > 0 Then
  DevicePropertyList.ListIndex = 0
End If
editPreviousEntry = False
End Sub
Function prpTypStr(ByVal fmt As Integer) As String
'fmt = fmt + CF_DOUBLE
Select Case fmt
  Case CF_DOUBLE: s$ = "double"
  Case CF_SHORT: s$ = "short"
  Case CF_BYTE: s$ = "BYTE"
  Case CF_LONG: s$ = "long"
  Case CF_TEXT: s$ = "char"
  Case CF_FLOAT: s$ = "float"
  Case CF_STRUCT: s$ = "struct"
  Case CF_NAME8: s$ = "NAME8"
  Case CF_NAME16: s$ = "NAME16"
  Case CF_CHAR16FI: s$ = "NAME16FI"
  Case CF_NAME32: s$ = "NAME32"
  Case CF_NAME48: s$ = "NAME48"
  Case CF_NAME64: s$ = "NAME64"
  Case CF_FLTINT: s$ = "FLTINT"
  Case CF_LNGINT: s$ = "LNGINT"
  Case CF_DBLINT: s$ = "DBLINT"
  Case CF_TDS: s$ = "TDS"
  Case CF_NAME8I: s$ = "NAME8I"
  Case CF_NAME16I: s$ = "NAME16I"
  Case CF_NAME32I: s$ = "NAME32I"
  Case CF_NAME48I: s$ = "NAME48I"
  Case CF_NAME64I: s$ = "NAME64I"
  Case CF_USTRING: s$ = "USTRING"
  Case CF_FLTFLTINT: s$ = "FLTFLTINT"
  Case CF_FILTER: s$ = "DFILTER"
  Case CF_INTFLTFLTFLT: s$ = "IFFF"
  Case CF_SPECTRUM: s$ = "DSPECTRUM"
  Case CF_ADDRESS: s$ = "DADDRESS"
  Case CF_WINDOW: s$ = "DWINDOW"
  Case CF_POINT: s$ = "DPOINT"
  Case CF_NAME64DBLDBL: s$ = "NAME64DBLDBL"
  Case Else: s$ = "BYTE"
End Select
prpTypStr = s$
End Function
Function getPropertyIndex(listProperty As String) As Integer
Dim i As Integer
For i = 0 To DevicePropertyList.ListCount - 1
  If prp(i) = listProperty Then Exit For
Next
getPropertyIndex = i
End Function
Function FmtSizeOf(DataFormat As String) As Integer
Select Case UCase(DataFormat)
  Case "DOUBLE": FmtSizeOf = 8
  Case "SHORT", "INT16", "INT": FmtSizeOf = 2
  Case "BYTE", "INT8": FmtSizeOf = 1
  Case "LONG", "INT32": FmtSizeOf = 4
  Case "CHAR", "TEXT": FmtSizeOf = 1
  Case "FLOAT": FmtSizeOf = 4
  Case "STRUCT": FmtSizeOf = 1
  Case "NAME8", "CHAR8": FmtSizeOf = 8
  Case "NAME8I", "CHAR8I": FmtSizeOf = 12
  Case "NAME16", "CHAR16": FmtSizeOf = 16
  Case "NAME16I", "CHAR16I": FmtSizeOf = 20
  Case "NAME16FI", "CHAR16FI", "NAMEFI", "CHARFI": FmtSizeOf = 24
  Case "NAME32", "CHAR32": FmtSizeOf = 32
  Case "NAME32I", "CHAR32I": FmtSizeOf = 36
  Case "NAME48", "CHAR48": FmtSizeOf = 48
  Case "NAME64", "CHAR64": FmtSizeOf = 64
  Case "NAME64I", "CHAR64I": FmtSizeOf = 68
  Case "FLTINT": FmtSizeOf = 8
  Case "LNGINT": FmtSizeOf = 8
  Case "DBLDBL": FmtSizeOf = 16
  Case "TDS": FmtSizeOf = 12
  Case "NAME8I", "CHAR8I": FmtSizeOf = 12
  Case "NAME16I", "CHAR16I": FmtSizeOf = 20
  Case "NAME16I", "CHAR16I": FmtSizeOf = 36
  Case "NAME48I", "CHAR48I": FmtSizeOf = 52
  Case "DUSTRING", "USTRING": FmtSizeOf = 8
  Case "FLTFLTINT": FmtSizeOf = 12
  Case "DFILTER": FmtSizeOf = 8
  Case "IFFF": FmtSizeOf = 16
  Case "DSPECTRUM": FmtSizeOf = 4
  Case "DADDRESS": FmtSizeOf = 16
  Case "DWINDOW": FmtSizeOf = 8
  Case "DPOINT": FmtSizeOf = 8
  Case "NAME64DBLDBL": FmtSizeOf = 80
End Select
End Function
Function bytesFromParam(ln As String) As Long
Dim fmt As String, siz As String
Dim s As String
Dim p As Integer
p = InStr(ln, ",")
s = Right$(ln, Len(ln) - p)
p = InStr(s, ",")
fmt = Left$(s, p - 1)
s = Right$(s, Len(s) - p)
p = InStr(s, ",")
siz = Left$(s, p - 1)
bytesFromParam = Val(siz) * FmtSizeOf(fmt)
End Function
Function suggestNextSize() As Long
Dim bytesAccountedFor As Long
Dim bytesNeeded As Long
Dim fmtSize As Long
If DataOutputList.ListCount = 0 Then
  suggestNextSize = Val(ArraySizeText.text)
  Exit Function
End If
fmtSize = FmtSizeOf(DataCallFormat.text)
bytesNeeded = Val(ArraySizeText.text) * fmtSize
For i = 0 To DataOutputList.ListCount - 1
  bytesAccountedFor = bytesAccountedFor + bytesFromParam(DataOutputList.List(i))
Next
suggestNextSize = (bytesNeeded - bytesAccountedFor) / fmtSize
End Function
Sub fillInSubParams()
Dim nxtsiz As Integer, i As Integer
On Error GoTo FillError
i = nrecs - 1
nxtsiz = suggestNextSize()
If nxtsiz <= 0 Then
  keywordText.text = ""
  SizeText.text = ""
  FormatCombo.text = DataCallFormat.text
  UnitsText.text = "none"
  MaxText.text = "0"
  MinText.text = "0"
  ToleranceText.text = "0"
  PlotCombo.ListIndex = 0
  SubSystemCombo.ListIndex = 0
  ScaleText.text = "1"
  OffsetText.text = "0"
  descriptionText.text = ""
'  Call AppendDatabase.SetFocus
  paramsFilled = True
Exit Sub
End If
' structure parameters suggestion:
Dim keytxt As String
keytxt = Trim$(DeviceServerList.text) + "." + Trim$(DevicePropertyList.text)
If DataOutputList.ListCount > 0 Then
  keytxt = keytxt + Trim$(STR$(DataOutputList.ListCount))
End If

keywordText.text = keytxt
SizeText.text = STR$(nxtsiz)
FormatCombo.text = DataCallFormat.text
If Len(prpUnits(prpIndex)) = 0 Then
  Dim DevName As String
  DevName = "/" + DeviceContextList.text + "/" + DeviceServerList.text + "/" + DeviceNameList.text
  GetEquipmentEGU DevName, prp(prpIndex), prpMin(prpIndex), prpMax(prpIndex), prpUnits(prpIndex)
  If Len(prpUnits(prpIndex)) = 0 Then prpUnits(prpIndex) = "none"
End If
If Not DeviceAndPropertySelected Then
  UnitsText.text = prpUnits(prpIndex)
  If Len(UnitsText.text) = 0 Then UnitsText.text = "none"
  If prpMax(prpIndex) = 0 And prpMin(prpIndex) = 0 Then
    MaxText.text = "100"
    MinText.text = "0"
  Else
    MaxText.text = STR$(prpMax(prpIndex))  '"100"
    MinText.text = STR$(prpMin(prpIndex)) '"0"
  End If
  ToleranceText.text = "1"
  PlotCombo.ListIndex = 0
  SubSystemCombo.ListIndex = 0
  descriptionText.text = GetValidDescription(prpDsc(prpIndex)) 'DevicePropertyList.text + " from " + DeviceServerList.text
End If
If devLstText.Enabled Then
  devLstText.text = ""
  devLstText.Enabled = False
  devLstOption.Value = False
End If
If bindToText.Enabled Then
  bindToText.text = ""
  bindToText.Enabled = False
  bindToOption.Value = 0
End If
Exit Sub

FillError:

MsgBox "Error in fillInSubParams: " + Err.Description
Exit Sub
End Sub

Private Sub DevicePropertyList_Change()
Dim tmpDev$, tmpProp$, tmpIndex%, tmpQuery As PropertyQueryEx 'PrpQuery 'PropertyQueryEx
If editOption(0).Value Then
  Exit Sub
End If
If UseSimplePropFlag = True Then
    ' Need to get the INFO
    Debug.Print
    'Function GetPropertyInformationEx(DevName As String, property As String, prp As PropertyQueryEx) As Integer
    tmpDev$ = DeviceNameList.text
    tmpProp$ = DevicePropertyList.text
    rc% = GetPropertyInformationEx(tmpDev$, tmpProp$, tmpQuery)
    ' Fill in array?
    tmpIndex% = DevicePropertyList.ListIndex

    prpSiz(tmpIndex%) = IIf(tmpQuery.prpSize < 32767, tmpQuery.prpSize, 32767)
    prpTyp(tmpIndex%) = tmpQuery.prpFormat + CF_DOUBLE
    prpDsc(tmpIndex%) = BSTR(tmpQuery.prpDesc)
    prpMax(tmpIndex%) = tmpQuery.prpMaxValue
    prpMin(tmpIndex%) = tmpQuery.prpMinValue
    prpUnits(tmpIndex%) = BSTR(tmpQuery.prpUnits)
    'rc% = GetEquipmentDevicePropertyInformationExt(devnam, prp(), prpSiz(), prpTyp(), prpDsc(), prpMax(), prpMin(), prpUnits(), nprp)

End If
AccessRateText.text = "1000"
DataOutputList.Clear
DataInputText.text = ""
paramsFilled = False
DeviceAndPropertySelected = False
fillInSubParams
End Sub

Private Sub DevicePropertyList_Click()
Dim i As Integer, rc As Integer
Dim dev As String
If prpsQueryPrecedence Then
  dev = "/" + DeviceContextList.text + "/" + DeviceServerList.text
  ndev = 0
  rc = GetEquipmentDeviceNamesFromProperty(dev, DevicePropertyList.text, dn(), ndev)
  DeviceNameList.Clear
  If rc = 0 Then
    For i = 0 To ndev - 1
      DeviceNameList.AddItem dn(i)
    Next
    If ndev > 0 Then DeviceNameList.ListIndex = 0
  End If
End If

If UseSimplePropFlag = True Then
    ' Need to get the INFO
End If

i = getPropertyIndex(DevicePropertyList.List(DevicePropertyList.ListIndex))
ArraySizeText.text = prpSiz(i)
DataCallFormat.text = prpTypStr(prpTyp(i))
prpIndex = i
DataOutputList.Clear
DataInputText.text = ""
paramsFilled = False
DeviceAndPropertySelected = False
editPreviousEntry = False
fillInSubParams
End Sub

Private Sub DeviceServerList_Change()
If editOption(0).Value Then Exit Sub
editPreviousEntry = False
DataOutputList.Clear
DataInputText.text = ""
DeviceAndPropertySelected = False
paramsFilled = False
End Sub

Private Sub DeviceServerList_Click()
Dim dev As String
Dim hqf As Boolean
DeviceNameList.Clear
dev = "/" + DeviceContextList.text + "/" + DeviceServerList.text
rc% = GetEquipmentDeviceNamesEx(dev, dn(), ndev, hqf)
prpsQueryPrecedence = hqf
devsQueryPrecedence = False
prpsQueried = False
If rc% Then Exit Sub
For i = 0 To ndev - 1
  DeviceNameList.AddItem dn(i)
Next
DeviceNameList.ListIndex = 0
editPreviousEntry = False
End Sub
Sub fillExistingDatabase()
Dim rec_col As Integer, nam_col As Integer, prp_col As Integer, dev_col As Integer
Dim len_col As Integer, fmt_col As Integer, inp_col As Integer, hbt_col As Integer
Dim rat_col As Integer, arc_col As Integer, stc_col As Integer, act_col As Integer
Dim con_col As Integer
Dim rectxt As String
If Len(Dir$(dbFile$)) = 0 Then Exit Sub
defaultContext = ""
Open dbFile$ For Input Access Read Shared As #1
i = 0
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not done Then
      rec_col = colptr(a$, "Record")
      If rec_col < 0 Then rec_col = colptr(a$, "Record Type")
      con_col = colptr(a$, "Context")
      nam_col = colptr(a$, "Server")
      If nam_col < 0 Then nam_col = colptr(a$, "Name")
      prp_col = colptr(a$, "Property")
      dev_col = colptr(a$, "Device")
      len_col = colptr(a$, "length")
      If len_col < 0 Then len_col = colptr(a$, "data length")
      fmt_col = colptr(a$, "Format")
      If fmt_col < 0 Then fmt_col = colptr(a$, "RPC Format")
      inp_col = colptr(a$, "input")
      If inp_col < 0 Then inp_col = colptr(a$, "data input")
      hbt_col = colptr(a$, "Heartbeat")
      rat_col = colptr(a$, "Poll")
      If rat_col < 0 Then rat_col = colptr(a$, "Polling Rate")
      arc_col = colptr(a$, "Filter")
      If arc_col < 0 Then arc_col = colptr(a$, "Archive")
      stc_col = colptr(a$, "Structure")
      act_col = colptr(a$, "Active")
      done = True
    Else
      recs(i).rec = Val(getcol(a$, rec_col))
      If con_col >= 0 Then recs(i).con = getcol(a$, con_col) Else recs(i).con = ""
      If Len(defaultContext) = 0 And Len(recs(i).con) > 0 Then defaultContext = recs(i).con
      recs(i).srv = getcol(a$, nam_col)
      recs(i).prp = getcol(a$, prp_col)
      recs(i).dev = getcol(a$, dev_col)
      recs(i).len = Val(getcol(a$, len_col))
      recs(i).fmt = getcol(a$, fmt_col)
      If inp_col >= 0 Then recs(i).fn_inp = getcol(a$, inp_col)
      recs(i).hbt = Val(getcol(a$, hbt_col))
      recs(i).tmr = Val(getcol(a$, rat_col))
      recs(i).ftr = getcol(a$, arc_col)
      recs(i).fn_key = getcol(a$, stc_col)
      recs(i).active = Val(getcol(a$, act_col))
      rectxt = STR$(recs(i).rec)
      If recs(i).active = 0 Then rectxt = " X "
      If recs(i).active < 0 Then rectxt = "<" + Trim$(STR$(recs(i).rec)) + ">"
      If Len(recs(i).dev) > 0 Then
        addtext$ = "[" + rectxt + "] " + recs(i).srv + "/" + recs(i).dev + " : " + recs(i).prp
      Else
        addtext$ = "[" + rectxt + "] " + recs(i).srv + " : " + recs(i).prp
      End If
      dbList.AddItem addtext$
      i = i + 1
    End If
  End If
Loop While Not EOF(1)
fillExistingDatabaseError:
Close 1
nrecs = i
End Sub
Sub initDatabase()
nrecs = 0
dbList.Clear
fillExistingDatabase
nfixedrecs = nrecs
If nrecs > 0 Then
  curRecNo% = recs(nrecs - 1).rec + 1
Else
  curRecNo% = 1
End If
nxtRecNo% = curRecNo%
updateFilterOptions
End Sub
Private Sub devlstOption_Click()
devLstOption.ToolTipText = "This multi-Channel Keyword should associate the names from the entry (.NAM) given"
devLstText.Enabled = devLstOption.Value
devLstText.text = ""
End Sub

Private Sub devLstText_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If devLstOption.Enabled = False Then Exit Sub
devLstText.ToolTipText = "This multi-Channel Keyword should associate the names from the entry (.NAM) given"
End Sub


Private Sub filterTableOpt_Click()
FilterTableForm.Show 1
End Sub

Private Sub Form_Load()
On Error GoTo archiveMgrErr

UseSimplePropFlag = False

dbServer = "HISTORY"
If Command$ = "GLOBALS" Then
  isGlobalsServer = True
  dbServer = "GLOBALS"
  FilterFrame.Visible = False
  opts.Enabled = False
  configOpts.Enabled = False
  Me.Caption = "Globals Database Manager"
  devLstOption.Visible = False
  devLstText.Visible = False
  bindToOption.Visible = False
  bindToText.Visible = False
  globalsCheck.Visible = True
  tgtArchive.Checked = False
  tgtGlobals.Checked = True
End If

AddParam.ToolTipText = "add current parameter settings to the record structure"
RemoveParam.ToolTipText = "remove current parameter settings from the record structure"
AppendDatabase.ToolTipText = "add new/modified record structure to the selected database (left panel)"
WriteDataBaseButton.ToolTipText = "update and reload all database changes remotely"

registerStructs
loadFilterOptions
loadFormatCombos
DeviceServerList.Clear
ScaleText.text = "1"
OffsetText.text = "0"
DeviceContextList.Clear
loadDbPathInfo

rc% = GetEquipmentDeviceContexts(dc(), ndc)
If rc% Then Exit Sub
For i = 0 To ndc - 1
  DeviceContextList.AddItem dc(i)
Next

For i = 0 To DeviceContextList.ListCount - 1
  If InStr(1, dbFile$, DeviceContextList.List(i), vbTextCompare) > 0 Then
    gContext = DeviceContextList.List(i)
    DeviceContextList.text = gContext
    DeviceContextList.ListIndex = i
    Exit For
  End If
Next
If DeviceContextList.ListIndex < 0 Then DeviceContextList.ListIndex = 0

GetArchiveServerContexts dbServer

SetBrowsingCombos

Exit Sub
archiveMgrErr:
Resume Next
End Sub
Function getFilterOption(ByVal fltrOpts As String) As String
Dim s$, tmp$
Dim p As Integer
Dim included As Boolean
For i = 0 To sizFilterTable - 1
  p = InStr(fltrOpts, filterTable(i))
  If p > 0 Then included = True Else included = False
  If OptionCheck(i).Value Then 'want it
    If Not included Then
      If Len(s$) > 0 Then s$ = s$ + "|"
      s$ = s$ + filterTable(i)
    End If
  Else ' don't want it
    If included Then
      tmp$ = Left(fltrOpts, p - 1) + Right(fltrOpts, Len(fltrOpts) - p + 1 - Len(filterTable(i)))
      If Right(tmp$, 1) = "|" Then tmp$ = Left(tmp$, Len(tmp$) - 1)
      fltrOpts = tmp$
    End If
  End If
Next
If Len(s$) > 0 And Len(fltrOpts) > 0 Then fltrOpts = fltrOpts + "|"
s$ = fltrOpts + s$
If Len(s$) = 0 Then s$ = "NEVER"
getFilterOption = s$
End Function
Function isInConfigFileList(fpath$, fname$) As Boolean
Dim i As Integer
Dim p1$, p2$
p2$ = Trim$(UCase$(fpath$))
If Right$(p2$, 1) <> "\" Then p2$ = p2$ + "\"
For i = 0 To nDbFiles - 1
  p1$ = Trim$(UCase$(dbPathList(i)))
  If Right$(p1$, 1) <> "\" Then p1$ = p1$ + "\"
  If p1$ = p2$ And dbFileList(i) = fname$ Then
    isInConfigFileList = True
    Exit Function
  End If
Next
isInConfigFileList = False
End Function
Sub writeDbPathInfo()
Dim a$, fn$, i%
fn$ = App.path + "\" + cfgfile$
Open fn$ For Output Access Write Shared As #1
a$ = "Path,File Name"
Print #1, a$
For i% = 0 To nDbFiles - 1
  a$ = dbPathList(i%) + "," + dbFileList(i%)
  Print #1, a$
Next
Close 1
End Sub
Sub loadDbPathInfo()
Dim done, a$, fn$
Dim path_col As Integer, name_col As Integer

On Error GoTo config_load_handler

fn$ = App.path + "\" + cfgfile$
Open fn$ For Input Access Read Shared As #1
i% = 0
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" Then
    If Not done Then
      path_col = colptr(a$, "Path")
      name_col = colptr(a$, "File Name")
      done = True
    Else
      dbPathList(i%) = getcol(a$, path_col)
      dbFileList(i%) = getcol(a$, name_col)
      i% = i% + 1
      If i% > 20 Then Exit Do
    End If
  End If
Loop While Not EOF(1)
nDbFiles = i%
Close 1

'dbPathList(0) = "S:\Servers\Hera\Hearchive\Database": dbFileList(0) = "datapktr"
'dbPathList(1) = "S:\Servers\Petra\Pearchive\Database": dbFileList(1) = "datapetr"
'dbPathList(2) = "S:\Servers\Desy\Desyarchive\Database": dbFileList(2) = "datadesy"
'dbPathList(3) = "S:\Servers\Ttf\Ttfarchive\Database": dbFileList(3) = "datattf"
'dbPathList(4) = "S:\Servers\Doris\Doarchive\Database": dbFileList(4) = "datadoris"
'nDbFiles = 5
dbPathCombo.Clear
For i = 0 To nDbFiles - 1
  dbPathCombo.AddItem dbPathList(i)
Next
dbPathCombo.ListIndex = 0
Exit Sub

config_load_handler:
nDbFiles = 0
Exit Sub
End Sub
Sub loadFormatCombos()
DataCallFormat.AddItem "double"
DataCallFormat.AddItem "INT16"
DataCallFormat.AddItem "BYTE"
DataCallFormat.AddItem "INT32"
DataCallFormat.AddItem "char"
DataCallFormat.AddItem "float"
DataCallFormat.AddItem "struct"
DataCallFormat.AddItem "NAME8"
DataCallFormat.AddItem "NAME16"
DataCallFormat.AddItem "NAME16FI"
DataCallFormat.AddItem "NAME32"
DataCallFormat.AddItem "NAME48"
DataCallFormat.AddItem "NAME64"
DataCallFormat.AddItem "FLTINT"
DataCallFormat.AddItem "LNGINT"
DataCallFormat.AddItem "TDS"
DataCallFormat.AddItem "NAME8I"
DataCallFormat.AddItem "NAME16I"
DataCallFormat.AddItem "NAME32I"
DataCallFormat.AddItem "NAME48I"
DataCallFormat.AddItem "NAME64I"
DataCallFormat.AddItem "USTRING"
DataCallFormat.AddItem "FLTFLTINT"
DataCallFormat.AddItem "FILTER"
DataCallFormat.AddItem "IFFF"
DataCallFormat.AddItem "SPECTRUM"
DataCallFormat.AddItem "ADDRESS"
DataCallFormat.AddItem "WINDOW"
DataCallFormat.AddItem "POINT"
DataCallFormat.AddItem "NAME64DBLDBL"
DataCallFormat.ListIndex = 0

FormatCombo.AddItem "double"
FormatCombo.AddItem "INT16"
FormatCombo.AddItem "BYTE"
FormatCombo.AddItem "INT32"
FormatCombo.AddItem "char"
FormatCombo.AddItem "float"
FormatCombo.AddItem "struct"
FormatCombo.AddItem "NAME8"
FormatCombo.AddItem "NAME16"
FormatCombo.AddItem "NAME16FI"
FormatCombo.AddItem "NAME32"
FormatCombo.AddItem "NAME48"
FormatCombo.AddItem "NAME64"
FormatCombo.AddItem "FLTINT"
FormatCombo.AddItem "LNGINT"
FormatCombo.AddItem "DBLINT"
FormatCombo.AddItem "TDS"
FormatCombo.AddItem "NAME8I"
FormatCombo.AddItem "NAME16I"
FormatCombo.AddItem "NAME32I"
FormatCombo.AddItem "NAME48I"
FormatCombo.AddItem "USTRING"
FormatCombo.AddItem "FLTFLTINT"
FormatCombo.AddItem "FILTER"
FormatCombo.AddItem "IFFF"
FormatCombo.AddItem "SPECTRUM"
FormatCombo.AddItem "ADDRESS"
FormatCombo.AddItem "WINDOW"
FormatCombo.AddItem "POINT"
FormatCombo.AddItem "NAME64DBLDBL"
FormatCombo.ListIndex = 0

PlotCombo.AddItem "LIN"
PlotCombo.AddItem "LOG"
PlotCombo.AddItem "SLOG"
PlotCombo.AddItem "TD"
PlotCombo.AddItem "BITS"
PlotCombo.ListIndex = 0

SubSystemCombo.AddItem "Diagnostics"
SubSystemCombo.AddItem "RF"
SubSystemCombo.AddItem "Magnets"
SubSystemCombo.AddItem "Quench Protection"
SubSystemCombo.AddItem "Vacuum"
SubSystemCombo.AddItem "Tunes/Feedback"
SubSystemCombo.AddItem "Injection"
SubSystemCombo.AddItem "Experiments"
SubSystemCombo.AddItem "Netmex"
SubSystemCombo.AddItem "Timing"
SubSystemCombo.AddItem "Services"
SubSystemCombo.AddItem "Subsystems"
SubSystemCombo.ListIndex = 0

infmtCombo.AddItem "BYTE"
infmtCombo.AddItem "INT16"
infmtCombo.AddItem "INT32"
infmtCombo.AddItem "FLOAT"
infmtCombo.AddItem "DOUBLE"
infmtCombo.AddItem "TEXT"
infmtCombo.AddItem "NAME16"
infmtCombo.AddItem "NAME32"
infmtCombo.AddItem "NAME64"
infmtCombo.ListIndex = 1

End Sub
Sub loadFilterOptions()
Dim i As Integer
If isGlobalsServer Then Exit Sub
filterOptions(0) = "NEVER"
filterOptions(1) = "BEAM"
filterOptions(2) = "RUNNING"
filterOptions(3) = "ALWAYS"
filterOptions(4) = "RUNNUM"
filterOptions(5) = "FAST"
filterOptions(6) = "LUMI"
filterOptions(7) = "ONCE"
filterOptions(8) = "GLOBAL"
filterOptions(9) = "RAMPING"
filterOptions(10) = "ELECTRONS"
filterOptions(11) = "PROTONS"
filterOptions(12) = "FASTRAMP"
filterOptions(13) = "INJECTION"
filterOptions(14) = "FASTINJ"
filterOptions(15) = "SLOW"
filterOptions(16) = "FIXTIME"

sizFilterTable = 17
For i = 0 To sizFilterTable - 1 Step 1
  filterTable(i) = filterOptions(i)
Next
NeverIndex = 0
AlwaysIndex = 3
OnceIndex = 7

End Sub

Private Sub Form_Unload(Cancel As Integer)
If databaseHasChanged Then
  result = MsgBox("Do you want to save your changes?", vbYesNo, "Select new Database")
  If result = vbYes Then Call WriteDataBaseButton_Click
End If
End Sub

Private Sub globalsCheck_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim i As Integer, slot As Integer
If DataOutputList.ListIndex < 0 Then Exit Sub
slot = -1
globalsCheck.Value = IIf(globalsCheck.Value = 0, 1, 0)
For i = 0 To nGlbKeywords - 1
  If slot < 0 And Len(glbKeywords(i)) = 0 Then slot = i
  If glbKeywords(i) = keywordText.text Then
    If globalsCheck.Value Then
      MsgBox "adding a globals that already in the list ?! -> debug this!"
    Else
      glbKeywords(i) = ""
    End If
    Exit Sub
  End If
Next
If slot < 0 Then
  slot = nGlbKeywords
  nGlbKeywords = nGlbKeywords + 1
End If

glbKeywords(slot) = keywordText.text


End Sub


Private Sub hstMap_Click()
hstFile$ = InputBox("History file Name (Full path)", "Input File Name")
fillExistingHistory
histToArc
End Sub

Private Sub mcaEditOpts_Click()
Shell App.path + "\cfgMgr.exe " + ArchiveServerCombo.text + " MCA", vbNormalFocus
End Sub

Private Sub OptionCheck_Click(Index As Integer)
Select Case Index
  Case NeverIndex: 'never
    If OptionCheck(NeverIndex).Value And OptionCheck(7).Value Then
      OptionCheck(OnceIndex).Value = False  'turn 'once' off
    End If
    If OptionCheck(NeverIndex).Value And OptionCheck(AlwaysIndex).Value Then
      OptionCheck(AlwaysIndex).Value = False  'turn 'always' off
    End If
  Case AlwaysIndex: 'Always
    If OptionCheck(AlwaysIndex).Value And OptionCheck(OnceIndex).Value Then
      OptionCheck(OnceIndex).Value = False  'turn 'once' off
    End If
    If OptionCheck(AlwaysIndex).Value And OptionCheck(NeverIndex).Value Then
      OptionCheck(NeverIndex).Value = False  'turn 'never' off
    End If
  Case OnceIndex: 'Once
    If OptionCheck(AlwaysIndex).Value And OptionCheck(OnceIndex).Value Then
      OptionCheck(AlwaysIndex).Value = False  'turn 'once' off
    End If
    If OptionCheck(NeverIndex).Value And OptionCheck(OnceIndex).Value Then
      OptionCheck(NeverIndex).Value = False  'turn 'never' off
    End If
End Select
End Sub



Private Sub OptionCheck_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
OptionCheck(Index).ToolTipText = filterTableTip(Index)

End Sub


Private Sub RemoveParam_Click()
If DataOutputList.ListCount > 0 And DataOutputList.ListIndex > -1 Then
  DataOutputList.RemoveItem (DataOutputList.ListIndex)
  If editPreviousEntry Then
    Call AppendDatabase_Click
  End If
  fillInSubParams
  paramsFilled = False
  DeviceAndPropertySelected = False
End If
End Sub

Private Sub resartCmd_Click()

End Sub

Private Sub searchDbList_Click()
dbListSearchString = InputBox("Please enter a search key (server or property):", "Database List Search", dbListSearchString)
If dbListSearchString = "" Then Exit Sub
Call findNextItemInDb
dbList.SetFocus
End Sub
Private Sub SizeText_Change()
  If Val(SizeText.text) > 1 Then
    devLstOption.Enabled = True
  Else
    devLstOption.Enabled = False
  End If
End Sub

Private Sub tgtArchive_Click()
  isGlobalsServer = False
  dbServer = "HISTORY"
  FilterFrame.Visible = True
  opts.Enabled = True
  configOpts.Enabled = True
  Me.Caption = "Archive Database Manager"
  devLstOption.Visible = True
  devLstText.Visible = True
  bindToOption.Visible = True
  bindToText.Visible = True
  globalsCheck.Visible = False
  tgtArchive.Checked = True
  tgtGlobals.Checked = False
  
  GetArchiveServerContexts dbServer
  SetBrowsingCombos
End Sub

Private Sub tgtGlobals_Click()
  isGlobalsServer = True
  dbServer = "GLOBALS"
  FilterFrame.Visible = False
  opts.Enabled = False
  configOpts.Enabled = False
  Me.Caption = "Globals Database Manager"
  devLstOption.Visible = False
  devLstText.Visible = False
  bindToOption.Visible = False
  bindToText.Visible = False
  globalsCheck.Visible = True
  tgtArchive.Checked = False
  tgtGlobals.Checked = True

  GetArchiveServerContexts dbServer
End Sub

Private Sub traceEditOpt_Click()
Shell App.path + "\cfgMgr.exe " + ArchiveServerCombo.text + " TRACE", vbNormalFocus

End Sub

Private Sub useFileSystem_Click()
useFileSystem.Checked = Not useFileSystem.Checked
attachServer.Checked = Not useFileSystem.Checked
isUsingFileSystem = useFileSystem.Checked
SetBrowsingCombos
End Sub

Private Sub WriteDataBaseButton_Click()
databaseHasChanged = False
If isUsingFileSystem Then
  writeDBFile
Else
  Dim mp
  mp = MousePointer
  MousePointer = MousePointerConstants.vbHourglass
  If updateDaqDatabase = 0 Or paramsStale Then
    ReLoadDaqDatabase
  End If
  MousePointer = mp
  paramsStale = False
End If
End Sub

Private Sub wsAutoProc_Error(ByVal number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)

End Sub


