VERSION 5.00
Begin VB.Form ArchiveDbForm 
   BackColor       =   &H00808000&
   Caption         =   "Event Archive Database Manager"
   ClientHeight    =   10245
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   14460
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   10245
   ScaleWidth      =   14460
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame9 
      Caption         =   "Action Items"
      ForeColor       =   &H8000000D&
      Height          =   3855
      Left            =   60
      TabIndex        =   7
      Top             =   6300
      Width           =   14295
      Begin VB.CheckBox ignoreDeviceCheck 
         Caption         =   "ignore stored device name"
         Height          =   315
         Left            =   120
         TabIndex        =   82
         Top             =   3360
         Width           =   2295
      End
      Begin VB.CheckBox AllDevicesCheckBox 
         Caption         =   "apply to ALL devices"
         Height          =   255
         Left            =   3000
         TabIndex        =   81
         Top             =   3000
         Width           =   1995
      End
      Begin VB.OptionButton persistentOption 
         Caption         =   "all"
         Height          =   255
         Index           =   1
         Left            =   3000
         TabIndex        =   79
         Top             =   2580
         Width           =   495
      End
      Begin VB.OptionButton persistentOption 
         Caption         =   "next"
         Height          =   255
         Index           =   0
         Left            =   2340
         TabIndex        =   78
         Top             =   2580
         Value           =   -1  'True
         Width           =   615
      End
      Begin VB.CommandButton AppendDatabase 
         Caption         =   "Add/Edit Step"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   435
         Left            =   3720
         TabIndex        =   59
         ToolTipText     =   "Add this step to the event action list"
         Top             =   3360
         Width           =   1515
      End
      Begin VB.CheckBox forwardCheck 
         Caption         =   "pipe output as input for next step"
         Height          =   315
         Left            =   120
         TabIndex        =   58
         ToolTipText     =   "Use the data as the input for the next step"
         Top             =   2940
         Width           =   2775
      End
      Begin VB.CheckBox setnumCheck 
         Caption         =   "pipe output as data size for"
         Height          =   255
         Left            =   120
         TabIndex        =   57
         ToolTipText     =   "Use the output of this step as the data size for the next step"
         Top             =   2580
         Width           =   2235
      End
      Begin VB.Frame Frame15 
         Caption         =   "Data Tag"
         Height          =   855
         Left            =   60
         TabIndex        =   27
         Top             =   1560
         Width           =   1215
         Begin VB.TextBox dataTagText 
            Height          =   345
            Left            =   60
            TabIndex        =   28
            ToolTipText     =   "Data Tag (for structures)"
            Top             =   420
            Width           =   1035
         End
      End
      Begin VB.Frame Frame11 
         Caption         =   "Device Context"
         Height          =   645
         Left            =   60
         TabIndex        =   24
         Top             =   240
         Width           =   1365
         Begin VB.ComboBox DeviceContextList 
            Height          =   315
            Left            =   30
            Sorted          =   -1  'True
            TabIndex        =   25
            Text            =   "DeviceContext"
            ToolTipText     =   "Targeted context"
            Top             =   210
            Width           =   1275
         End
      End
      Begin VB.Frame Frame1 
         Caption         =   "Device Server"
         Height          =   645
         Left            =   1440
         TabIndex        =   22
         Top             =   240
         Width           =   1845
         Begin VB.ComboBox DeviceServerList 
            Height          =   315
            Left            =   90
            Sorted          =   -1  'True
            TabIndex        =   23
            Text            =   "DeviceServerList"
            ToolTipText     =   "Targeted device server"
            Top             =   210
            Width           =   1695
         End
      End
      Begin VB.Frame Frame2 
         Caption         =   "Device Name"
         Height          =   645
         Left            =   3300
         TabIndex        =   20
         Top             =   240
         Width           =   1905
         Begin VB.ComboBox DeviceNameList 
            Height          =   315
            Left            =   90
            TabIndex        =   21
            ToolTipText     =   "Targeted device name"
            Top             =   210
            Width           =   1725
         End
      End
      Begin VB.Frame Frame3 
         Caption         =   "Device Property"
         Height          =   645
         Left            =   60
         TabIndex        =   18
         Top             =   900
         Width           =   2295
         Begin VB.ComboBox DevicePropertyList 
            Height          =   315
            Left            =   60
            Sorted          =   -1  'True
            TabIndex        =   19
            ToolTipText     =   "Targeted Property"
            Top             =   240
            Width           =   2145
         End
      End
      Begin VB.Frame Frame4 
         Caption         =   "Array Size"
         Height          =   645
         Left            =   2400
         TabIndex        =   16
         Top             =   900
         Width           =   1155
         Begin VB.TextBox ArraySizeText 
            Height          =   345
            Left            =   90
            TabIndex        =   17
            ToolTipText     =   "Data Size of call"
            Top             =   240
            Width           =   945
         End
      End
      Begin VB.Frame Frame5 
         Caption         =   "Format"
         Height          =   645
         Left            =   3600
         TabIndex        =   14
         Top             =   900
         Width           =   1605
         Begin VB.ComboBox DataCallFormat 
            Height          =   315
            Left            =   90
            TabIndex        =   15
            Text            =   "DataCallFormat"
            ToolTipText     =   "Data Format of Call"
            Top             =   240
            Width           =   1395
         End
      End
      Begin VB.Frame Frame12 
         Caption         =   "Store As ..."
         Height          =   885
         Left            =   1320
         TabIndex        =   9
         Top             =   1560
         Width           =   3885
         Begin VB.TextBox ArcServerText 
            Height          =   345
            Left            =   150
            TabIndex        =   11
            ToolTipText     =   "Device server name used in the stored event"
            Top             =   420
            Width           =   1755
         End
         Begin VB.TextBox arcPropertyText 
            Height          =   375
            Left            =   2070
            TabIndex        =   10
            ToolTipText     =   "Property Name used in the stored event"
            Top             =   420
            Width           =   1755
         End
         Begin VB.Label Label1 
            Caption         =   "Device Server"
            Height          =   255
            Left            =   150
            TabIndex        =   13
            Top             =   210
            Width           =   1305
         End
         Begin VB.Label Label3 
            Caption         =   "Device Property"
            Height          =   225
            Left            =   2040
            TabIndex        =   12
            Top             =   180
            Width           =   1335
         End
      End
      Begin VB.Frame Frame13 
         Caption         =   "Data Operations"
         Height          =   3195
         Left            =   5400
         TabIndex        =   8
         Top             =   240
         Width           =   7485
         Begin VB.Frame Frame21 
            Caption         =   "Input Data"
            Height          =   2835
            Left            =   4380
            TabIndex        =   60
            Top             =   240
            Width           =   2955
            Begin VB.CheckBox hasInptDataCheck 
               Caption         =   "has data"
               Height          =   285
               Left            =   180
               TabIndex        =   70
               ToolTipText     =   "This step takes input data"
               Top             =   240
               Width           =   1095
            End
            Begin VB.ComboBox inptFileNameCombo 
               Height          =   315
               Left            =   960
               TabIndex        =   68
               Text            =   "fileName"
               ToolTipText     =   "The file name containing the input value to use for this step"
               Top             =   1200
               Width           =   1695
            End
            Begin VB.ListBox inptFmtList 
               Height          =   1035
               Left            =   1500
               TabIndex        =   66
               ToolTipText     =   "The input format"
               Top             =   1740
               Width           =   1095
            End
            Begin VB.TextBox InptValuesText 
               Height          =   975
               Left            =   120
               MultiLine       =   -1  'True
               TabIndex        =   64
               Text            =   "Form1.frx":0442
               ToolTipText     =   "The input data"
               Top             =   1740
               Width           =   1275
            End
            Begin VB.OptionButton inptOptMulti 
               Caption         =   "multiple values"
               Height          =   255
               Left            =   1320
               TabIndex        =   63
               ToolTipText     =   "The input data are more complex than a single integer value"
               Top             =   600
               Value           =   -1  'True
               Width           =   1395
            End
            Begin VB.OptionButton inptOptSingle 
               Caption         =   "single value"
               Height          =   255
               Left            =   120
               TabIndex        =   62
               ToolTipText     =   "The input value is a single integer value"
               Top             =   600
               Width           =   1215
            End
            Begin VB.CheckBox writeAccessCheck 
               Caption         =   "Write Access"
               Height          =   285
               Left            =   1320
               TabIndex        =   61
               ToolTipText     =   "This step requires WRITE access"
               Top             =   240
               Width           =   1275
            End
            Begin VB.Label Label14 
               Caption         =   "file name :"
               Height          =   255
               Left            =   120
               TabIndex        =   69
               Top             =   1260
               Width           =   795
            End
            Begin VB.Label Label12 
               Caption         =   "input data :"
               Height          =   195
               Left            =   120
               TabIndex        =   65
               Top             =   1560
               Width           =   915
            End
         End
         Begin VB.Frame Frame19 
            Caption         =   "monitor options"
            Height          =   1815
            Left            =   2280
            TabIndex        =   49
            Top             =   1260
            Width           =   2055
            Begin VB.ComboBox monitorModeCombo 
               Height          =   315
               Left            =   120
               TabIndex        =   75
               Text            =   "TIMER"
               ToolTipText     =   "The monitor access mode "
               Top             =   1320
               Width           =   1815
            End
            Begin VB.TextBox monitorLifetimeText 
               Height          =   255
               Left            =   900
               TabIndex        =   54
               Text            =   "60"
               ToolTipText     =   "Duration of monitor"
               Top             =   960
               Width           =   495
            End
            Begin VB.TextBox monitorRateText 
               Height          =   315
               Left            =   900
               TabIndex        =   51
               Text            =   "1000"
               ToolTipText     =   "Polling interval for monitor"
               Top             =   540
               Width           =   495
            End
            Begin VB.CheckBox monitorCheck 
               Caption         =   "monitor"
               Height          =   255
               Left            =   120
               TabIndex        =   50
               ToolTipText     =   "Monitor this call for the duration given"
               Top             =   240
               Width           =   855
            End
            Begin VB.Label Label11 
               Caption         =   "duration"
               Height          =   255
               Left            =   180
               TabIndex        =   56
               ToolTipText     =   "Duration of monitor"
               Top             =   960
               Width           =   615
            End
            Begin VB.Label Label10 
               Caption         =   "sec"
               Height          =   255
               Left            =   1500
               TabIndex        =   55
               ToolTipText     =   "Duration of monitor"
               Top             =   960
               Width           =   315
            End
            Begin VB.Label Label9 
               Caption         =   "msec"
               Height          =   255
               Left            =   1500
               TabIndex        =   53
               ToolTipText     =   "Polling interval for monitor"
               Top             =   540
               Width           =   435
            End
            Begin VB.Label Label7 
               Caption         =   "interval"
               Height          =   255
               Left            =   180
               TabIndex        =   52
               ToolTipText     =   "Polling interval for monitor"
               Top             =   600
               Width           =   615
            End
         End
         Begin VB.Frame Frame20 
            Caption         =   "repeat"
            Height          =   1035
            Left            =   2280
            TabIndex        =   40
            Top             =   240
            Width           =   2055
            Begin VB.TextBox seriesRateText 
               Height          =   315
               Left            =   900
               TabIndex        =   43
               Text            =   "1000"
               ToolTipText     =   "The interval to use between 'repeats'"
               Top             =   600
               Width           =   555
            End
            Begin VB.TextBox numInSeriesText 
               Height          =   315
               Left            =   120
               TabIndex        =   41
               Text            =   "1"
               ToolTipText     =   "Repeat this step this many times before continuing to the next step"
               Top             =   240
               Width           =   615
            End
            Begin VB.Label Label6 
               Caption         =   "interval"
               Height          =   255
               Left            =   180
               TabIndex        =   48
               ToolTipText     =   "The interval to use between 'repeats'"
               Top             =   660
               Width           =   615
            End
            Begin VB.Label Label5 
               Caption         =   "msec"
               Height          =   255
               Left            =   1500
               TabIndex        =   47
               ToolTipText     =   "The interval to use between 'repeats'"
               Top             =   660
               Width           =   435
            End
            Begin VB.Label Label2 
               Caption         =   "times"
               Height          =   255
               Left            =   960
               TabIndex        =   42
               ToolTipText     =   "Repeat this step this many times before continuing to the next step"
               Top             =   240
               Width           =   495
            End
         End
         Begin VB.Frame Frame18 
            Caption         =   "delay"
            Height          =   1035
            Left            =   60
            TabIndex        =   36
            Top             =   900
            Width           =   2175
            Begin VB.CheckBox waitEmpty 
               Caption         =   "wait prior to next step"
               Height          =   255
               Left            =   120
               TabIndex        =   67
               ToolTipText     =   "Apply the wait time in advance of this step"
               Top             =   660
               Width           =   1815
            End
            Begin VB.CheckBox waitCheck 
               Caption         =   "wait"
               Height          =   255
               Left            =   120
               TabIndex        =   39
               ToolTipText     =   "Wait the given number of seconds"
               Top             =   300
               Width           =   615
            End
            Begin VB.TextBox WaitText 
               Height          =   315
               Left            =   840
               TabIndex        =   38
               Text            =   "0"
               ToolTipText     =   "Wait the given number of seconds"
               Top             =   240
               Width           =   735
            End
            Begin VB.Label Label8 
               Caption         =   "sec"
               Height          =   285
               Left            =   1680
               TabIndex        =   37
               Top             =   300
               Width           =   285
            End
         End
         Begin VB.Frame Frame17 
            Caption         =   "scale"
            Height          =   675
            Left            =   1140
            TabIndex        =   34
            Top             =   240
            Width           =   1095
            Begin VB.TextBox ScaleText 
               Height          =   345
               Left            =   120
               TabIndex        =   35
               Text            =   "Scale"
               ToolTipText     =   "Multiply all data elements by this value"
               Top             =   240
               Width           =   855
            End
         End
         Begin VB.Frame Frame16 
            Caption         =   "offset"
            Height          =   675
            Left            =   60
            TabIndex        =   32
            Top             =   240
            Width           =   1035
            Begin VB.TextBox OffsetText 
               Height          =   345
               Left            =   120
               TabIndex        =   33
               Text            =   "Offset"
               ToolTipText     =   "Add this offset to all data elements"
               Top             =   240
               Width           =   795
            End
         End
         Begin VB.Frame Frame7 
            Caption         =   "target"
            Height          =   1155
            Left            =   60
            TabIndex        =   29
            Top             =   1980
            Width           =   2175
            Begin VB.TextBox timeoutText 
               Height          =   345
               Left            =   900
               TabIndex        =   44
               Text            =   "1"
               ToolTipText     =   "Timeout to use in polling for a value"
               Top             =   660
               Width           =   495
            End
            Begin VB.CheckBox pollCheck 
               Caption         =   "match"
               Height          =   255
               Left            =   120
               TabIndex        =   31
               ToolTipText     =   "Poll the target until the (integer) output matches the given data"
               Top             =   240
               Width           =   795
            End
            Begin VB.TextBox dataTargetText 
               Height          =   315
               Left            =   900
               TabIndex        =   30
               Text            =   "0"
               ToolTipText     =   "Poll the target until the (integer) output matches the given data"
               Top             =   240
               Width           =   825
            End
            Begin VB.Label Label4 
               Caption         =   "timeout"
               Height          =   255
               Left            =   120
               TabIndex        =   46
               ToolTipText     =   "Timeout to use in polling for a value"
               Top             =   720
               Width           =   615
            End
            Begin VB.Label Label13 
               Caption         =   "sec"
               Height          =   225
               Left            =   1500
               TabIndex        =   45
               Top             =   720
               Width           =   315
            End
         End
      End
      Begin VB.Label Label18 
         Caption         =   "step(s)"
         Height          =   195
         Left            =   3540
         TabIndex        =   80
         Top             =   2580
         Width           =   795
      End
   End
   Begin VB.Frame Frame14 
      Caption         =   "Event Trigger Browsing"
      ForeColor       =   &H8000000D&
      Height          =   6075
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   14295
      Begin VB.Frame Frame8 
         Caption         =   "Event Triggers"
         Height          =   5055
         Left            =   120
         TabIndex        =   4
         Top             =   900
         Width           =   2085
         Begin VB.CommandButton editTriggerCmd 
            Caption         =   "Edit Description"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   8.25
               Charset         =   0
               Weight          =   700
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   285
            Left            =   120
            TabIndex        =   77
            ToolTipText     =   "Add a new event trigger to the system"
            Top             =   600
            Width           =   1755
         End
         Begin VB.ListBox dbList 
            Height          =   3960
            Left            =   120
            TabIndex        =   6
            ToolTipText     =   "Registered event trigger list (double click to remove an item)"
            Top             =   960
            Width           =   1875
         End
         Begin VB.CommandButton addTriggerCmd 
            Caption         =   "Add Trigger"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   8.25
               Charset         =   0
               Weight          =   700
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   285
            Left            =   120
            TabIndex        =   5
            ToolTipText     =   "Add a new event trigger to the system"
            Top             =   240
            Width           =   1755
         End
      End
      Begin VB.Frame Frame10 
         Caption         =   "Context"
         Height          =   585
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   2085
         Begin VB.ComboBox naviCombo 
            Height          =   315
            Left            =   60
            Sorted          =   -1  'True
            Style           =   2  'Dropdown List
            TabIndex        =   26
            Top             =   180
            Width           =   1875
         End
      End
      Begin VB.Frame Frame6 
         Caption         =   "Trigger Action List (double click to remove item)"
         Height          =   5715
         Left            =   2280
         TabIndex        =   1
         Top             =   240
         Width           =   11865
         Begin VB.TextBox trgKeepDepthText 
            Height          =   315
            Left            =   7740
            TabIndex        =   72
            Text            =   "0"
            ToolTipText     =   "Number of months to keep un-annotated events in long-term storage"
            Top             =   180
            Width           =   555
         End
         Begin VB.CommandButton WriteDataBaseButton 
            Caption         =   "Write DB"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   8.25
               Charset         =   0
               Weight          =   700
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   405
            Left            =   10560
            TabIndex        =   71
            ToolTipText     =   "Send all changes to the event server"
            Top             =   180
            Width           =   1125
         End
         Begin VB.ListBox stepsList 
            Height          =   4935
            Left            =   105
            TabIndex        =   2
            Top             =   645
            Width           =   11685
         End
         Begin VB.Label Label17 
            Caption         =   "Trigger Description: "
            Height          =   255
            Left            =   120
            TabIndex        =   76
            Top             =   240
            Width           =   6015
         End
         Begin VB.Label Label16 
            Caption         =   "months (0 or less -> always)"
            Height          =   255
            Left            =   8460
            TabIndex        =   74
            ToolTipText     =   "Number of months to keep un-annotated events in long-term storage"
            Top             =   240
            Width           =   2055
         End
         Begin VB.Label Label15 
            Caption         =   "Event Keep Depth :"
            Height          =   255
            Left            =   6300
            TabIndex        =   73
            ToolTipText     =   "Number of months to keep un-annotated events in long-term storage"
            Top             =   240
            Width           =   1455
         End
      End
   End
   Begin VB.Menu opts 
      Caption         =   "Options"
      Begin VB.Menu trcViewEdit 
         Caption         =   "Edit &Viewer Configurations"
      End
   End
End
Attribute VB_Name = "ArchiveDbForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim dc() As String
Dim ndc As Integer
Dim ds() As String
Dim nds As Integer
Dim dn() As String
Dim ndev As Integer
Dim prp() As String, prpSiz() As Long, prpTyp() As Integer
Dim prpDsc() As String, prpUnits() As String
Dim prpMax() As Single, prpMin() As Single
Dim nprp As Integer
Dim gContext As String
Dim isOpen As Boolean
Dim dbPathList(20) As String
Dim dbContextList(20) As String
Dim nDbFiles As Integer
Dim nrecs As Integer, nfixedrecs As Integer
Dim nPmEvents As Integer
Dim paramsFilled As Boolean
Dim DeviceAndPropertySelected As Boolean
Dim editPreviousEntry As Boolean
Dim touchDeviceServer As Boolean
Dim databaseHasChanged As Boolean
Dim prpIndex As Integer
Dim archiveServerContexts() As String
Dim nArchiveServerContexts As Integer
Dim nEventTriggers As Integer
Dim eventTable() As TrgElem
Dim inptFiles() As String
Dim nInptFiles As Integer
Dim prpsQueryPrecedence As Boolean
Dim devsQueryPrecedence As Boolean
Dim prpsQueried As Boolean
Dim dbList_index As Integer
Dim dbListReentry As Boolean

Private Sub addStepToList(das As DASQS)
Dim a As String
Dim srv As String, ctx As String, dev As String, prp As String, acc As String
  a = ""
  srv = BSTR(das.srv): ctx = BSTR(das.ctx): dev = BSTR(das.dev): prp = BSTR(das.prp)
  acc = GetAccessString(das.access)
  If Len(srv) > 0 Then
    a = "/" + ctx + "/" + srv + "/" + dev + "[" + prp + "]"
    a = a + " -> /" + ctx + "/" + BSTR(das.srvArc) + "/" + dev + " [" + BSTR(das.prpArc) + "]"
    a = a + " <" + acc + ">"
    'useDeviceListCheck.value = IIf(das.useDevList, 1, 0)
    If (acc = "WRITE") And Len(BSTR(das.infile)) = 0 Then
      a = a + " value = " + STR(das.value)
    End If
  End If
  If das.wait > 0 Then
    a = a + " WAIT " + STR(das.wait) + " seconds"
  End If
  If Len(a) > 0 Then stepsList.AddItem a

End Sub

Private Sub clearDataOperationsFields()
dataTargetText.text = "0"
OffsetText.text = "0.0"
ScaleText.text = "1.0"
WaitText.text = "0"

End Sub

Private Function isEntryInList() As Boolean
Dim i As Integer, k As Integer
Dim das As DASQS
Dim srv As String, ctx As String, dev As String, prp As String
Dim srvArc As String, prpArc As String
i = dbList.ListIndex

For k = 0 To UBound(eventTable(i).steps)
  das = eventTable(i).steps(k)
  srv = BSTR(das.srv): ctx = BSTR(das.ctx): dev = BSTR(das.dev): prp = BSTR(das.prp)
  srvArc = BSTR(das.srvArc): prpArc = BSTR(das.prpArc)
  If _
    (ctx = DeviceContextList.text) And _
    (srv = DeviceServerList.text) And _
    (dev = DeviceNameList.text) And _
    (prp = DevicePropertyList.text) And _
    (srvArc = ArcServerText.text) And _
    (prpArc = arcPropertyText.text) Then
    isEntryInList = True
    Exit Function
  End If
Next
isEntryInList = False
End Function

Function isTriggerInList(ByVal triggerStr As String) As Integer
Dim i As Integer
isTriggerInList = -1
For i = 0 To UBound(eventTable)
  If triggerStr = BSTR(eventTable(i).trgItem.trg) Then
    isTriggerInList = i%
    Exit Function
  End If
Next

End Function

Function isTriggerInListOLD(ByVal triggerStr As String) As Boolean
Dim i As Integer
For i = 0 To UBound(eventTable)
  If triggerStr = BSTR(eventTable(i).trgItem.trg) Then
    isTriggerInListOLD = True
    Exit Function
  End If
Next
isTriggerInListOLD = False

End Function

Private Sub loadEventInfo(ByVal context)
Dim i As Integer
stepsList.Clear
GetTriggerTable context, eventTable(), nEventTriggers
dbList.Clear
For i = 0 To nEventTriggers - 1
  dbList.AddItem BSTR(eventTable(i).trgItem.trg)
Next
If nEventTriggers > 0 Then dbList.ListIndex = 0
inptFileNameCombo.Clear
GetTriggerDataFiles context, inptFiles(), nInptFiles
For i = 0 To nInptFiles - 1 Step 1
  inptFileNameCombo.AddItem inptFiles(i)
Next
If nInptFiles > 0 Then inptFileNameCombo.ListIndex = 0
End Sub

Private Sub makeDBPathStructure(dbPath As String)
Dim p$, root$, sd() As String
Dim nlevels As Integer, i As Integer
On Error GoTo makeDBPathStructure
sd = Split(dbPath, "\")
p$ = sd(0)
root$ = "."
nlevels = UBound(sd)
For i = 1 To nlevels
  p$ = p$ + "\" + sd(i)
  MkDir p$
  If i < nlevels Then root$ = p$
Next
MkDir root$ + "\CACHE"
MkDir root$ + "\CACHE\triggerFiles"
MkDir root$ + "\CACHE\headerFiles"
MkDir root$ + "\CACHE\deviceFiles"
Exit Sub
makeDBPathStructure:
Resume Next
End Sub
Private Function UpdateStepsList(steps() As DASQS, ByVal stepsIndex As Integer) As Integer
Dim i As Integer, k As Integer

i = dbList.ListIndex
k = stepsIndex

If stepsList.ListCount = 1 Then ' nothing there yet
  ReDim steps(0)
ElseIf k >= stepsList.ListCount - 1 Then ' I'm adding something to the list
  If isEntryInList Then
    MsgBox "Entry is already in list!", vbInformation, "Add entry refused"
    UpdateStepsList = -1
    Exit Function
  End If
  ReDim Preserve steps(UBound(steps) + 1)
End If

BARR steps(k).ctx, DeviceContextList.text

BARR steps(k).srv, DeviceServerList.text
BARR steps(k).dev, DeviceNameList.text
BARR steps(k).prp, DevicePropertyList.text

BARR steps(k).srvArc, ArcServerText.text
BARR steps(k).prpArc, arcPropertyText.text

steps(k).shiftY = Val(OffsetText.text)
steps(k).ScaleY = Val(ScaleText.text)

steps(k).timeout = Val(timeoutText.text)

steps(k).mode = GetModeFromString(monitorModeCombo.text)

Dim v As Long
Dim siz As Long
Dim fmt As Integer
Dim acc As Integer
siz = Val(ArraySizeText.text)
fmt = CF_DOUBLE + getFormatFromString(DataCallFormat.text)
If siz > 0 Then
  acc = acc + dasREAD
  steps(k).datSiz = siz
  steps(k).datFmt = fmt
  If Len(dataTagText.text) > 0 Then BARR steps(k).datTag, dataTagText.text
Else
  steps(k).datFmt = CF_NULL
End If
If waitCheck.value Then
  acc = acc + dasWAIT
  steps(k).wait = Val(WaitText.text)
End If
If pollCheck.value Then
  acc = acc + dasMATCH
  steps(k).value = Val(dataTargetText.text)
  steps(k).timeout = Val(timeoutText.text)
End If
If writeAccessCheck.value Then
  acc = acc + dasWRITE
  If inptOptSingle.value Then
    steps(k).value = Val(dataTargetText.text)
  End If
End If
If hasInptDataCheck.value Then
  If inptOptMulti.value Then
    If Len(inptFileNameCombo.text) > 0 Then
      BARR steps(k).infile, inptFileNameCombo.text
      putInputData naviCombo.text
    End If
  End If
  steps(k).datFmtIn = CF_DOUBLE + getFormatFromString(inptFmtList.text)
Else
  steps(k).datFmtIn = CF_NULL
End If
If setnumCheck.value Then
  acc = acc + dasSETNUM
  If persistentOption(1).value Then acc = acc + dasPERSIST
  forwardCheck.value = False
End If
If forwardCheck.value Then
  acc = acc + dasFORWARD
End If
v = Val(numInSeriesText.text)
If v > 0 Then
  acc = acc + dasSERIES
  steps(k).value = v
  steps(k).wait = Val(WaitText.text)
End If
If monitorCheck.value Then
  acc = acc + dasMONITOR
  steps(k).monitorRate = Val(monitorRateText.text)
  steps(k).monitorTime = Val(monitorLifetimeText.text)
End If
steps(k).access = acc
UpdateStepsList = 0
End Function

Private Sub EditDatabase()
Dim i As Integer, stepsIndex As Integer
i = dbList.ListIndex
If i < 0 Then
  MsgBox "Please select a trigger !"
  Exit Sub
End If
stepsIndex = stepsList.ListIndex
If stepsIndex < 0 Then stepsIndex = stepsList.ListCount - 1
If UpdateStepsList(eventTable(i).steps, stepsIndex) <> 0 Then Exit Sub
eventTable(i).modified = True
RefreshStepsList False
databaseHasChanged = True
End Sub


Private Sub addTriggerCmd_Click()
Dim trgstr As String, trgdesc As String, iAnswer%, tmpRC%, tmpIndex%, tmpstr$
trgstr = InputBox("Please enter a trigger string (up to 16 characters - no blanks):", "Add Event Trigger")
If Len(trgstr) = 0 Then
  MsgBox "No trigger string was entered !"
  Exit Sub
End If
If InStr(trgstr, " ") > 0 Then
  MsgBox "Trigger string contains blank spaces!"
  Exit Sub
End If
If Len(trgstr) > 16 Then
  Dim s As String, msg As String
  Dim rc As Integer
  s = Left$(trgstr, 16)
  msg = "Trigger string exceeds 16 characters !"
  msg = vbNewLine + "Do you wish to use " + s + " as a trigger ?"
  rc = MsgBox(msg, vbOKCancel, "Trigger string too long")
  If rc = vbCancel Then Exit Sub
  trgstr = s
End If

tmpIndex% = isTriggerInList(trgstr)
If tmpIndex% > -1 Then
    ' Just modify the comment?
    'MsgBox "Trigger string is already in use!", vbInformation, "Trigger Refused"
    tmpstr$ = BSTR(eventTable(tmpIndex%).trgItem.trgdesc)
    
    iAnswer% = MsgBox("The trigger already exists. Would you like to modify the description?  [Current Desc: " + tmpstr$ + "]", vbYesNo)
    If iAnswer% = vbYes Then
        
        trgdesc = InputBox("Please enter a trigger description (up to 64 characters ):", "Modify the Trigger Description")
        If Len(trgdesc) > 64 Then
            s = Left$(trgdesc, 64)
            trgdesc = s
        End If
        
        BARR eventTable(tmpIndex%).trgItem.trgdesc, trgdesc
        eventTable(tmpIndex%).modified = True
        'databaseHasChanged = True
    End If
    Exit Sub
Else
    ' add a new one!
    
End If

trgdesc = InputBox("Please enter a trigger description (up to 64 characters ):", "Add Trigger Description")
If Len(trgdesc) > 64 Then
    s = Left$(trgdesc, 64)
    trgdesc = s
End If

Dim i As Integer
i = UBound(eventTable) + 1
If nEventTriggers = 0 Then i = 0
ReDim Preserve eventTable(i)

BARR eventTable(i).trgItem.trg, trgstr
BARR eventTable(i).trgItem.Ext, trgstr
BARR eventTable(i).trgItem.trgdesc, trgdesc
trgKeepDepthText.text = "0"

dbList.AddItem trgstr
dbList.text = trgstr
databaseHasChanged = True

End Sub

Private Sub AllDevicesCheckBox_Click()
  If AllDevicesCheckBox.value = 1 And DeviceNameList.text = ALL_DEVICES Then
    Exit Sub ' no change
  ElseIf AllDevicesCheckBox.value = 0 And DeviceNameList.text <> ALL_DEVICES Then
    Exit Sub ' no change
  End If
  If AllDevicesCheckBox.value Then
    DeviceNameList.text = ALL_DEVICES
  Else
    DeviceNameList.text = "#0"
  End If
End Sub

Private Sub AppendDatabase_Click()
EditDatabase
stepsList.ListIndex = stepsList.ListCount - 1
End Sub




Private Sub AppendOption_Click()

End Sub

Private Sub ArraySizeText_Change()
editPreviousEntry = False
End Sub




Private Sub DataCallFormat_Click()
editPreviousEntry = False
End Sub



Private Sub RefreshStepsList(ByVal acquire As Boolean)
Dim i As Integer, k As Integer, n As Integer
Dim a As String
i = dbList.ListIndex
If i < 0 Then Exit Sub
stepsList.Clear
trgKeepDepthText.text = STR(eventTable(i).trgItem.depthInMonths)
If acquire Then GetTriggerDb naviCombo.text, eventTable(i)

n = UBound(eventTable(i).steps) + 1
Dim das As DASQS
Dim ctx As String, srv As String, prp As String, dev As String, acc As String
For k = 0 To n - 1
  das = eventTable(i).steps(k)
  addStepToList das
Next
stepsList.AddItem "<Click here to add New Entry>"
End Sub

Private Sub dbContextText_Change()

End Sub

Private Sub dbContextText_Click()

End Sub


Private Sub dbList_Click()
If dbListReentry Then
  dbListReentry = False
  Exit Sub
End If
If databaseHasChanged Then
  Dim msg As String
  Dim rc As Integer
  msg = "You have made changes which will be lost unless you first 'Write DB'"
  msg = vbNewLine + "Do you wish to continue with a new selection ?"
  rc = MsgBox(msg, vbYesNoCancel, "Ignore Changes?")
  If rc <> vbYes Then
    dbListReentry = True
    dbList.ListIndex = dbList_index
    Exit Sub
  End If
  databaseHasChanged = False
End If
RefreshStepsList True
dbList_index = dbList.ListIndex
Label17.Caption = "Trigger Description: " + BSTR(eventTable(dbList_index).trgItem.trgdesc)
End Sub

Private Sub dbList_DblClick()
Dim i As Integer, j As Integer
If dbList.ListCount > 0 Then
  i = dbList.ListIndex
  If MsgBox("Remove Entry : " + dbList.List(i), vbOKCancel, "Remove Database entry") = vbCancel Then Exit Sub
  eventTable(i).trgItem.depthInMonths = -1
  eventTable(i).modified = True
  dbList.List(i) = "[" + BSTR(eventTable(i).trgItem.trg) + "]<deleted>"
  
  databaseHasChanged = True
End If

End Sub



Private Sub DeviceContextList_Change()
'DeviceAndPropertySelected = False
'paramsFilled = False
'dbContextText.text = DeviceContextList.text
Call DeviceContextList_Click
End Sub

Private Sub DeviceContextList_Click()
Dim rc As Integer, i As Integer
rc = GetEquipmentDeviceServers(DeviceContextList.text, "", ds(), nds)
If rc Then Exit Sub
DeviceServerList.Clear
For i = 0 To nds - 1
  DeviceServerList.AddItem ds(i)
Next
DeviceServerList.ListIndex = 0
'If Len(dbContextText.text) = 0 Then dbContextText.text = DeviceContextList.text
End Sub

Private Sub DeviceNameList_Change()
DeviceAndPropertySelected = False
paramsFilled = False
DeviceNameList_Click
End Sub

Private Sub DeviceNameList_Click()
Dim devnam As String
Dim rc As Integer, i As Integer

If DeviceNameList.text = ALL_DEVICES Then Exit Sub
If DeviceNameList.text = IGNORE_DEVICES Then Exit Sub
If prpsQueryPrecedence And prpsQueried Then Exit Sub
DevicePropertyList.Clear
If Left$(DeviceNameList.text, 1) = "#" Then
  devnam = "/" & DeviceContextList.text & "/" & DeviceServerList.text & "/#0"
Else
  devnam = "/" & DeviceContextList.text & "/" & DeviceServerList.text & "/" & DeviceNameList.text
End If
rc = GetEquipmentDevicePropertyInformationL(devnam, prp(), prpSiz(), prpTyp(), prpDsc(), prpMax(), prpMin(), prpUnits(), nprp)
If rc Then Exit Sub
prpsQueried = True
For i = 0 To nprp - 1
  DevicePropertyList.AddItem prp(i)
Next
DevicePropertyList.ListIndex = 0
editPreviousEntry = False
End Sub
Function getPropertyIndex(listProperty As String) As Integer
Dim i As Integer
For i = 0 To DevicePropertyList.ListCount - 1
  If prp(i) = listProperty Then Exit For
Next
getPropertyIndex = i
End Function
Private Sub DevicePropertyList_Click()
Dim i As Integer, rc As Integer, ndev As Integer
Dim dev As String
Dim pqx As PropertyQueryEx
Dim dn() As String

If prpsQueryPrecedence And Not AllDevicesCheckBox.value Then
  dev = "/" + DeviceContextList.text + "/" + DeviceServerList.text
  rc = GetEquipmentDeviceNamesFromProperty(dev, DevicePropertyList.text, dn(), ndev)
  DeviceNameList.Clear
  If rc = 0 Then
    For i = 0 To ndev - 1
      DeviceNameList.AddItem dn(i)
    Next
    DeviceNameList.ListIndex = 0
  End If
End If

i = getPropertyIndex(DevicePropertyList.List(DevicePropertyList.ListIndex))
ArraySizeText.text = STR(prpSiz(i))
DataCallFormat.text = GetFormatAsString(prpTyp(i))
prpIndex = i
arcPropertyText.text = DevicePropertyList.text

clearDataOperationsFields

End Sub
Private Sub DeviceServerList_Click()
Dim rc As Integer, i As Integer
Dim srv As String
Dim hqf As Boolean
DeviceNameList.Clear
AllDevicesCheckBox.value = False
srv = "/" + DeviceContextList + "/" + DeviceServerList.text

rc% = GetEquipmentDeviceNamesEx(srv, dn(), ndev, hqf)
prpsQueryPrecedence = hqf
devsQueryPrecedence = False
prpsQueried = False
If rc Then Exit Sub
For i = 0 To ndev - 1
  DeviceNameList.AddItem dn(i)
Next
DeviceNameList.ListIndex = 0
ArcServerText.text = DeviceServerList.text
editPreviousEntry = False
End Sub




Private Sub editTriggerCmd_Click()
Dim trgstr As String, trgdesc As String, s$, iAnswer%, tmpRC%, tmpIndex%, tmpstr$

tmpIndex% = dbList.ListIndex

If tmpIndex% > -1 Then
    tmpstr$ = BSTR(eventTable(tmpIndex%).trgItem.trgdesc)
    trgdesc = InputBox("Please enter a new trigger description (up to 64 characters )" + vbCr + vbCr + "Current Description for " + dbList.text + ": " + vbCr + tmpstr$, "Modify the Trigger Description", tmpstr$)
    
    If Len(trgdesc) = 0 Then Exit Sub
    
    If Len(trgdesc) > 64 Then
        s = Left$(trgdesc, 64)
        trgdesc = s
    End If
    
    BARR eventTable(tmpIndex%).trgItem.trgdesc, trgdesc
    eventTable(tmpIndex%).modified = True
    'databaseHasChanged = True

End If

End Sub

Private Sub Form_Activate()
Static initDone As Boolean
Dim selectedContext As Integer, i As Integer, rc As Integer
If initDone Then Exit Sub
initDone = True
On Error GoTo archiveMgrErr
registerStructs
loadFormatCombos

GetArchiveServerContexts

For i = 0 To nArchiveServerContexts - 1
  If Command$ = naviCombo.List(i) Then selectedContext = i
Next
naviCombo.ListIndex = selectedContext

DeviceServerList.Clear
ScaleText.text = "1.0"
OffsetText.text = "0.0"
DeviceContextList.Clear

rc = GetEquipmentDeviceContexts(dc(), ndc)
If rc Then Exit Sub
For i = 0 To ndc - 1
  DeviceContextList.AddItem dc(i)
Next

DeviceContextList.text = naviCombo.text

Exit Sub
archiveMgrErr:
Resume Next
End Sub

Sub GetArchiveServerContexts()
Dim rc As Integer, i As Integer
rc = GetEquipmentDeviceContextsForServer("EVENTS", archiveServerContexts, nArchiveServerContexts)
If rc <> 0 Then
  MsgBox "Cannot acquire archive server context information!" + vbNewLine + RPCERROR(rc), vbOKOnly, "GetArchiveServerContexts"
  Exit Sub
End If

For i = 0 To nArchiveServerContexts - 1
  naviCombo.AddItem archiveServerContexts(i)
Next

End Sub

Sub writeDbPathInfo()
Dim a$, fn$, i%
fn$ = App.path + "\" + cfgfile$
Open fn$ For Output Access Write Shared As #1
a$ = "Path,Context"
Print #1, a$
For i% = 0 To nDbFiles - 1
  a$ = dbPathList(i%) + "," + dbContextList(i%)
  Print #1, a$
Next
Close 1
End Sub
Sub loadFormatCombos()
DataCallFormat.AddItem "DOUBLE"
DataCallFormat.AddItem "INT16"
DataCallFormat.AddItem "BYTE"
DataCallFormat.AddItem "INT32"
DataCallFormat.AddItem "TEXT"
DataCallFormat.AddItem "FLOAT"
DataCallFormat.AddItem "STRUCT"
DataCallFormat.AddItem "NAME8"
DataCallFormat.AddItem "NAME16"
DataCallFormat.AddItem "NAME16FI"
DataCallFormat.AddItem "NAME32"
DataCallFormat.AddItem "FLTINT"
DataCallFormat.AddItem "LNGINT"
DataCallFormat.AddItem "DBLINT"
DataCallFormat.AddItem "DBLDBL"
DataCallFormat.AddItem "TDS"
DataCallFormat.AddItem "NAME48"
DataCallFormat.AddItem "NAME64"
DataCallFormat.AddItem "NAME8I"
DataCallFormat.AddItem "NAME16I"
DataCallFormat.AddItem "NAME32I"
DataCallFormat.AddItem "NAME48I"
DataCallFormat.AddItem "NAME64I"
DataCallFormat.AddItem "DUSTRING"
DataCallFormat.AddItem "FLTFLTINT"
DataCallFormat.AddItem "DFILTER"
DataCallFormat.AddItem "IFFF"
DataCallFormat.AddItem "DSPECTRUM"
DataCallFormat.AddItem "DADDRESS"
DataCallFormat.AddItem "DWINDOW"
DataCallFormat.AddItem "DPOINT"
DataCallFormat.AddItem "DIMAGE"
DataCallFormat.ListIndex = 0


inptFmtList.AddItem "BYTE"
inptFmtList.AddItem "INT16"
inptFmtList.AddItem "INT32"
inptFmtList.AddItem "FLOAT"
inptFmtList.AddItem "DOUBLE"
inptFmtList.AddItem "NAME16"
inptFmtList.AddItem "NAME32"
inptFmtList.AddItem "NAME64"

inptFmtList.ListIndex = 2

monitorModeCombo.AddItem "TIMER"
monitorModeCombo.AddItem "TIMER|CONNECT"
monitorModeCombo.AddItem "TIMER|NETWORK"
monitorModeCombo.AddItem "TIMER|STREAM"

End Sub

Private Sub Form_Resize()
'If ArchiveDbForm.Width > 12000 Then
'    Frame6.Width = ArchiveDbForm.Width - Frame6.Left - 150
'    stepsList.Width = Frame6.Width - 200
'End If

End Sub

Private Sub Form_Unload(Cancel As Integer)
Dim result As Integer
If databaseHasChanged Then
  result = MsgBox("Do you want to save your changes?", vbYesNo, "Select new Database")
  If result = vbYes Then Call WriteDataBaseButton_Click
End If
End Sub




Private Sub pushDBcmd_Click()
'Dim autoprocText As String
'Dim rc&, aptxt$, dbsrv$
'
'If dbPathCombo.ListIndex < 0 Then Exit Sub
'Select Case dbFileList(dbPathCombo.ListIndex)
'  Case "datapktr", "datamex":
'    aptxt$ = "exec " & "hedbget"
'    dbsrv$ = "mstlxmarch.desy.de"
'  Case "datadesy":
'    aptxt$ = "exec " & "d3dbget"
'    dbsrv$ = "mstlxmarch2.desy.de"
'  Case "datadoris":
'    aptxt$ = "exec " & "dodbget"
'    dbsrv$ = "mstlxmarch2.desy.de"
'  Case "datapetr":
'    aptxt$ = "exec " & "pedbget"
'    dbsrv$ = "mstlxmarch2.desy.de"
'  Case "datattf":
'    aptxt$ = "exec " & "ttfdbget"
'    dbsrv$ = "mstlxmarch2.desy.de"
'End Select
'
'rc& = ap_sendCommand(wsAutoProc, dbsrv$, aptxt$)
'If rc& < 0 Then MsgBox aptxt$ + " not accepted!"
End Sub


Private Sub resartCmd_Click()
'Dim autoprocText As String
'Dim rc&, aptxt$, dbsrv$, aptxt2$
'
'If dbPathCombo.ListIndex < 0 Then Exit Sub
'Select Case dbFileList(dbContextText.text)
'  Case "HERA":
'    aptxt$ = "restart " & "hepmarch"
'    dbsrv$ = "acclxmarch1.desy.de"
'  Case "PETRA":
'    aptxt$ = "restart " & "pepmarch"
'    dbsrv$ = "acclxmarch2.desy.de"
'  Case "DESY", "DESY2", "DESY3", "LINAC2", "LINAC3":
'    aptxt$ = "restart " & "d3pmarch"
'    dbsrv$ = "acclxmarch2.desy.de"
'  Case "DORIS":
'    aptxt$ = "restart " & "dopmarch"
'    dbsrv$ = "acclxmarch2.desy.de"
'  Case "TTF":
'    aptxt$ = "restart " & "ttfpmarch"
'    dbsrv$ = "acclxmarch2.desy.de"
'End Select
'
'rc& = ap_sendCommand(wsAutoProc, dbsrv$, aptxt$)
'If rc& < 0 Then MsgBox aptxt$ + " not accepted!"
'
'rc& = ap_sendCommand(wsAutoProc, dbsrv$, aptxt2$)
'If rc& < 0 Then MsgBox aptxt$ + " not accepted!"

End Sub

Private Sub ignoreDeviceCheck_Click()
  If ignoreDeviceCheck.value = 1 And DeviceNameList.text = IGNORE_DEVICES Then
    Exit Sub ' no change
  ElseIf ignoreDeviceCheck.value = 0 And DeviceNameList.text <> IGNORE_DEVICES Then
    Exit Sub ' no change
  End If
  If ignoreDeviceCheck.value Then
    DeviceNameList.text = IGNORE_DEVICES
  Else
    DeviceNameList.text = "#0"
  End If

End Sub

Private Sub inptFileNameCombo_Click()
GetInputData naviCombo.text, inptFileNameCombo.text, getFormatFromString(inptFmtList.text)
End Sub


Private Sub inptOptMulti_Click()
If inptOptMulti.value Then
  inptFileNameCombo.Enabled = True
Else
  inptFileNameCombo.Enabled = False
End If
End Sub

Private Sub inptOptSingle_Click()
If inptOptSingle.value Then
  inptFileNameCombo.Enabled = False
Else
  inptFileNameCombo.Enabled = True
End If
End Sub

Private Sub naviCombo_Click()
loadEventInfo naviCombo.text
End Sub

Private Sub Option1_Click()

End Sub

Private Sub stepsList_Click()
Dim i As Integer, k As Integer
Dim das As DASQS
Dim ctx As String, srv As String, prp As String, dev As String, acc As String

i = dbList.ListIndex
k = stepsList.ListIndex

hasInptDataCheck.value = 0
InptValuesText.text = ""
inptFileNameCombo.text = ""
numInSeriesText.text = ""
If k > UBound(eventTable(i).steps) Then
'  DeviceContextList.text = naviCombo.text
  DeviceServerList.SetFocus
  Exit Sub
End If
das = eventTable(i).steps(k)

srv = BSTR(das.srv): ctx = BSTR(das.ctx): dev = BSTR(das.dev): prp = BSTR(das.prp)
acc = GetAccessString(das.access)


If Len(ctx) > 0 Then
  DeviceContextList.text = ctx
End If
DeviceServerList.text = srv
DeviceNameList.text = dev
If dev = ALL_DEVICES Then
  AllDevicesCheckBox.value = 1
Else
  AllDevicesCheckBox.value = 0
End If
If dev = IGNORE_DEVICES Then
  ignoreDeviceCheck.value = 1
Else
  ignoreDeviceCheck.value = 0
End If

DevicePropertyList.text = prp
ArraySizeText.text = STR$(das.datSiz)
DataCallFormat.text = GetFormatAsString(das.datFmt)
dataTagText.text = BSTR(das.datTag)
ArcServerText.text = BSTR(das.srvArc)
arcPropertyText.text = BSTR(das.prpArc)

OffsetText.text = STR(das.shiftY)
ScaleText.text = STR(das.ScaleY)

If (das.access And dasMATCH) = dasMATCH Then
  pollCheck.value = 1
  dataTargetText.text = STR(das.value)
Else
  pollCheck.value = 0
  dataTargetText.text = "0"
End If
If (das.access And dasWAIT) = dasWAIT Then
  waitCheck.value = 1
  WaitText.text = STR(das.wait)
  If Len(DeviceServerList.text) = 0 Then waitEmpty.value = 1
Else
  waitCheck.value = 0
  waitEmpty.value = 0
  WaitText.text = "0"
End If
If (das.access And dasSETNUM) = dasSETNUM Then
  setnumCheck.value = 1
  If (das.access And dasPERSIST) = dasPERSIST Then
    persistentOption(1).value = True
  Else
    persistentOption(0).value = True
  End If
Else
  setnumCheck.value = 0
End If
If (das.access And dasFORWARD) = dasFORWARD Then
  forwardCheck.value = 1
Else
  forwardCheck.value = 0
End If
If (das.access And dasMONITOR) = dasMONITOR Then
  monitorCheck.value = 1
  monitorRateText.text = STR(das.monitorRate)
  monitorLifetimeText.text = STR(das.monitorTime)
  monitorModeCombo.text = GetModeString(das.mode)
Else
  monitorCheck.value = 0
  monitorRateText.text = "1000"
  monitorLifetimeText.text = "60"
  monitorModeCombo.text = "TIMER"
End If
If (das.access And dasSERIES) = dasSERIES Then
  numInSeriesText.text = STR(das.value)
  seriesRateText.text = STR(das.wait)
Else
  numInSeriesText.text = "0"
  seriesRateText.text = "1000"
End If
If (das.access And dasWRITE) = dasWRITE Then
  writeAccessCheck.value = 1
  hasInptDataCheck.value = 1
  InptValuesText.text = STR(das.value)
Else
  writeAccessCheck.value = 0
End If
Dim inpf As String
inpf = BSTR(das.infile)
If Len(inpf) > 0 Then
  inptFileNameCombo.text = inpf
  GetInputData naviCombo.text, inpf, das.datFmtIn
  hasInptDataCheck.value = 1
  inptOptMulti.value = True
End If

timeoutText.text = STR(das.timeout)

End Sub
Private Sub stepsList_DblClick()
Dim i As Integer, j As Integer, n As Integer
Dim dbsiz As Integer

n = dbList.ListIndex
If stepsList.ListCount > 0 Then
  i = stepsList.ListIndex
  If MsgBox("Remove Entry : " + stepsList.List(i), vbOKCancel, "Remove Database entry") = vbCancel Then Exit Sub
  dbsiz = UBound(eventTable(n).steps)
  For j = i To dbsiz - 1
    eventTable(n).steps(j) = eventTable(n).steps(j + 1)
  Next
  ReDim Preserve eventTable(n).steps(dbsiz - 1)
  stepsList.RemoveItem i
  eventTable(n).modified = True
  databaseHasChanged = True
End If

End Sub


Private Sub useDeviceListCheck_Click()

End Sub

Private Sub trcViewEdit_Click()
shell App.path + "\cfgMgr.exe " + naviCombo.text + " TRC", vbNormalFocus
End Sub

Private Sub trgKeepDepthText_KeyUp(KeyCode As Integer, Shift As Integer)
Dim i As Integer
i = dbList.ListIndex
If i < 0 Then Exit Sub
eventTable(i).trgItem.depthInMonths = Val(trgKeepDepthText.text)
eventTable(i).modified = True

End Sub

Private Sub waitCheck_Click()
If waitCheck.value Then
  If Val(WaitText.text) = 0 Then
    WaitText.text = "1000"
  End If
Else
  WaitText.text = "0"
End If
End Sub

Private Sub WaitText_Change()
Dim v As Long
v = Val(WaitText.text)
If waitCheck.value Or v = 0 Then Exit Sub
DeviceServerList.text = ""
DeviceNameList.text = ""
DevicePropertyList.text = ""
ArcServerText.text = ""
arcPropertyText.text = ""
waitCheck.value = IIf(v > 0, 1, 0)
End Sub

Private Sub writeAccessCheck_Click()
If writeAccessCheck.value Then
  inptOptSingle.value = True
Else
  inptOptMulti.value = True
End If
End Sub

Private Sub WriteDataBaseButton_Click()
databaseHasChanged = False

'input data file already there
'no worry about device names, headers
'send the trigger table and trigger info
PutTriggerTable naviCombo.text, eventTable

'restart the server
resetServer naviCombo.text
Sleep 2000
'force a local reload:
loadEventInfo naviCombo.text
End Sub

Private Sub wsAutoProc_Error(ByVal number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)

End Sub


