Attribute VB_Name = "CLIENT1"
Global Const NUMEQP = 2500
Global Const NUMPROP = 1000
Global Const NUMDEV = 4000
Global Const PROPSET_QUERY = 512
Global Const PROPSET = 18
Global Const PROPSET_LNG = 18
Global Const PROPSET_SHT = 6
Global Const PARAMDEPTH = 100
Global Const MAX_ARRAYSIZE = 4096
Global Const MIN_TIMEOUT = 100
Global nRecs%, numEqm%, nl$, dmode%, off%
'Global ddat#(MAX_ARRAYSIZE), idat%(MAX_ARRAYSIZE), fdat!(MAX_ARRAYSIZE * 2), ldat&(MAX_ARRAYSIZE)
Global ddat#(), idat%(), fdat!(), ldat&()
Global lldat() As Currency
Type CSTRING
  s As String * MAX_ARRAYSIZE
End Type
Global sdat As CSTRING
Global nam16dat(NUMEQP) As NAME16
Global nam32dat(NUMEQP) As NAME32
Global fltintdat() As FLTINT
Global bdat() As Byte ' use a 32Kb byte 'blob' for exotic format types
Global histnames(100) As NAME32, nHistories%
Global props(NUMPROP + 256) As NAME64
Global pquery(NUMPROP / 10) As PropertyQuery
Global pqx(NUMPROP / 10) As PropertyQueryEx
Global xpq(NUMPROP / 10) As XPropertyQuery
Global prpq(NUMPROP / 10) As PrpQuery
Global nullquery As PrpQuery
Global Const MAXNUMCONTEXTS = 100
Global numContexts%
Global contxts$(MAXNUMCONTEXTS)
Global deviceContext$, DeviceSubSystem$
Global ndevices As Integer
Global devices(NUMDEV) As NAME64
Global eqnm$(NUMEQP), eqMxNo%
Global eqfltr$(50), neqfltr%
Type STRUCTINFO
 tag As String
 slen As Long
 sf(64) As NAME64DBLDBL
End Type
Type BITFIELDINFO
 tag As String
 nfields As Long
 bf(64) As NAME16I
End Type
Global bfinfo(NUMPROP / 10) As BITFIELDINFO
Global nRegisteredStructs As Integer, nRegisteredBitfields As Integer
Type PROPINFO
  nam As String
  noverloads As Integer
  drawmode As Integer
  pq() As PrpQuery ' PropertyQueryEx
  isChannelArray As Boolean
End Type
Global eqprpinfo(NUMEQP) As PROPINFO
Global eqnprop%(NUMEQP)
Global eqprop$(NUMPROP + 100), eqpropDotNam$(NUMPROP / 2)
Global numDotNamEqp As Integer
Global defaultNumDevices As Integer
Global phist(NUMPROP) As Byte, pdone(NUMPROP) As Byte
Global nm_index%, prop_index%, sz_index&, type_index%
Global rpcerrStr As String * 80
Global datetime As String * 25
Global devicePrecedence As Boolean
Global propertyPrecedence As Boolean
Global CDBPATH$, DBPATH$
'Global Const DBPATH$ = "l:\database\archive\"
Global nparam%
Global g_nsubSystems As Integer
Type SUBSTYPE
  tag As String
  alias As String
End Type
Global g_subSystems(50) As SUBSTYPE
Global rtyp As String * 1
Type FECSTRUCT: eqm As String
                prop As String
                dev As String
                EqNo As Integer
                len As Integer
                fmt As String
                rectyp As Integer
                tstamp As Integer
                vnum As Integer
                Comment As String
                responsible As String
                recIndex As Integer
End Type
Global fec(NUMEQP) As FECSTRUCT
Global vname$(NUMEQP, PARAMDEPTH), vfmt$(NUMEQP, PARAMDEPTH), vcmt$(NUMEQP, PARAMDEPTH)
Global vmax#(NUMEQP, PARAMDEPTH), vmin#(NUMEQP, PARAMDEPTH), vunit$(NUMEQP, PARAMDEPTH), vsize%(NUMEQP, PARAMDEPTH)
Global fref%(NUMEQP), pref%(NUMEQP), nexti%, nextp%, nextf%
Global rpcID%(NUMEQP), ddata#(NUMEQP)
Global statusID%, fecstat%(NUMEQP)
Global npktr%, nmex%, nfecs%, nlinks%, maxsize%
Global MKIoffset%, MEXoffset%
Global RPCdebug As Integer
Global AsyncID%, readID%
Global EqpName$, EQPproperty$, EQPsize&, EQPdev$, EQPStructTag$, EQPStructKey$, EQPBfTag$
Global eqpunits$, doAutoscale As Integer
Global rpcxmax As Single, rpcxmin As Single
Global showStockPrps As Boolean

Global eqs(200) As ElemQueryStruct

Global InputDataType As String
Global InputDataLength As Integer
Global writeAccess As Boolean
Global InstanceCount As Integer

'---- DLL function definitions -----
Declare Function LOADDLL Lib "tinecln32.dll" () As Integer
Declare Function EQPDEINIT Lib "tinecln32.dll" () As Integer
Declare Function GETEQPUSAGE Lib "tinecln32.dll" () As Integer


Sub cbLink(ByVal LinkIndex As Long, ByVal StatusCode As Long)
Dim arrSize As Long
Dim captionText As String
Dim ts As Double, msec As Long
Dim lts As Long
Dim i As Long
Dim tDevNames() As String
Dim devString As String
Dim pos As Integer, cnt As Integer
Dim idx As Integer, j%, K%, fmt%, rc As Integer
Dim bval As Byte, sval%, lval&, fval!, dval#
Dim sinf(63) As NAME64DBLDBL

Debug.Print "got callback event"
Exit Sub

ts = client.rpcdata.getDataTimeStamp()
If ts < 0 Then
  ts = 0
Else
  msec = (ts - CDbl(client.rpcdata.timestamp)) * 1000
End If
devString = client.rpcdata.deviceName + " " + client.rpcdata.deviceProperty
If Len(devString) > 42 Then
  If Left$(devString, 1) = "/" Then
    pos = 1
    Do
      devString = Right$(devString, Len(devString) - pos)
      pos = InStr(pos + 1, devString, "/")
      cnt = cnt + 1
    Loop While (pos > 0) And (cnt < 3) And (Len(devString) > 42)
  End If
End If
captionText = devString + " @" + Mid$(client.rpcdata.CTIME(ts), 4, 16) + "." + format(msec, "000")
client.rpcdata.Caption = captionText
client.rpcdata.XAxisLabel = client.rpcdata.deviceProperty '+ "  " + eqpunits$
client.rpcdata.ClearScreen: client.rpcdata.ClearText
If (StatusCode And CE_SENDDATA) = CE_SENDDATA Then
  Dim errstr As String * 192
  RPCGETLASTERROR errstr
  captionText = errstr
  StatusCode = 0
End If
If StatusCode Then
rpc_error:
  lts = UNIXTIME
  rpctextFrame.Visible = True: client.rpcdata.Visible = False
  msg$ = client.rpcdata.deviceName + " " + client.rpcdata.deviceProperty + _
                  " @" + Mid$(client.rpcdata.CTIME(lts), 4, 21)
  msg$ = msg$ + vbNewLine + " Error " + "<" + STR$(StatusCode) + "> : " + vbNewLine + "    " + client.rpcdata.Status
  rpctext.text = msg$
  rpctextCaption.Caption = captionText
  DoEvents
  GoTo OverAndOut
End If
If eqptype.text = "NULL" Then
  rpctextFrame.Visible = True: client.rpcdata.Visible = False
  msg$ = client.rpcdata.deviceName + " " + client.rpcdata.deviceProperty + _
                  " @" + Mid$(client.rpcdata.CTIME(client.rpcdata.timestamp), 4, 21)
  rpctext.text = msg$ + vbNewLine + " Success"
  rpctextCaption.Caption = captionText
  GoTo OverAndOut
End If

client.rpcdata.GetDataSize arrSize
If arrSize <= 0 Then
  rpctextFrame.Visible = True: client.rpcdata.Visible = False
  rpctext.text = "no data returned"
  rpctextCaption.Caption = captionText
  GoTo OverAndOut
End If
If Right$(client.rpcdata.deviceProperty, 5) = ".HIST" Or Right$(client.rpcdata.deviceProperty, 4) = ".HST" Then isChannelArray = False
If Right$(prop.text, 5) = ".ARCH" Or Right$(prop.text, 4) = ".ARC" Or Right$(prop.text, 3) = ".AR" Then isChannelArray = False
If Right$(eqname, 7) = "HISTORY" Then isChannelArray = False
If isChannelArray And UBound(DeviceNames) >= arrSize Then
  client.reorderChannelDeviceNames devnam.text, arrSize, tDevNames
End If
Select Case eqptype.text
  Case "STRUCT"
'     Client.rpcdata.Draw bdat, , , , EQPsize&, "struct"
     d$ = ""
     If Len(EQPStructTag$) > 0 Then
       EQPStructKey$ = "/" + client.devcontext.text + "/" + client.eqname.text
       rc = GetStructFromTag(EQPStructTag$, EQPStructKey$, sinf(0), 64)
       If rc < 0 Then
         rpctextCaption.Caption = "problem with structure tag : " + tag$
         Exit Sub
       End If
      If arrSize > EQPsize Then
         For i = 0 To 63
           If sinf(i).d2Val = CF_NULL Then Exit For
         Next
         arrSize = arrSize / sinf(i).d1val
       End If
      d$ = client.StructToString(EQPStructTag$, EQPStructKey$, arrSize, "", bdat)
     End If
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "BITFIELD8", "BITFIELD16", "BITFIELD32", "BITFIELD64"
     d$ = ""
     If Len(EQPBfTag$) > 0 Then
     idx = getBitfieldIndexFromTag(EQPBfTag$)
      If idx < 0 Then
        rpctextCaption.Caption = "problem with bitfield tag : " + tag$
        Exit Sub
      End If
      Dim bflen As Integer, bffmt As Integer
      Dim bmask As Long, bshift As Long
      bflen = client.fmtsizeof(eqptype.text)
      bffmt = getFormatFromString(eqptype.text)
      If arrSize > EQPsize Then arrSize = arrSize / bflen
      For n% = 0 To arrSize - 1
        For i = 0 To bfinfo(idx).nfields - 1
          bmask = bfinfo(idx).bf(i).iVal
          bshift = GetShiftFromMask(bmask, bffmt)
          d$ = d$ + "[" + STR(n%) + " -> " + STR(i) + " " + BSTR(bfinfo(idx).bf(i).nam) + "] "
          
          Select Case bffmt
            Case CF_BYTE
              bval = bdat(K%)
              d$ = d$ + STR((bval And bmask) / bshift) + vbNewLine
              K% = K% + 1
            Case CF_SHORT
              MEMCPYL sval%, bdat(K%), 2
              d$ = d$ + STR((sval And bmask) / bshift) + vbNewLine
              K% = K% + 2
            Case CF_LONG
              MEMCPYL lval&, bdat(K%), 4
              d$ = d$ + STR((lval And bmask) / bshift) + vbNewLine
              K% = K% + 4
          End Select
        Next
      Next
     Else
      For i = 0 To EQPsize& - 1
        s$ = Hex(bdat(i))
        While Len(s$) < 2: s$ = "0" + s$: Wend
        d$ = d$ + s$
        If i Mod 2 Then d$ = d$ + " "
        If (i + 1) Mod 8 = 0 Then d$ = d$ + nl$ + " "
      Next
     End If
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "TEXT", "XML"
     If client.rpcdata.getdata(sdat.s, , LinkIndex) Then GoTo rpc_error
     s$ = Left$(sdat.s, EQPsize&): d$ = ""
     Dim ss() As String
     ss = Split(s$, Chr(10))
     For i = 0 To UBound(ss)
       d$ = d$ + ss(i) + vbNewLine
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME8"
     Dim l_nam8 As NAME8
     d$ = " "
     For i = 0 To arrSize - 1
        MEMCPYL l_nam8, bdat(i * 8), 8
        s$ = BSTR(l_nam8.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 8: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + s$ + nl$
'        If (i + 1) Mod 5 = 0 Then d$ = d$ + nl$ + " "
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME16"
     d$ = ""
     For i = 0 To arrSize - 1
        s$ = BSTR(nam16dat(i).nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 16: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + s$ + nl$
'        d$ = d$ + s$ + " "
'        If (i + 1) Mod 5 = 0 Then d$ = d$ + nl$ + " "
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME16I"
     Dim l_n16i As NAME16I
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_n16i, bdat(i * 20), 20
        s$ = BSTR(l_n16i.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 16: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "################################") + " " + _
             "  " + format$(l_n16i.iVal, "#########0") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME32"
     Dim l_nam32 As NAME32
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_nam32, bdat(i * 32), 32
        s$ = BSTR(l_nam32.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 32: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + s$ + nl$
'        d$ = d$ + s$ + " "
'        If (i + 1) Mod 5 = 0 Then d$ = d$ + nl$ + " "
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME32I"
     Dim l_n32i As NAME32I
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_n32i, bdat(i * 36), 36
        s$ = BSTR(l_n32i.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 32: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "################################") + " " + _
             "  " + format$(l_n32i.iVal, "#########0") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME48"
     Dim l_nam48 As NAME48
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_nam48, bdat(i * 48), 48
        s$ = BSTR(l_nam48.nam())
        d$ = d$ + " (" + STR(i) + ") " + s$ + nl$
'        d$ = d$ + s$ + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME48I"
     Dim l_n48i As NAME48I
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_n48i, bdat(i * 52), 52
        s$ = BSTR(l_n48i.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 48: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "#################################################") + " " + _
             "  " + format$(l_n48i.iVal, "#########0") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME64"
     Dim l_nam64 As NAME64
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_nam64, bdat(i * 64), 64
        s$ = BSTR(l_nam64.nam())
        d$ = d$ + " (" + STR(i) + ") " + s$ + nl$
'        d$ = d$ + s$ + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME64I"
     Dim l_n64i As NAME64I
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_n64i, bdat(i * 68), 68
        s$ = BSTR(l_n64i.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 64: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "#################################################################") + " " + _
             "  " + format$(l_n64i.iVal, "#########0") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME16FI"
     Dim l_nfi As NAME16FI
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_nfi, bdat(i * 24), 24
        s$ = BSTR(l_nfi.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 16: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "################") + " " + _
             format$(l_nfi.fval, "####0.0000") + _
             "  " + format$(l_nfi.iVal, "#########0") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAMEII", "NAME16II"
     Dim l_nii As NAME16II
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_nii, bdat(i * 24), 24
        s$ = BSTR(l_nii.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 16: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "################") + " " + _
             format$(l_nii.i1val, "#########0") + _
             "  " + format$(l_nii.i2Val, "#########0") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME32DBLDBL"
     Dim l_n32dd As NAME32DBLDBL
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_n32dd, bdat(i * 48), 48
        s$ = BSTR(l_n32dd.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 32: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "################") + " " + _
             format$(l_n32dd.d1val, "####0.0000") + _
             "  " + format$(l_n32dd.d2Val, "#########0") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME64DBLDBL"
     Dim l_n64dd As NAME64DBLDBL
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_n64dd, bdat(i * 80), 80
        s$ = BSTR(l_n64dd.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 64: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "################") + " " + _
             format$(l_n64dd.d1val, "####0.0000") + _
             "  " + format$(l_n64dd.d2Val, "#########0") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "NAME64DBL"
     Dim l_n64d As NAME64DBL
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_n64d, bdat(i * 72), 72
        s$ = BSTR(l_n64d.nam())
        p0 = InStr(s$, Chr(0))
        If p0 Then
          For j% = p0 To 64: Add$ = Add$ + " ": Next
          s$ = Left$(s$, p0 - 1) + Add$
        End If
        d$ = d$ + " (" + STR(i) + ") " + format(s$, "################") + " " + _
             format$(l_n64d.dval, "####0.0000") + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "USTRING"
     Dim l_ustring As USTRING
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_ustring, bdat(i * 96), 96
        s$ = TrimString(BSTR(l_ustring.STR))
        d$ = d$ + " (" + STR(i) + ") " + STR$(l_ustring.iVal) + " " + STR$(l_ustring.f1val) + " " + _
                  STR$(l_ustring.f2val) + " " + STR$(l_ustring.ts) + _
                  " " + s$ + vbNewLine
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "UNAME"
     Dim l_uname As UNAME
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_uname, bdat(i * 32), 32
        s$ = TrimString(BSTR(l_uname.nam))
        d$ = d$ + " (" + STR(i) + ") " + STR$(l_uname.iVal) + " " + STR$(l_uname.f1val) + " " + _
                  STR$(l_uname.f2val) + " " + STR$(l_uname.f3val) + _
                  " " + s$ + vbNewLine
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
  Case "FLTINT"
     ReDim fltintdat(arrSize)
     MEMCPYL fltintdat(0), bdat(0), arrSize * 8
      d$ = ""
      For i = 0 To arrSize - 1
         d$ = d$ + " (" + STR(i) + ") "
         If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
         d$ = d$ + STR$(fltintdat(i).fval) + " " + STR$(fltintdat(i).iVal) + vbNewLine
      Next
      rpctext.text = d$
      rpctextCaption.Caption = captionText
      rpctextFrame.Visible = True: client.rpcdata.Visible = False
      GoTo OverAndOut
  Case "INTINT", "LNGINT"
     Dim l_ii As INTINT
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_ii, bdat(i * 8), 8
        d$ = d$ + " (" + STR(i) + ") "
        If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
        d$ = d$ + STR$(l_ii.i1val) + " " + STR$(l_ii.i2Val) + vbNewLine
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "DBLDBL"
     Dim l_dd As DBLDBL
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_dd, bdat(i * 16), 16
        d$ = d$ + " (" + STR(i) + ") "
        If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
        d$ = d$ + STR$(l_dd.d1val) + " " + STR$(l_dd.d2Val) + vbNewLine
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "SPECTRUM"
     rpctextFrame.Visible = False: client.rpcdata.Visible = True
     'Dim l_spectrum As DSPECTRUM
     'MEMCPY l_spectrum, fdat(0), 96 + arrsize
'     Client.rpcdata.Draw l_spectrum.spectrum, , , , arrsize
     client.rpcdata.Draw fdat(24), , , , arrSize, "FLOAT"
  Case "TDS", "INTFLTINT"
     Dim l_tds As TDS
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_tds, bdat(i * 12), 12
        d$ = d$ + " (" + STR(i) + ") "
        If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
        d$ = d$ + STR$(l_tds.tval) + " " + STR$(l_tds.dval) + " " + STR$(l_tds.sval) + vbNewLine
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "FFI"
     Dim l_ffi As FLTFLTINT
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_ffi, bdat(i * 12), 12
        d$ = d$ + " (" + STR(i) + ") "
        If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
        d$ = d$ + STR$(l_ffi.f1val) + " " + STR$(l_ffi.f2val) + " " + STR$(l_ffi.iVal) + vbNewLine
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "FII"
     Dim l_fii As FLTINTINT
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_fii, bdat(i * 12), 12
        d$ = d$ + " (" + STR(i) + ") "
        If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
        d$ = d$ + STR$(l_fii.fval) + " " + STR$(l_fii.i1val) + " " + STR$(l_fii.i2Val) + vbNewLine
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "FILTER"
     Dim l_filter As INTFLTFLTFLT
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_filter, bdat(i * 16), 16
        d$ = d$ + " (" + STR(i) + ") " + STR$(l_filter.iVal) + " " + STR$(l_filter.f1val) + " " + STR$(l_filter.f2val) + " " + STR$(l_filter.f3val) + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "FIFI"
     Dim l_fifi As FLTINTFLTINT
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_fifi, bdat(i * 16), 16
        d$ = d$ + " (" + STR(i) + ") " + STR$(l_fifi.f1val) + " " + STR$(l_fifi.i1val) + " " + STR$(l_fifi.f2val) + " " + STR$(l_fifi.i2Val) + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "IIFF"
     Dim l_iiff As INTINTFLTFLT
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_iiff, bdat(i * 16), 16
        d$ = d$ + " (" + STR(i) + ") " + STR$(l_iiff.i1val) + " " + STR$(l_iiff.i2Val) + " " + STR$(l_iiff.f1val) + " " + STR$(l_iiff.f2val) + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "INTINTINT"
     Dim l_iii As INTINTINT
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_iii, bdat(i * 12), 12
        d$ = d$ + " (" + STR(i) + ") " + STR$(l_iii.i1val) + " " + STR$(l_iii.i2Val) + " " + STR$(l_iii.i3val) + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "ADDRESS", "WINDOW"
     Dim l_iiii As INTINTINTINT
     d$ = ""
     For i = 0 To arrSize - 1
        MEMCPYL l_iiii, bdat(i * 16), 16
        d$ = d$ + " (" + STR(i) + ") " + STR$(l_iiii.i1val) + " " + STR$(l_iiii.i2Val) + " " + STR$(l_iiii.i3val) + " " + STR$(l_iiii.i4val) + nl$
     Next
     rpctext.text = d$
     rpctextCaption.Caption = captionText
     rpctextFrame.Visible = True: client.rpcdata.Visible = False
  Case "BYTE"
     If client.rpcdata.DisplayMode = TextBox Then
        d$ = ""
        For i = 0 To arrSize - 1
           d$ = d$ + " (" + STR(i) + ") "
           If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
           d$ = d$ + STR$(bdat(i)) + vbNewLine
        Next
        rpctext.text = d$
        rpctextCaption.Caption = captionText
        rpctextFrame.Visible = True: client.rpcdata.Visible = False
        GoTo OverAndOut
     End If
     rpctextFrame.Visible = False: client.rpcdata.Visible = True
     If isChannelArray And UBound(DeviceNames) >= arrSize Then
       client.rpcdata.Draw bdat, , , tDevNames, arrSize
     Else
       client.rpcdata.Draw bdat, , , , arrSize
     End If
  Case "INT16", "INTEGER"
     If client.rpcdata.DisplayMode = TextBox Then
        d$ = ""
        For i = 0 To arrSize - 1
           d$ = d$ + " (" + STR(i) + ") "
           If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
           d$ = d$ + STR$(idat(i)) + vbNewLine
        Next
        rpctext.text = d$
        rpctextCaption.Caption = captionText
        rpctextFrame.Visible = True: client.rpcdata.Visible = False
        GoTo OverAndOut
     End If
     rpctextFrame.Visible = False: client.rpcdata.Visible = True
     If isChannelArray And UBound(DeviceNames) >= arrSize Then
       client.rpcdata.Draw idat, , , tDevNames, arrSize
     Else
       client.rpcdata.Draw idat, , , , arrSize
     End If
  Case "INT32", "LONG"
     If client.rpcdata.DisplayMode = TextBox Then
        d$ = ""
        For i = 0 To arrSize - 1
           d$ = d$ + " (" + STR(i) + ") "
           If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
           d$ = d$ + STR$(ldat(i)) + vbNewLine
        Next
        rpctext.text = d$
        rpctextCaption.Caption = captionText
        rpctextFrame.Visible = True: client.rpcdata.Visible = False
        GoTo OverAndOut
     End If
     rpctextFrame.Visible = False: client.rpcdata.Visible = True
     If isChannelArray And UBound(DeviceNames) >= arrSize Then
       client.rpcdata.Draw ldat, , , tDevNames, arrSize
     Else
       client.rpcdata.Draw ldat, , , , arrSize
    End If
  Case "DLONG"
     If client.rpcdata.DisplayMode = TextBox Then
        d$ = ""
        If UBound(ddat) < UBound(lldat) Then ReDim ddat(UBound(lldat))
        For i = 0 To arrSize - 1
           d$ = d$ + " (" + STR(i) + ") "
           If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
           d$ = d$ + STR$(lldat(i)) + vbNewLine
           ddat(i) = lldat(i)
        Next
        rpctext.text = d$
        rpctextCaption.Caption = captionText
        rpctextFrame.Visible = True: client.rpcdata.Visible = False
        GoTo OverAndOut
     End If
     rpctextFrame.Visible = False: client.rpcdata.Visible = True
     If isChannelArray And UBound(DeviceNames) >= arrSize Then
       client.rpcdata.Draw ddat, , , tDevNames, arrSize
     Else
       client.rpcdata.Draw ddat, , , , arrSize
    End If
  Case "FLOAT"
     If client.rpcdata.DisplayMode = TextBox Then
        d$ = ""
        For i = 0 To arrSize - 1
           d$ = d$ + " (" + STR(i) + ") "
           If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
           d$ = d$ + STR$(fdat(i)) + vbNewLine
        Next
        rpctext.text = d$
        rpctextCaption.Caption = captionText
        rpctextFrame.Visible = True: client.rpcdata.Visible = False
        GoTo OverAndOut
     End If
     rpctextFrame.Visible = False: client.rpcdata.Visible = True
     If isChannelArray And UBound(DeviceNames) >= arrSize Then
       client.rpcdata.Draw fdat, , , tDevNames, arrSize
     Else
       client.rpcdata.Draw fdat, , , , arrSize
     End If
  Case "DOUBLE"
     If client.rpcdata.DisplayMode = TextBox Then
        d$ = ""
        For i = 0 To arrSize - 1
           d$ = d$ + " (" + STR(i) + ") "
           If isChannelArray And UBound(DeviceNames) >= arrSize Then d$ = d$ + tDevNames(i) + " : "
           d$ = d$ + STR$(ddat(i)) + vbNewLine
        Next
        rpctext.text = d$
        rpctextCaption.Caption = captionText
        rpctextFrame.Visible = True: client.rpcdata.Visible = False
        GoTo OverAndOut
     End If
     rpctextFrame.Visible = False: client.rpcdata.Visible = True
     If isChannelArray And UBound(DeviceNames) >= arrSize Then
       client.rpcdata.Draw ddat, , , tDevNames, arrSize
     Else
       client.rpcdata.Draw ddat, , , , arrSize
     End If
End Select
If doAutoscale Then
  client.rpcdata.AutoScale True, True, True, True
Else
  client.rpcdata.AutoScale True, True
End If
'EGU
OverAndOut:
If client.rpcdata.AccessMode = "READ" Or client.rpcdata.AccessMode = "WRITE" Or _
   client.rpcdata.AccessMode = "READ.CONNECT" Or client.rpcdata.AccessMode = "WRITE.CONNECT" Then
  CmdReadWrite.Enabled = True
  poll.Enabled = True
  client.rpcdata.CloseLink
  linkIdx& = 0
  client.userCanChangeSettings True
End If

End Sub


Function fecload(fname$, offset%)
dpos# = 1
type_done = False
fname$ = DBPATH$ + fname$
If Dir(fname$) = "" Then
  fecload = 0
  Exit Function
End If
Open fname$ For Input Access Read Shared As #1
i% = offset%: p% = nparam%
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not type_done Then
      rec_col = colptr(a$, "Record Type")
      Name_col = colptr(a$, "Name")
      prop_col = colptr(a$, "Property")
      dev_col = colptr(a$, "Device")
      len_col = colptr(a$, "data length")
      fmt_col = colptr(a$, "RPC Format")
      sf_col = colptr(a$, "Structure")
      act_col = colptr(a$, "Active")
      rsp_col = colptr(a$, "Responsibility")
      type_done = True
    Else
      fec(i%).rectyp = Val(getcol(a$, rec_col))
      fec(i%).eqm = getcol(a$, Name_col)
      fec(i%).prop = getcol(a$, prop_col)
      fec(i%).dev = getcol(a$, dev_col)
      If fec(i).dev <> "" Then fec(i%).EqNo = Val(Right$(fec(i).dev, Len(fec(i).dev) - 1))
      fec(i%).len = Val(getcol(a$, len_col))
      fec(i%).fmt = getcol(a$, fmt_col)
      sfname$ = getcol(a$, sf_col)
      active% = Val(getcol(a$, act_col))
      fec(i%).responsible = getcol(a$, rsp_col)
      
      fec(i%).rectyp = fec(i%).rectyp + offset - 1
      If active% Then
        j% = 0: sfname$ = DBPATH$ + "INFO\" + sfname$: done = 0
        Open sfname$ For Input Access Read Shared As #2
        Do
          Line Input #2, a$
          tok$ = Left$(a$, 1)
          If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And Len(a$) > 7 Then
            If Not done Then
              kwd_col = colptr(a$, "Keyword")
              fmt_col = colptr(a$, "Format")
              siz_col = colptr(a$, "Size")
              uni_col = colptr(a$, "Units")
              max_col = colptr(a$, "Maximum")
              min_col = colptr(a$, "Minimum")
              cmt_col = colptr(a$, "Comment")
              done = True
            Else
              vname$(i%, j%) = getcol(a$, kwd_col)
              vfmt$(i%, j%) = getcol(a$, fmt_col)
              vsize%(i%, j%) = Val(getcol(a$, siz_col))
              vunit$(i%, j%) = getcol(a$, uni_col)
              vmax#(i%, j%) = Val(getcol(a$, max_col))
              vmin#(i%, j%) = Val(getcol(a$, min_col))
              vcmt$(i%, j%) = getcol(a$, cmt_col)
              fref%(p%) = i%: pref%(p%) = j%
              If maxsize% < vsize(i%, j%) Then maxsize% = vsize%(i%, j%)
              p% = p% + 1: j% = j% + 1
            End If
          End If
        Loop While Not EOF(2)
        Close 2
        i% = i% + 1
      End If
    End If
  End If
Loop While Not EOF(1)
numEqm% = i%
Close 1

fecload = p% - nparam%
nparam% = p%
nfecs% = i%
Close 1

End Function
Function getBitfieldIndexFromTag(ByVal tag As String)
Dim i As Integer
For i = 0 To nRegisteredBitfields - 1
  If bfinfo(i).tag = tag Then Exit For
Next
If i < nRegisteredBitfields Then
  getBitfieldIndexFromTag = i
Else
  getBitfieldIndexFromTag = -1
End If

End Function

Function getValueAsString(B As Byte, ByVal fmt As Integer) As String
Dim s As String
Dim flen As Integer, i As Integer
Dim sval As Integer
Dim lval As Long
Dim fval As Single
Dim dval As Double
Dim nval As String
Dim dlval As Currency
Dim nbuf(64) As Byte
'TODO finish
flen = GetFormatSize(fmt)
If flen <= 0 Then Exit Function
Select Case fmt
  Case CF_BYTE
    s = Hex(B)
  Case CF_SHORT
    MEMCPYL sval, B, 2
    s = STR(sval)
  Case CF_LONG
    MEMCPYL lval, B, 4
    s = STR(lval)
  Case CF_DLONG
    MEMCPYL dlval, B, 8
    s = STR(dlval)
  Case CF_FLOAT
    MEMCPYL fval, B, 4
    s = STR(fval)
  Case CF_DOUBLE
    MEMCPYL dval, B, 8
    s = STR(dval)
  Case CF_NAME8, CF_NAME16, CF_NAME32, CF_NAME48, CF_NAME64
    MEMCPYL nbuf(0), B, flen
    s = BSTR(nbuf)
  Case CF_USTRING
    Dim ustr As USTRING
    MEMCPYL ustr, B, flen
    s = STR(ustr.f1val) + " " + STR(ustr.f2val) + " " + STR(ustr.iVal) + " " + BSTR(ustr.STR) + " " + STR(ustr.ts)
  Case CF_UNAME
    Dim unam As UNAME
    MEMCPYL unam, B, flen
    s = STR(unam.f1val) + " " + STR(unam.f2val) + " " + STR(unam.f3val) + " " + STR(unam.iVal) + " " + BSTR(unam.nam)
  Case CF_INTINT
    Dim iival As INTINT
    MEMCPYL iival, B, flen
    s = STR(iival.i1val) + " " + STR(iival.i2Val)
  Case CF_FLTINT
    Dim fival As FLTINT
    MEMCPYL fival, B, flen
    s = STR(fival.fval) + " " + STR(fival.iVal)
  Case CF_FLTFLT
    Dim ffval As FLTFLT
    MEMCPYL ffval, B, flen
    s = STR(ffval.f1val) + " " + STR(ffval.f2val)
  Case CF_DBLDBL
    Dim ddval As DBLDBL
    MEMCPYL ddval, B, flen
    s = STR(ddval.d1val) + " " + STR(ddval.d2Val)
  Case CF_NAME8I, CF_NAME16I, CF_NAME32I, CF_NAME48I, CF_NAME64I
    MEMCPYL nbuf(0), B, flen - 4
    MEMCPYLP CADDR(lval), CADDR(B) + flen - 4, 4
    s = BSTR(nbuf) + " " + STR(lval)
  Case CF_NAME16FI
    MEMCPYL nbuf(0), B, 16
    MEMCPYL CADDR(fval), CADDR(B) + 16, 4
    MEMCPYL CADDR(lval), CADDR(B) + 20, 4
    s = BSTR(nbuf) + " " + STR(fval) + " " + STR(lval)
  Case CF_NAME16II
    MEMCPYL nbuf(0), B, 16
    MEMCPYL CADDR(lval), CADDR(B) + 16, 4
    s = BSTR(nbuf) + " " + STR(lval)
    MEMCPYL CADDR(lval), CADDR(B) + 20, 4
    s = s + " " + STR(lval)
  Case CF_NAME16DBLDBL, CF_NAME32DBLDBL, CF_NAME64DBLDBL
    MEMCPYL nbuf(0), B, flen - 16
    MEMCPYL CADDR(dval), CADDR(B) + flen, 8
    s = BSTR(nbuf) + " " + STR(dval)
    MEMCPYL CADDR(dval), CADDR(B) + flen + 8, 8
    s = s + " " + STR(sval)
  Case CF_NAME64DBL
    MEMCPYL nbuf(0), B, flen - 8
    MEMCPYL CADDR(dval), CADDR(B) + flen, 8
    s = BSTR(nbuf) + " " + STR(dval)
    s = s + " " + STR(sval)
  Case CF_INTINTINT
    Dim iiival As INTINTINT
    MEMCPYL iiival, B, flen
    s = STR(iiival.i1val) + " " + STR(iiival.i2Val) + " " + STR(iiival.i3val)
  Case CF_INTFLTINT
    Dim ifival As INTFLTINT
    MEMCPYL ifival, B, flen
    s = STR(ifival.i1val) + " " + STR(ifival.fval) + " " + STR(ifival.i2Val)
  Case CF_INTINTINTINT
    Dim iiiival As INTINTINTINT
    MEMCPYL iiiival, B, flen
    s = STR(iiiival.i1val) + " " + STR(iiiival.i2Val) + " " + STR(iiiival.i3val) + " " + STR(iiiival.i4val)
  Case CF_FLTFLTINT
    Dim ffival As FLTFLTINT
    MEMCPYL ffival, B, flen
    s = STR(ffival.f1val) + " " + STR(ffival.f2val) + " " + STR(ffival.iVal)
  Case CF_FLTINTINT
    Dim fiival As FLTINTINT
    MEMCPYL fiival, B, flen
    s = STR(fiival.fval) + " " + STR(fiival.i1val) + " " + STR(fiival.i2Val)
  Case CF_INTFLTFLTFLT
    Dim ifffval As INTFLTFLTFLT
    MEMCPYL ifffval, B, flen
    s = STR(ifffval.iVal) + " " + STR(ifffval.f1val) + " " + STR(ifffval.f2val) + " " + STR(ifffval.f3val)
  Case CF_FLTINTFLTINT
    Dim fifival As FLTINTFLTINT
    MEMCPYL fifival, B, flen
    s = STR(fifival.f1val) + " " + STR(fifival.i1val) + " " + STR(fifival.f2val) + " " + STR(fifival.i2Val)
End Select

getValueAsString = s
End Function
