VERSION 5.00
Object = "{A8B3B723-0B5A-101B-B22E-00AA0037B2FC}#1.0#0"; "GRID32.OCX"
Begin VB.Form globals 
   Appearance      =   0  'Flat
   BackColor       =   &H00808000&
   Caption         =   "Globals"
   ClientHeight    =   1365
   ClientLeft      =   210
   ClientTop       =   480
   ClientWidth     =   2910
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "GLOBALS.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1365
   ScaleWidth      =   2910
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   1290
      Top             =   -180
   End
   Begin MSGrid.Grid GlobalsGrid 
      Height          =   1335
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2895
      _Version        =   65536
      _ExtentX        =   5106
      _ExtentY        =   2355
      _StockProps     =   77
      BackColor       =   16777215
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "globals"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim glbname$(NUMEQP), glbfmt%(NUMEQP), glbsiz%(NUMEQP), nglobals%, globalsize%
Dim glbContext As String
Dim ddval As DBLDBL
Dim ndval As NAME64DBL

Sub changeGlobalsContext(ByVal context As String)

If Timer1.Enabled And context = glbContext Then Exit Sub

Call getGlobalsFromServer(context)

'Call getGlobalsListFromFile

GlobalsGrid.Rows = nglobals% + 2
GlobalsGrid.Cols = globalsize% + 2
GlobalsGrid.Row = 0
GlobalsGrid.col = 0: GlobalsGrid.text = "Parameter"
GlobalsGrid.col = 1: GlobalsGrid.text = "Value"
GlobalsGrid.ColWidth(0) = 1200
GlobalsGrid.ColWidth(1) = 2400
For i% = 2 To globalsize% + 1
  GlobalsGrid.ColWidth(i%) = 2400
Next i%
For i% = 0 To nglobals% - 1
  GlobalsGrid.Row = i% + 1
  GlobalsGrid.col = 0: GlobalsGrid.text = glbname$(i%)
Next i%
GlobalsGrid.Row = nglobals% + 1
GlobalsGrid.col = 0: GlobalsGrid.text = "Time"
globals.Height = (nglobals% + 2) * 240 + 800
globals.Left = Screen.Width - globals.Width
globals.Top = Screen.Height - globals.Height

End Sub

Sub getGlobalsFromServer(context As String)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As USTRING
Dim prpNames() As NAME32
Dim rc As Integer, i%, k%
Dim DevName As String

retryGetKeywords:
DevName = "/" + context + "/GLOBALS"

dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
'dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
'rc = T_EXECLINK(DevName, "NKEYWORDS", dbout, n, dbin, Null, CA_READ Or CA_RETRY, 500)
'If rc = address_unknown% And context <> "SITE" Then
'  context = "SITE"
'  GoTo retryGetKeywords
'End If
'If rc Then GoTo exitFunction
glbContext = context
globals.Caption = context + " Globals"
'ReDim prpNames(n)
'ReDim prps(n * 2)
Dim ndd(50) As NAME64DBLDBL
dbout.dArrayLength = 50: dbout.dFormat = CF_NAME64DBLDBL
'rc = T_EXECLINK(DevName, "KEYWORDS", dbout, prpNames(0), dbin, Null, CA_READ Or CA_RETRY, 500)
rc = T_EXECLINK(DevName, "SRVGLOBALS", dbout, ndd(0), dbin, Null, CA_READ Or CA_RETRY, 500)
If (rc = address_unknown% Or rc = link_blacklisted%) And context <> "SITE" Then
  context = "SITE"
  GoTo retryGetKeywords
End If
If (rc And CE_SENDDATA) = CE_SENDDATA Then rc = 0
If rc Then GoTo exitFunction
n = dbout.dArrayLength
ReDim prpNames(n)
ReDim prps(n * 2)
For i% = 0 To n - 1
  MEMCPY prpNames(i%).nam(0), ndd(i%).nam(0), 64
  glbname$(i%) = Trim$(BSTR(prpNames(i%).nam))
  glbfmt%(i%) = ndd(i%).d1val
  glbsiz%(i%) = ndd(i%).d2Val
  If glbsiz%(i%) > globalsize% And glbfmt%(i%) <> CF_TEXT Then globalsize% = glbsiz%(i%)
Next
'dbout.dArrayLength = n * 2: dbout.dFormat = CF_USTRING
'rc = T_EXECLINK(DevName, "PROPERTIES", dbout, prps(0), dbin, Null, CA_READ Or CA_RETRY, 500)
'If (rc And CE_SENDDATA) = CE_SENDDATA Then rc = 0

'For i% = 0 To n - 1
'  For k% = 0 To 2 * n - 1
'    If glbname$(i%) = BSTR(prps(k%).STR) Then
'      glbfmt%(i%) = prps(k%).ts + CF_DOUBLE
'      glbsiz%(i%) = prps(k%).iVal
'      If glbsiz%(i%) > globalsize% Then globalsize% = glbsiz%(i%)
'      Exit For
'    End If
'  Next
'Next

exitFunction:
nglobals% = n

End Sub

Sub getGlobalsListFromFile()
Dim i%
globfile$ = CDBPATH$ + "nglobals.csv"
i% = 0
On Error GoTo getGlobalsListFromFileError
Open globfile$ For Input Access Read Shared As #1
Do
    Line Input #1, a$
    tok$ = Left$(a$, 1)
    If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And Len(a$) > 7 Then
      If Not done Then
        key_col = colptr(a$, "KEYWORD")
        fmt_col = colptr(a$, "FORMAT")
        siz_col = colptr(a$, "SIZE")
        done = True
      Else
        glbname$(i%) = getcol(a$, key_col)
        fmtstr$ = getcol(a$, fmt_col)
        fmtval% = Val(fmtstr)
        If fmtval% < CF_DOUBLE Then
          fmtstr$ = UCase(fmtstr$)
          Select Case fmtstr$
           Case "BYTE": fmtval% = CF_BYTE
           Case "SHORT", "INT", "INT16", "INTEGER": fmtval% = CF_SHORT
           Case "LONG", "INT32": fmtval% = CF_LONG
           Case "DLONG": fmtval% = CF_DLONG
           Case "FLOAT": fmtval% = CF_FLOAT
           Case "DOUBLE": fmtval% = CF_DOUBLE
           Case "CHAR": fmtval% = CF_TEXT
           Case "NAME8", "STRING8", "CHAR8": fmtval% = CF_CHAR8
           Case "NAME16", "STRING16", "CHAR16": fmtval% = CF_CHAR16
           Case "NAME32", "STRING32", "CHAR32": fmtval% = CF_CHAR32
           Case "NAME64", "STRING64", "CHAR64": fmtval% = CF_CHAR64
           Case "CHAR16FI", "NAME16FI": fmtval% = CF_CHAR16FI
           Case "STRUCT": vmtval% = CF_STRUCT
          End Select
        End If
        glbfmt%(i%) = fmtval%
        sizstr$ = getcol(a$, siz_col)
        glbsiz%(i%) = Val(sizstr$)
        If glbsiz%(i%) > globalsize% And fmtval% <> CF_TEXT Then globalsize% = glbsiz%(i%)
        i% = i% + 1
        If i% > NUMEQP Then Exit Do
      End If
    End If
  Loop While Not EOF(1)
  Close 1

getGlobalsListFromFileError:
nglobals% = i%
End Sub
Private Sub Form_Load()
changeGlobalsContext deviceContext$
Timer1.Enabled = True

End Sub

Private Sub Form_Resize()
Dim addw As Integer
GlobalsGrid.Height = globals.ScaleHeight - GlobalsGrid.Top * 2
GlobalsGrid.Width = globals.Width
addw = GlobalsGrid.Width - 3600
If addw < 0 Then Exit Sub
For i% = 1 To globalsize% + 1
  GlobalsGrid.ColWidth(i%) = 2400 + addw
Next i%
End Sub

Private Sub Form_Unload(Cancel As Integer)
Timer1.Enabled = False
End Sub

Private Sub Timer1_Timer()
Dim st As String * 256
Dim glbkey As String
On Error GoTo globalsTimerError
For i% = 0 To nglobals% - 1
  GlobalsGrid.Row = i% + 1
  glbkey = "/" + glbContext + "/" + glbname$(i%)
  Select Case glbfmt%(i%)
    Case CF_DBLDBL:
      rc% = GETGLOBAL(glbkey, ddval, 1, CF_DBLDBL)
      GlobalsGrid.col = 1
      dd# = IIf(rc%, -1, ddval.d1val)
      GlobalsGrid.text = format$(dd#, "####0.000")
    Case CF_NAME64DBL:
      rc% = GETGLOBAL(glbkey, ndval, 1, CF_NAME64DBL)
      GlobalsGrid.col = 1
      If rc% Then st = "-1" Else Call Bytes2String(st, ndval.nam(0), 64)
      GlobalsGrid.text = st
    Case CF_DOUBLE:
      rc% = GETGLOBAL(glbkey, ddat#(0), glbsiz%(i%), CF_DOUBLE)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        dd# = IIf(rc%, -1, ddat#(j% - 1))
        GlobalsGrid.text = format$(dd#, "####0.000")
      Next j%
    Case CF_INTEGER:
      rc% = GETGLOBAL(glbkey, idat%(0), glbsiz%(i%), CF_INTEGER)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        ID% = IIf(rc%, -1, idat%(j% - 1))
        GlobalsGrid.text = STR$(ID%)
      Next j%
    Case CF_LONG:
      rc% = GETGLOBAL(glbkey, ldat&(0), glbsiz%(i%), CF_LONG)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        ld& = IIf(rc%, -1, ldat&(j% - 1))
        GlobalsGrid.text = STR$(ld&)
      Next j%
    Case CF_FLOAT:
      rc% = GETGLOBAL(glbkey, fdat!(0), glbsiz%(i%), CF_FLOAT)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        fd! = IIf(rc%, -1, fdat!(j% - 1))
        GlobalsGrid.text = STR$(fd!)
      Next j%
    Case CF_TEXT:
      rc% = GETGLOBAL(glbkey, bdat(0), glbsiz%(i%), CF_TEXT)
      GlobalsGrid.col = 1
      If rc% Then st = "-1" Else Call Bytes2String(st, bdat(0), glbsiz%(i%))
      GlobalsGrid.text = st
    Case CF_CHAR8:
      rc% = GETGLOBAL(glbkey, bdat(0), glbsiz%(i%), CF_CHAR8)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        If rc% Then st = "-1" Else Call Bytes2String(st, bdat((j% - 1) * 8), 8)
        GlobalsGrid.text = st
      Next j%
    Case CF_CHAR16:
      rc% = GETGLOBAL(glbkey, bdat(0), glbsiz%(i%), CF_CHAR16)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        If rc% Then st = "-1" Else Call Bytes2String(st, bdat((j% - 1) * 16), 16)
        GlobalsGrid.text = st
      Next j%
    Case CF_CHAR32:
      rc% = GETGLOBAL(glbkey, bdat(0), glbsiz%(i%), CF_CHAR32)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        If rc% Then st = "-1" Else Call Bytes2String(st, bdat((j% - 1) * 32), 32)
        GlobalsGrid.text = st
      Next j%
    Case CF_CHAR64:
      rc% = GETGLOBAL(glbkey, bdat(0), glbsiz%(i%), CF_CHAR64)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        If rc% Then st = "-1" Else Call Bytes2String(st, bdat((j% - 1) * 64), 64)
        GlobalsGrid.text = st
      Next j%
    
    End Select
Next i%
GlobalsGrid.col = 1
GlobalsGrid.Row = nglobals% + 1
GlobalsGrid.text = format$(Now)
globalsTimerError:
Exit Sub
End Sub

