VERSION 5.00
Object = "{3C5F82B2-2B3E-11D1-B429-00AA004115AF}#2.0#0"; "acop.ocx"
Begin VB.Form Wincntrl 
   Caption         =   "Windows Front End Debug Screen"
   ClientHeight    =   4470
   ClientLeft      =   165
   ClientTop       =   780
   ClientWidth     =   7215
   LinkTopic       =   "Form1"
   ScaleHeight     =   4470
   ScaleWidth      =   7215
   StartUpPosition =   3  'Windows Default
   Begin ACOPLib.ACOP windebug 
      Height          =   285
      Left            =   360
      TabIndex        =   1
      Top             =   1530
      Visible         =   0   'False
      Width           =   285
      _Version        =   131072
      _ExtentX        =   503
      _ExtentY        =   503
      _StockProps     =   47
      ForeColor       =   0
      BackColor       =   16777215
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      DeviceProperty  =   "DEBUGBUFFER"
      AccessMode      =   "REFRESH"
      XAxisLabel      =   ""
      YAxisLabel      =   ""
      Status          =   ""
      RandomData      =   0   'False
   End
   Begin VB.TextBox DebugScreen 
      Height          =   4305
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   90
      Width           =   7005
   End
   Begin VB.Menu dbgLevel 
      Caption         =   "Debug Level"
      Begin VB.Menu dbg 
         Caption         =   "&Off"
         Index           =   0
      End
      Begin VB.Menu dbg 
         Caption         =   "&Short"
         Checked         =   -1  'True
         Index           =   1
      End
      Begin VB.Menu dbg 
         Caption         =   "&Long"
         Index           =   2
      End
   End
End
Attribute VB_Name = "Wincntrl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim dbgbuf As String * 1306
Dim debugLevel As Integer
Dim idDBG As Long
Sub setDebugLevel(dbglev%)
Dim rc As Long
  windebug.DeviceName = gEQPTAG$
  windebug.DeviceProperty = "DEBUGLEVEL"
  windebug.accessMode = "WRITE"
  rc = windebug.Execute(, , , dbglev%)
  debugLevel = dbglev%
  If idDBG Then Exit Sub
  windebug.DeviceProperty = "DEBUGBUFFER"
  windebug.accessMode = "POLL"
  idDBG = windebug.OpenLink(dbgbuf)
End Sub

Private Sub dbg_Click(Index As Integer)
Dim i As Integer
If Index = debugLevel Then Exit Sub
For i = 0 To 2: dbg(i).Checked = False: Next
dbg(Index).Checked = True
setDebugLevel Index
End Sub

Private Sub Form_Load()
  Call setDebugLevel(1)
End Sub

Private Sub Form_Unload(Cancel As Integer)
Dim dbglev%, rc&
  windebug.DeviceProperty = "DEBUGLEVEL"
  windebug.accessMode = "WRITE"
  dbglev% = 0
  rc& = windebug.Execute(, , , dbglev%)
  windebug.CloseLink
  idDBG = 0
End Sub
Function ascii2vb(s$) As String
Dim ptr%
Dim vbs$
Do
  ptr% = InStr(s$, Chr(10))
  If ptr% = 0 Then Exit Do
  vbs$ = vbs$ + Left$(s$, ptr% - 1) + Chr(13) + Chr(10)
  s$ = Right$(s$, Len(s$) - ptr%)
'  If ptr% > 0 Then ptr% = ptr% + 1
Loop While ptr% > 0
ascii2vb = vbs$
End Function
Private Sub windebug_Receive(ByVal LinkIndex As Long, ByVal StatusCode As Long)
If StatusCode Then
  DebugScreen.text = windebug.Status
  Exit Sub
End If
If debugLevel = 0 Then Exit Sub
windebug.GetData dbgbuf
DebugScreen.text = ascii2vb(dbgbuf)
End Sub
