Attribute VB_Name = "feccntl"
'Declare Function Get_Number_GreenFecs Lib "remote.dll" () As Integer
Declare Function RegisterRemote Lib "remote.dll" (ByVal ID%, ByVal b$) As Integer
Declare Function Release_Fec Lib "remote.dll" (ByVal ID%) As Integer
Declare Function Boot_Fec Lib "remote.dll" (ByVal ID%) As Integer
Declare Function Ping_Fec Lib "remote.dll" (ByVal ID%) As Integer
Declare Function Get_Ping Lib "remote.dll" (ByVal ID%) As Integer
Declare Function Control_Fec Lib "remote.dll" (ByVal ID%) As Integer
Declare Function BootVxServer Lib "remote.dll" (ByVal bootflag&, ByVal ip$) As Long
Declare Function RetBootVxServer Lib "remote.dll" () As Long
Declare Function Session_Active Lib "remote.dll" (ByVal ID%) As Long

Global gEQPTAG$
Global Const MAXENTRIES = 600
Type EQPRECORD
Tagname As String * 16
fecname As String * 16
EqpName As String * 16
context As String * 16
End Type
Global Eqp(MAXENTRIES) As EQPRECORD
Global dsvrs() As String, ndsvrs As Integer
Global fecnams() As String, nfecnams As Integer
Type FECRECORD
  fecname As String * 16
  eqpnames(25) As String * 32
  neqp As Integer
  computername As String * 32
  loginname As String * 16
  os As String * 16
  macAddr As String * 12
  ipxnet As String * 8
  IPAddr As String * 16
  Description As String * 48
  Location As String * 48
  responsible As String * 32
  facility As String * 16
  subsystem As String * 16
  visible As Boolean
  gridposition As Integer
  BackCol As Long
  pingTimeouts As Integer
  infoGathered As Boolean
End Type
Type SubSystemType
  Name As String * 16
  tag As String * 5
  selected As Boolean
End Type
Type ExoticFec
  fecname As String * 16
  shellPgm As String * 128
  message As String * 256
End Type
Global Exts() As ExoticFec
Global nexts As Integer
Type FecImportance
  fecname As String * 16
  level As Integer
End Type
Global Importance() As FecImportance
Global nimportance As Integer
Global Const MAXSUBSYS = 24
Global subs(MAXSUBSYS) As SubSystemType
Type FacilityType
  Name As String * 5
  selected As Boolean
End Type
Global nsubsys%
Global nfacilities%
Global nfecsVisible%
Global CDBASE$
Global fec() As FECRECORD
Global neqp As Integer
Global nfec As Integer
Global COLWIDTH As Long '= 1260
Global ROWHEIGHT As Long '= 250
Global targettedServer$
Global pingFecStartIndex As Integer

Global Const SLAVEALIVE = 0
Global Const SLAVECONTROLLED = 1
Global Const SLAVEDEAD = 2
Global Const NOTADOS = 3

Global cleared%
Global initDone%
Global numTotalContracts%
Global numTotalClients%
Global Const MAX_SUBSYSTEMS = 30
Global g_subSystems(MAX_SUBSYSTEMS) As String
Global g_subSystemsTipText(MAX_SUBSYSTEMS) As String
Global g_nsubsystems As Integer
Function findSubSystemTag(tag As String) As Integer
For i = 0 To MAXSUBSYS - 1
  If TrimString(Left(subs(i).tag, 3)) = TrimString(Left(tag, 3)) Then Exit For
Next
If i < MAXSUBSYS Then findSubSystemTag = i Else findSubSystemTag = -1
End Function
Sub getSelectedSubSystems()
Dim ss_col As Integer
Dim done As Boolean
Dim opened As Boolean
On Error GoTo FileNotFound
TMPPATH$ = Environ("TEMP")
ssfile$ = TMPPATH$ + "\subsys.csv"
Open ssfile$ For Input Access Read Shared As #1
opened = True
For i = 0 To MAXSUBSYS - 1: subs(i).selected = False: Next
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" Then
    If Not done Then
      ss_col = colptr(a$, "SubSystem")
      done = True
    Else
      n = findSubSystemTag(getcol(a$, ss_col))
      If n >= 0 Then subs(n).selected = True
    End If
  End If
Loop While Not EOF(1)
FileNotFound:
If opened Then Close #1
Exit Sub
End Sub
Sub fillSubSystemInformation()
' TODO:  get these from a query to the ENS !!!!!!!!!!!!!!!!!!!!!!
' set default selections
Dim i As Integer
load_subsystems

For i = 0 To g_nsubsystems - 1
  subs(i).Name = g_subSystems(i)
  subs(i).tag = g_subSystems(i)
  subs(i).selected = IIf(TrimString(subs(i).tag) = "TEST", False, True)
Next
nsubsys% = g_nsubsystems
'subs(0).Name = "RF": subs(0).tag = "RF": subs(0).selected = True
'subs(1).Name = "Vacuum": subs(1).tag = "VAC": subs(1).selected = True
'subs(2).Name = "Magnets": subs(2).tag = "MAG": subs(2).selected = True
'subs(3).Name = "Quench": subs(3).tag = "QPS": subs(3).selected = True
'subs(4).Name = "Tunes/FB": subs(4).tag = "TUNE": subs(4).selected = True
'subs(5).Name = "Injection": subs(5).tag = "INJ": subs(5).selected = True
'subs(6).Name = "Experiments": subs(6).tag = "EXP": subs(6).selected = True
'subs(7).Name = "Diagnostics": subs(7).tag = "DIAG": subs(7).selected = True
'subs(8).Name = "Services": subs(8).tag = "SER": subs(8).selected = True
'subs(9).Name = "Netmex": subs(9).tag = "MEX": subs(9).selected = True
'subs(10).Name = "Subsystems": subs(10).tag = "SUB": subs(10).selected = True
'subs(11).Name = "Timing": subs(11).tag = "TIM": subs(11).selected = True
'subs(12).Name = "Archive": subs(12).tag = "HIST": subs(12).selected = True
'subs(13).Name = "Tests": subs(13).tag = "TEST": subs(13).selected = False
'nsubsys% = 14

getSelectedSubSystems   ' is config file there?

For i = 0 To MAXSUBSYS - 1
  If i < nsubsys% Then
    fecform.subsys(i).Caption = TrimString(subs(i).Name)
    fecform.subsys(i).Value = IIf(subs(i).selected, 1, 0)
    fecform.subsys(i).ToolTipText = g_subSystemsTipText(i)
    fecform.subsys(i).Enabled = True
    fecform.subsys(i).visible = True
  Else
    fecform.subsys(i).Enabled = False
    fecform.subsys(i).visible = False
  End If
Next

End Sub
Sub load_subsystems()
Dim subsys(100) As NAME16
Dim dbin As DBLK, dbout As DBLK
Dim rc%, n As Integer
Dim devnam As String, tmpstr As String

For i% = 0 To MAX_SUBSYSTEMS - 1: subsys(i%).nam(0) = 0: Next
dbout.dArrayLength = MAX_SUBSYSTEMS: dbout.dFormat = CF_NAME16
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
devnam = "ENSEQM/" + fecform.ContextList.text
rc% = T_EXECLINK(devnam, "SUBSYSTEMS", dbout, subsys(0), dbin, 0, CA_READ, 3000)
If rc% Then 'load some default sub systems for older name servers
    g_subSystems(0) = "RF"
    g_subSystems(1) = "VAC"
    g_subSystems(2) = "MAG"
    g_subSystems(3) = "SER"
    g_subSystems(4) = "TUNE"
    g_subSystems(5) = "DIAG"
    g_subSystems(6) = "EXP"
    g_subSystems(7) = "MEX"
    g_subSystems(8) = "SUB"
    g_subSystems(9) = "QPS"
    g_subSystems(10) = "TIM"
    g_subSystems(11) = "INJ"
    g_subSystems(12) = "HIST"
    g_subSystems(13) = "UTIL"
    g_subSystems(14) = "TEST"
    g_nsubsystems = 15
Else
    n = 0
    For i% = 0 To MAX_SUBSYSTEMS - 1
      If subsys(i%).nam(0) <> 0 Then
        tmpstr = TrimString(BSTR(subsys(i%).nam()))
        If tmpstr = "XXX" Then
          tmpstr = ""
        Else
          If Asc(tmpstr) < 48 Then tmpstr = ""
        End If
        If tmpstr = fecform.ContextList.text Then tmpstr = ""
        If tmpstr = "TEST" Then tmpstr = ""
        If Len(tmpstr) > 0 Then
          g_subSystems(n) = tmpstr
          n = n + 1
        End If
      End If
      If n = MAXSUBSYS Then Exit For 'only 24 subsys labels at the moment
    Next
    If n < MAXSUBSYS Then
      g_subSystems(n) = "TEST"
      n = n + 1
    End If
    g_nsubsystems = n
End If
For i% = 0 To g_nsubsystems - 1
  Select Case g_subSystems(i)
    Case "VAC": g_subSystemsTipText(i) = "Vacuum"
    Case "MAG": g_subSystemsTipText(i) = "Magnets"
    Case "SER": g_subSystemsTipText(i) = "Services"
    Case "TUNE": g_subSystemsTipText(i) = "Tunes/Feedback"
    Case "DIAG": g_subSystemsTipText(i) = "Diagnostics"
    Case "EXP": g_subSystemsTipText(i) = "Experiments"
    Case "MEX": g_subSystemsTipText(i) = "Machine/Experiment data Exchange"
    Case "SUB": g_subSystemsTipText(i) = "Subsystems/Infrastructure"
    Case "QPS": g_subSystemsTipText(i) = "Quench Protection"
    Case "TIM": g_subSystemsTipText(i) = "Timing"
    Case "INJ": g_subSystemsTipText(i) = "Injection"
    Case "HIST": g_subSystemsTipText(i) = "History/Archive"
    Case "UTIL": g_subSystemsTipText(i) = "Utilities"
    Case "CRYO": g_subSystemsTipText(i) = "Cryogenics"
    Case "CAM": g_subSystemsTipText(i) = "Cameras"
    Case "RPT": g_subSystemsTipText(i) = "TINE Repeaters"
    Case "TEST": g_subSystemsTipText(i) = "Tests"
    Case Else: g_subSystemsTipText(i) = g_subSystems(i)
  End Select
Next
End Sub

