REM 
REM The central archiver consists of two server processes
REM This script starts the archive server, which handles all
REM read requests.  This process does NOT get and store data.
REM The process which gets and stores data (and acts as a 
REM 'NETMEX' gateway) is the MARCH server.  Both servers need
REM to share the same database and data repository.
REM
@echo off
REM remove these environment variable from the shell if they're there!
set FECDB=
set FEC_HOME=
set FECLOG=
REM start the central archiver server
copy ../../MARCH/bin/march.exe march.exe
start march /f=MARCH0 /c=TEST /p=1 
REM start the central history server 
start arcsrv /f=HISTORY0 /c=TEST /p=2

