VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ArchiveServer"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Archive Server"
Dim npointsRequested As Integer
Dim keyRequested As String
Dim idxRequested As Integer
Dim subidxRequested As Integer

Property Get dataArray(da() As Single) As Integer
dataArray = 0
For i% = 0 To 15
  If FSlct(i%).Active Then
    'fNr = FSlct(i%).fecNo: pNr = FSlct(i%).pNo
    If (archivedKeywords(FSlct(i%).PListIndex).keyword = keyRequested) And _
        (FSlct(i%).Index = idxRequested) And _
        (FSlct(i%).SubIndex = subidxRequested) Then GoTo evaluate
  End If
Next
Exit Property
evaluate:
For n% = 0 To npointsRequested - 1
  If n% > FSlct(i%).npoints% Then Exit For
  'da(n%) = fdat(n%, i%)
  da(n%) = ArchData(n% + 1, i%).fval
Next
dataArray = n% - 1
End Property
Property Get correlatedArray(da() As Single) As Integer
If FSlct(0).npoints% = 0 Then Exit Property
Dim y0(5000) As Single, x0(5000) As Long
Dim y1(5000) As Single, x1(5000) As Long
correlatedArray = 0
For i% = 0 To 15
  If FSlct(i%).Active Then
    'fNr = FSlct(i%).fecNo: pNr = FSlct(i%).pNo
    If (archivedKeywords(i%).keyword = keyRequested) And _
        (FSlct(i%).Index = idxRequested) And _
        (FSlct(i%).SubIndex = subidxRequested) Then GoTo evaluate
  End If
Next
Exit Property
evaluate:
'the fool switched the meaning of the array indices => dll calls with double arrays
'won't work !!!
'Call MEMCPY(y0(0), fdat(0, i%), fslct(i%).npoints)
For ii = 0 To FSlct(i%).npoints - 1
    'y0(ii) = fdat(ii, 0)
    'x0(ii) = ltim(ii, 0)
    'y1(ii) = fdat(ii, i%)
    'x1(ii) = ltim(ii, i%)

    y0(ii) = ArchData(ii, 0).fval
    x0(ii) = ArchData(ii, 0).ival
    y1(ii) = ArchData(ii, i%).fval
    x1(ii) = ArchData(ii, i%).ival
Next
If i% > 0 Then Call INTERP(y1(0), x1(0), FSlct(i%).npoints, x0(0), FSlct(0).npoints)
'If i% > 0 Then Call INTERP1(x0(), y0(), fslct(0).npoints, x1(), y1(), fslct(i%).npoints)
For n% = 0 To npointsRequested - 1
  If n% > FSlct(0).npoints% Then Exit For
  da(n%) = y1(n%)
Next
correlatedArray = FSlct(0).npoints
End Property
Function getSelectedName(n As Integer) As String
Dim i As Integer
If n > 15 Then
  getSelectedName = ""
  Exit Function
End If
i = FSlct(n).PListIndex
'fNr = FSlct(n).fecNo: pNr = FSlct(n).pNo
nm$ = archivedKeywords(i).keyword
If archivedKeywords(i).size > 1 Then
  nm$ = nm$ + "[" + Trim$(str$(FSlct(n).Index)) + "]"
  If FSlct(n).SubIndex > 0 Then nm$ = nm$ + "[" + Trim$(str$(FSlct(n).SubIndex)) + "]"
End If
getSelectedName = nm$
End Function
Property Get nameList(name1$, name2$, name3$, name4$, name5$, name6$, name7$, NAME8$) As Integer
Dim nam$(15)
Dim i As Integer, j As Integer
name1$ = "": name2$ = "": name3$ = "": name4$ = "": name5$ = "": name6$ = "": name7$ = "": NAME8$ = ""
For i = 0 To 15
  If FSlct(i).Active Then
    nam$(j) = getSelectedName(i)
    j = j + 1
  End If
Next
name1$ = nam$(0): name2$ = nam$(1): name3$ = nam$(2): name4$ = nam$(3)
name5$ = nam$(4): name6$ = nam$(5): name7$ = nam$(6): NAME8$ = nam$(7)
nameList = NPlots%(ActivePlot%)
End Property
Property Get keywordList(names$())
For i% = 0 To 15
  If FSlct(i%).Active Then
    'fNr = FSlct(i%).fecNo: pNr = FSlct(i%).pNo
    names$(i%) = archivedKeywords(i%).keyword
    If archivedKeywords(i%).size > 1 Then
      names$(i%) = names$(i%) + "[" + str$(FSlct(i%).Index) + "]"
    End If
  End If
Next
keywordList = NPlots%(ActivePlot%)
End Property
Property Get timeArray(ti() As Long) As Integer
timeArray = 0
For i% = 0 To 15
  If FSlct(i%).Active Then
    'fNr = FSlct(i%).fecNo: pNr = FSlct(i%).pNo
    If (archivedKeywords(FSlct(i%).PListIndex).keyword = keyRequested) And _
        (FSlct(i%).Index = idxRequested) And _
        (FSlct(i%).SubIndex = subidxRequested) Then GoTo evaluate
  End If
Next
Exit Property
evaluate:
For n% = 0 To npointsRequested - 1
    If n% > FSlct(i%).npoints% Then Exit For
    'ti(n%) = ltim(n%, i%)
    ti(n%) = ArchData(n% + 1, i%).ival
Next
timeArray = n% - 1
End Property
Property Get ctimeArray(ts() As String) As Integer
Dim tss As String * 26
ctimeArray = 0
For i% = 0 To 15
  If FSlct(i%).Active Then
    'fNr = FSlct(i%).fecNo: pNr = FSlct(i%).pNo
    If (archivedKeywords(i%).keyword = keyRequested) And _
        (FSlct(i%).Index = idxRequested) And _
        (FSlct(i%).SubIndex = subidxRequested) Then GoTo evaluate
  End If
Next
Exit Property
evaluate:
For n% = 0 To npointsRequested - 1
  If n% > FSlct(i%).npoints% Then Exit For
  Call CTIME(tss, ArchData(n% + 1, i%).ival)
  ts(n%) = tss
Next
ctimeArray = n% - 1
End Property


Public Sub load(ByVal key$, ByVal npts%)
npointsRequested = npts%
keyRequested = key$
End Sub
Function request(key$, npts%)
Dim keyIndex As Integer
Dim subkeyIndex As Integer
Dim tmpKey$
If key$ = "" Then
  request = -1
  Exit Function
End If
tmpKey$ = key$
For i% = 0 To 15
  If FSlct(i%).Active Then
    'fNr = FSlct(i%).fecNo: pNr = FSlct(i%).pNo:
    idx = FSlct(i%).Index
    p% = InStr(tmpKey$, "[")
    If p% > 0 Then
      indices$ = Right$(tmpKey, Len(tmpKey) - p%)
      keyIndex = Val(indices$)
      tmpKey = Left$(key$, p% - 1)
      p2% = InStr(indices$, "[")
      If p2% > 0 Then
        subkeyIndex = Val(Right$(indices$, Len(indices$) - p2%))
      End If
    End If
    If archivedKeywords(FSlct(i%).PListIndex).keyword = tmpKey Then GoTo ValidateKey
  End If
Next
request = -1
Exit Function
ValidateKey:
npointsRequested = npts%
keyRequested = tmpKey
idxRequested = keyIndex
subidxRequested = subkeyIndex
request = 0
End Function

