VERSION 5.00
Object = "{3C5F82B2-2B3E-11D1-B429-00AA004115AF}#2.0#0"; "acop.ocx"
Begin VB.Form FilterForm 
   Caption         =   "Filter Settings"
   ClientHeight    =   3390
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4545
   Icon            =   "FilterForm.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3390
   ScaleWidth      =   4545
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Height          =   1005
      Left            =   30
      TabIndex        =   2
      Top             =   2340
      Width           =   4455
      Begin VB.CommandButton ApplyCmd 
         Caption         =   "Apply"
         Height          =   375
         Left            =   3660
         TabIndex        =   14
         Top             =   540
         Width           =   675
      End
      Begin VB.ComboBox stateParamCombo 
         Height          =   315
         Left            =   1680
         TabIndex        =   13
         Top             =   150
         Visible         =   0   'False
         Width           =   2595
      End
      Begin VB.CheckBox StateOnlyCheck 
         Caption         =   "State Only"
         Height          =   315
         Left            =   90
         TabIndex        =   12
         Top             =   570
         Width           =   1065
      End
      Begin VB.CommandButton clearCommand 
         Caption         =   "Clear"
         Height          =   375
         Left            =   2880
         TabIndex        =   10
         Top             =   540
         Width           =   735
      End
      Begin VB.CommandButton removeCommand 
         Caption         =   "Remove"
         Height          =   375
         Left            =   2070
         TabIndex        =   9
         Top             =   540
         Width           =   765
      End
      Begin VB.CommandButton AddCommand 
         Caption         =   "Add"
         Height          =   375
         Left            =   1260
         TabIndex        =   8
         Top             =   540
         Width           =   765
      End
      Begin VB.TextBox maxText 
         Height          =   315
         Left            =   3210
         TabIndex        =   7
         Top             =   150
         Width           =   645
      End
      Begin VB.TextBox minText 
         Height          =   315
         Left            =   1920
         TabIndex        =   5
         Top             =   150
         Width           =   645
      End
      Begin VB.ComboBox ParamCombo 
         Height          =   315
         Left            =   90
         Sorted          =   -1  'True
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   150
         Width           =   1455
      End
      Begin VB.Label eguLabel 
         Height          =   225
         Left            =   3900
         TabIndex        =   11
         Top             =   210
         Width           =   435
      End
      Begin VB.Label Label2 
         Caption         =   "and <="
         Height          =   285
         Left            =   2610
         TabIndex        =   6
         Top             =   180
         Width           =   585
      End
      Begin VB.Label Label1 
         Caption         =   ">="
         Height          =   285
         Left            =   1650
         TabIndex        =   4
         Top             =   150
         Width           =   345
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Display Conditions"
      Height          =   2235
      Left            =   60
      TabIndex        =   0
      Top             =   30
      Width           =   4425
      Begin ACOPLib.ACOP ACOPStates 
         Height          =   135
         Left            =   3960
         TabIndex        =   15
         Top             =   1800
         Visible         =   0   'False
         Width           =   135
         _Version        =   131072
         _ExtentX        =   238
         _ExtentY        =   238
         _StockProps     =   47
         ForeColor       =   0
         BackColor       =   16777215
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         XAxisLabel      =   ""
         YAxisLabel      =   ""
         Status          =   ""
         LeadingEdgeColor=   -2147483630
         CursorMarkerColor=   -2147483630
      End
      Begin VB.Label FilterLabel 
         Height          =   1935
         Left            =   90
         TabIndex        =   1
         Top             =   240
         Width           =   4275
      End
   End
End
Attribute VB_Name = "FilterForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim params() As String
Dim nparams As Integer
Dim selectedFormat As String
Dim lastArchiveContext As String
Dim stateParams(30) As String
Dim nStateParams As Integer
Private Const MaximumStates = 100
Dim StateListBytes(MaximumStates) As NAME32, StateListStr$(MaximumStates)

Function makeFilterCaption() As String
Dim i As Integer
Dim s As String, cs As String
cs = "With : "
For i = 0 To nFilterKeywords - 1
  Select Case UCase(filterKeywords(i).fmt)
    Case "NAME16", "NAME32", "NAME48", "TEXT":
      s = s + vbNewLine + filterKeywords(i).Keyword + " = " + filterKeywords(i).plot
      cs = cs + filterKeywords(i).Keyword + " = " + filterKeywords(i).plot
    Case Else:
      s = s + vbNewLine + filterKeywords(i).Keyword + " >= " + _
              STR(filterKeywords(i).Min) + " AND <= " + STR(filterKeywords(i).Max) + _
              " " + filterKeywords(i).egu
      cs = cs + filterKeywords(i).Keyword + " >= " + _
              STR(filterKeywords(i).Min) + " AND <= " + STR(filterKeywords(i).Max)
  End Select
Next
makeFilterCaption = s
filterString = cs
End Function
Private Sub AddCommand_Click()
Dim s As String
If nFilterKeywords > 10 Then Exit Sub
filterKeywords(nFilterKeywords).Context = gArchiveContext$
filterKeywords(nFilterKeywords).HistoryServer = gHistoryServer$
filterKeywords(nFilterKeywords).DataServer = gDataServer$
filterKeywords(nFilterKeywords).Keyword = ParamCombo.text
filterKeywords(nFilterKeywords).Min = Val(minText.text)
filterKeywords(nFilterKeywords).Max = Val(maxText.text)
filterKeywords(nFilterKeywords).egu = eguLabel.Caption
filterKeywords(nFilterKeywords).fmt = selectedFormat
Select Case UCase(selectedFormat)
  Case "NAME16", "NAME32", "NAME48", "TEXT":
    If stateParamCombo.Visible Then
      filterKeywords(nFilterKeywords).plot = stateParamCombo.text
    Else
      filterKeywords(nFilterKeywords).plot = minText.text
    End If
End Select
nFilterKeywords = nFilterKeywords + 1
filterAcquired = False
FilterLabel.Caption = makeFilterCaption
End Sub

Private Sub ApplyCmd_Click()
If Not filterAcquired Then Call DoTheData(0)
End Sub

Private Sub clearCommand_Click()
FilterLabel.Caption = ""
nFilterKeywords = 0
End Sub

Private Sub Form_Load()
fillStateParams
fillParamCombo
End Sub
Sub fillStateParams()
Dim i%, NStates%
'Dim StateListBytes(MaximumStates) As NAME32, StateListStr$(MaximumStates)

stateParamCombo.Clear
nStateParams = 0
If gArchiveServerInfo(SelectedContext%).StateServerName = "" Then
    ' No states!
    MsgBox "No State Server!"
End If

ACOPStates.deviceName = gArchiveServerInfo(SelectedContext%).StateServerName + "/#0"
ACOPStates.deviceProperty = "STATELIST"
ACOPStates.AccessMode = "READ"
rcc& = ACOPStates.Execute(StateListBytes(0).nam(0), 100, "NAME32")
If rcc& Then
    ' Error!
    MsgBox "Error reading state list!" + ACOPStates.status
    Exit Sub
End If

For i% = 0 To MaximumStates - 1
    StateListStr$(i%) = BSTR(StateListBytes(i%).nam)
    If StateListStr$(i%) = "" Then Exit For
Next i%
nStateParams = i%

For i% = 0 To nStateParams - 1
    stateParamCombo.AddItem StateListStr$(i%)
Next i%
stateParamCombo.text = StateListStr$(1)

'stateParams(0) = "Undefined"
'stateParams(1) = "Ramp"
'stateParams(2) = "Ramp Idle"
'stateParams(3) = "Ramp Abort"
'stateParams(4) = "Ramp End"
'stateParams(5) = "Injection Ready"
'stateParams(6) = "Massage"
'stateParams(7) = "Massage Idle"
'stateParams(8) = "Massage Abort"
'stateParams(9) = "Massage end"
'stateParams(10) = "Lumi Ready"
'stateParams(11) = "Idle"
'stateParams(12) = "Not Operating"
'stateParams(13) = "Lumi Run"
'stateParams(14) = "Lumi Run End"
'stateParams(15) = "Lumi End Pending"
'stateParams(16) = "Load Lumi"
'stateParams(17) = "Load Lumi Idle"
'stateParams(18) = "Load Lumi Abort"
'stateParams(19) = "Lumi Done"
'stateParams(20) = "Run Ready"
'nStateParams = 21

End Sub
Sub fillParamCombo()
Dim i%
If lastArchiveContext = gArchiveContext$ Then Exit Sub
lastArchiveContext = gArchiveContext$
If GetArchivedParameters(gArchiveContext$, gHistoryServer$, "", params(), nparams) Then Exit Sub
ParamCombo.Clear
For i% = 0 To nparams - 1
  If Not ((StateOnlyCheck.Value = 1) And (InStr(UCase(params(i%)), "STATE") = 0)) Then
    ParamCombo.AddItem params(i%)
  End If
Next
If ParamCombo.ListCount > 0 Then ParamCombo.ListIndex = 0
stateParamCombo.Visible = StateOnlyCheck.Value
End Sub

Private Sub Form_Unload(Cancel As Integer)
If Not filterAcquired Then Call DoTheData(0)
End Sub

Private Sub ParamCombo_Click()
Dim Max As Single, Min As Single, egu As String
Dim desc As String, plot As String, siz As Integer, fmt As String
Dim ArrayType%, xmax!, xmin!, XUnits$, tmpName$

'Call getKeywordInfo(gHistoryServer$, ParamCombo.text, min, max, egu, plot, desc, siz, fmt)
tmpName$ = gArchiveContext$ + "/" + gHistoryServer$ + "/" + gArchiveDevice$
Call getALLKeywordInfo(tmpName$, ParamCombo.text, Min, Max, egu, plot, desc, siz, fmt, _
                        ArrayType%, xmax!, xmin!, XUnits$)
Select Case UCase(fmt)
  Case "NAME16", "NAME32", "NAME48", "TEXT":
    If Not stateParamCombo.Visible Then
      minText.text = plot
      maxText.text = plot
    End If
  Case Else:
    minText.text = STR(Min)
    maxText.text = STR(Max)
End Select
eguLabel.Caption = egu
selectedFormat = fmt
End Sub

Private Sub removeCommand_Click()
Dim i As Integer
Dim found As Boolean
For i = 0 To nFilterKeywords - 1
  If filterKeywords(i).Keyword = ParamCombo.text Then found = True
  If found Then
    filterKeywords(i).Keyword = filterKeywords(i + 1).Keyword
    filterKeywords(i).Context = filterKeywords(i + 1).Context
    filterKeywords(i).HistoryServer = filterKeywords(i + 1).HistoryServer
    filterKeywords(i).DataServer = filterKeywords(i + 1).DataServer
    filterKeywords(i).Keyword = filterKeywords(i + 1).Keyword
    filterKeywords(i).Min = filterKeywords(i + 1).Min
    filterKeywords(i).Max = filterKeywords(i + 1).Max
    filterKeywords(i).fmt = filterKeywords(i + 1).fmt
    filterKeywords(i).plot = filterKeywords(i + 1).plot
  End If
Next
If found Then nFilterKeywords = nFilterKeywords - 1
filterAcquired = False
FilterLabel.Caption = makeFilterCaption
End Sub

Private Sub StateOnlyCheck_Click()
lastArchiveContext = ""
fillParamCombo
End Sub
