VERSION 5.00
Begin VB.Form Filter 
   Caption         =   "Display Filter"
   ClientHeight    =   2250
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   2625
   LinkTopic       =   "Form1"
   ScaleHeight     =   2250
   ScaleWidth      =   2625
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Save"
      Height          =   375
      Left            =   1350
      TabIndex        =   3
      Top             =   1830
      Width           =   1245
   End
   Begin VB.CommandButton Command1 
      Caption         =   "OK"
      Height          =   375
      Left            =   30
      TabIndex        =   2
      Top             =   1830
      Width           =   1275
   End
   Begin VB.Frame Frame1 
      Caption         =   "Device Server Names to display : "
      Height          =   1665
      Left            =   0
      TabIndex        =   0
      Top             =   120
      Width           =   2595
      Begin VB.TextBox FilterList 
         Height          =   1395
         Left            =   90
         MultiLine       =   -1  'True
         TabIndex        =   1
         Top             =   210
         Width           =   2445
      End
   End
   Begin VB.Label Label1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000080&
      Height          =   2055
      Left            =   2670
      TabIndex        =   4
      Top             =   120
      Width           =   3615
   End
   Begin VB.Menu hlp 
      Caption         =   "&Help"
   End
End
Attribute VB_Name = "Filter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub Command1_Click()
Unload Filter
End Sub

Private Sub Command2_Click()
Call fillFilter
On Error GoTo filter_save_handler
fltrfile$ = "eqfilter.csv"
Open fltrfile$ For Output As #1
Print #1, "Filter"
For i% = 0 To neqfltr% - 1
  Print #1, eqfltr$(i%)
Next
Close 1
filter_save_handler:
Exit Sub
End Sub

Private Sub Form_Load()
S$ = ""
S$ = S$ + "Enter display criteria. " + vbNewLine
S$ = S$ + "Use '*' as a wild-card: e.g. " + vbNewLine + vbNewLine
S$ = S$ + "   *     - all" + vbNewLine
S$ = S$ + "   HE*   - all beginning with 'HE'" + vbNewLine
S$ = S$ + "   *BPM  - all ending with 'BPM'" + vbNewLine
S$ = S$ + "   *RF*  - all containing 'RF'"
Label1.Caption = S$

Call fillList
End Sub

Private Sub Form_Unload(Cancel As Integer)
Call fillFilter
End Sub
Sub fillList()
S$ = ""
For i% = 0 To neqfltr% - 1
 S$ = S$ + eqfltr$(i%) + vbNewLine
Next
Filter.FilterList.text = S$
End Sub
Sub fillFilter()
Dim i%
S$ = Filter.FilterList.text
While Len(S$) > 0
  p% = InStr(S$, vbNewLine)
  If p% = 0 Then GoTo out
  s1$ = Left$(S$, p% - 1)
  If Len(s1$) > 0 Then
    eqfltr$(i%) = s1$
    i% = i% + 1
    If i% >= 50 Then GoTo out
  End If
  S$ = Right$(S$, Len(S$) - p% - 1)
Wend
out:
neqfltr% = i%
End Sub


Private Sub hlp_Click()
Filter.Width = 6510
End Sub
