Attribute VB_Name = "Module1"
Type AMS_LEGACY            ' Alarm Message Structure
tag(15) As Byte
device(15) As Byte
almTag(15) As Byte
alarmCode As Long
timestamp As Long
alarmMask As Long
alarmData(5) As Byte
alarmDataFormat As Byte
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
alarmSystem As Integer
End Type

Type AMRB_LEGACY         ' Alarm Message Request Block
starttime As Long
stoptime As Long
severity As Long
reservered As Long
End Type

Type ASB_LEGACY        ' Alarm Status Block
nalarms As Long
mostRecentAlarmTime As Long
highestSeverity As Long
nalarmsAtMostRecentAlarmTime As Long
nalarmsAtHighestSeverity As Long
End Type

Type ADS
tag(15) As Byte
code As Long
mask As Long
severity As Integer
DataFormat As Byte
dataDim As Byte
timeRes As Long
hitsChannel As Integer
hitsModule As Integer
alarmtext(39) As Byte
deviceText(37) As Byte
alarmSystem As Integer
dataText(39) As Byte
url(39) As Byte
reserved As Long
End Type

Global Const MAXALARMS = 200
Global Const MAXALARMDEF = 10
Global AlarmMessages(MAXALARMS) As AMS
Global AlarmMessage As AMS
Global AlarmRequest As AMRB
Global AlarmStatus As ASB
Global AlarmDef(MAXALARMDEF) As ADS
Global AlarmDefinition As ADS

Global nalarms%

Type AQS
SrvName(19) As Byte
localTime As Long
starttime As Long
systemPollingRate As Long
numBkgTasks As Integer
numTotalContracts As Integer
numTotalClients As Integer
numTargetContracts As Integer
numTargetClients As Integer
numConnections As Integer
numConnectionTimeouts As Long
numConnectionArrivals As Long
numUDPPkts As Long
numTCPpkts As Long
numIPXpkts As Long
numSPXpkts As Long
End Type
Global ActivityQuery As AQS

Type CONQS
  EqpProperty(31) As Byte
  EqpDeviceName(15) As Byte
  EqpName(7) As Byte
  EqpSizeIn As Long
  EqpSizeOut As Long
  hEqpName As Byte
  EqpAccess As Byte
  EqpFormatIn As Byte
  EqpFormatOut As Byte
  strTagIn(7) As Byte
  strTagOut(7) As Byte
  pollRate As Long
  nconsumers As Long
End Type

Type CTQSr4
  EqpProperty(63) As Byte
  EqpDeviceName(63) As Byte
  EqpName(7) As Byte
  EqpSizeIn As Long
  EqpSizeOut As Long
  hEqpName As Byte
  EqpAccess As Byte
  EqpFormatIn As Byte
  EqpFormatOut As Byte
  strTagIn(15) As Byte
  strTagOut(15) As Byte
  pollRate As Long
  nconsumers As Long
End Type

Global Const MAXCONTRACTS = 200
Global ContractQuery(MAXCONTRACTS - 1) As CTQSr4

Type CLNQS
  UserName(15) As Byte
  network(3) As Byte
  node(5) As Byte
  ipxsocket(1) As Byte
  immAddr(5) As Byte
  sockFamily As Integer
  sockPort As Integer
  sockAddr(3) As Byte
  reserved(7) As Byte
  ncontracts As Integer
  netProtocol As Integer
End Type

Global Const MAXCLIENTS = 100
Global ClientQuery(MAXCLIENTS - 1) As CLNQS

