@echo off
REM set the environment ...
if "%TINEHOME%" == "" set TINEHOME=%SystemDrive%\tine
if "%LOCALSOURCEDIR%" == "" set LOCALSOURCEDIR=L:
if "%ALLUSERSPROFILE%" == "" set ALLUSERSPROFILE=%windir%\Profiles\All Users
if "%CONTROLSOURCEDIR%" == "" set CONTROLSOURCEDIR=.
if "%STARTUPLINK%" == "" set STARTUPLINK=Programs\TINE

REM create tine home ...
mkdir %TINEHOME%
mkdir %TINEHOME%\system32
mkdir %TINEHOME%\Log

REM copy dlls, exes ...
%CONTROLSOURCEDIR%\support32\ROBOCOPY %CONTROLSOURCEDIR%\support32\ %windir%\system32\ *.* /XX /XO /XN /XC /R:0
call %windir%\system32\registervbocx.bat
%CONTROLSOURCEDIR%\support32\ROBOCOPY %CONTROLSOURCEDIR%\dll32\ %TINEHOME%\system32\ *.* /XX /XO /R:0  
%TINEHOME%\system32\regocx.exe /LOG=%TEMP%\regocx.log
%CONTROLSOURCEDIR%\support32\ROBOCOPY %CONTROLSOURCEDIR%\apps32\CommandLine\bin %TINEHOME%\system32\ *.* /XX /XO /R:0  
%CONTROLSOURCEDIR%\support32\ROBOCOPY %CONTROLSOURCEDIR%\dll64\ %TINEHOME%\system32\ *.* /XX /XO /R:0  
%CONTROLSOURCEDIR%\support32\ROBOCOPY %CONTROLSOURCEDIR%\dll.net\ %TINEHOME%\system32\ *.* /XX /XO /R:0  

REM fix ENS address in cshosts.csv ?
%CONTROLSOURCEDIR%\support32\ROBOCOPY %CONTROLSOURCEDIR%\database\ %TINEHOME%\database\ *.csv /R:0

REM put %TINEHOME% on the path ...
echo %path% | find /i "%TINEHOME%"
if "%errorlevel%" == "0" goto skip01
echo Put %TINEHOME% on the path ...
setx PATH "%PATH%;%TINEHOME%\system32" -m
set PATH=%PATH%;%TINEHOME%\system32
:skip01

echo Share Controls Directory ...
net share controls=%TINEHOME%

subst %LOCALSOURCEDIR% %TINEHOME%

echo set control database environment ...
setx TINE_HOME %TINEHOME%\database\ -m
set TINE_HOME=%TINEHOME%\database\

echo Copying Applications to Local Disk ...
mkdir %TINEHOME%\bin
mkdir %TINEHOME%\bin\InstantClient
set APPDIR=%TINEHOME%\bin\InstantClient
set APPEXE=bin\client.exe
set APPNAME=Instant Client
ROBOCOPY %CONTROLSOURCEDIR%\apps32\InstantClient\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\AlarmViewer
set APPDIR=%TINEHOME%\bin\AlarmViewer
set APPEXE=bin\AlarmViewer.exe
set APPNAME=Alarm Viewer
ROBOCOPY %CONTROLSOURCEDIR%\apps32\AlarmViewer\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\AlarmManager
set APPDIR=%TINEHOME%\bin\AlarmManager
set APPEXE=bin\almdbMngr.exe
set APPNAME=Alarm Database Manager
ROBOCOPY %CONTROLSOURCEDIR%\apps32\AlarmManager\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\ArchiveReader
set APPDIR=%TINEHOME%\bin\ArchiveReader
set APPEXE=bin\arch.exe
set APPNAME=Archive Reader
ROBOCOPY %CONTROLSOURCEDIR%\apps32\ArchiveReader\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\ArchiveManager
set APPDIR=%TINEHOME%\bin\ArchiveManager
set APPEXE=bin\arcdbmgr.exe
set APPNAME=Archive Database Manager
ROBOCOPY %CONTROLSOURCEDIR%\apps32\ArchiveManager\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\OpHistManager
set APPDIR=%TINEHOME%\bin\OpHistManager
set APPEXE=bin\OpHistMgr.exe
set APPNAME=Operation History/State Database Manager
ROBOCOPY %CONTROLSOURCEDIR%\apps32\OpHistMgr\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\EventArchiveManager
set APPDIR=%TINEHOME%\bin\EventArchiveManager
set APPEXE=bin\pmarcdbmgr.exe
set APPNAME=Event Archive Database Manager
ROBOCOPY %CONTROLSOURCEDIR%\apps32\EventArchiveManager\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\MultiChannelAnalizer
set APPDIR=%TINEHOME%\bin\MultiChannelAnalizer
set APPEXE=bin\spectrum.exe
set APPNAME=Multi-Channel Analyzer
ROBOCOPY %CONTROLSOURCEDIR%\apps32\MultiChannelAnalizer\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\Remote
set APPDIR=%TINEHOME%\bin\Remote
set APPEXE=bin\Remote.exe
set APPNAME=Fec Remote Control
ROBOCOPY %CONTROLSOURCEDIR%\apps32\Remote\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\ServerSetup
set APPDIR=%TINEHOME%\bin\ServerSetup
set APPEXE=bin\srvsetup.exe
set APPNAME=Server Setup
ROBOCOPY %CONTROLSOURCEDIR%\apps32\ServerSetup\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\FecSetup
set APPDIR=%TINEHOME%\bin\FecSetup
set APPEXE=bin\fecsetup.exe
set APPNAME=Fec Setup
ROBOCOPY %CONTROLSOURCEDIR%\apps32\FecSetup\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\FecAdmin
set APPDIR=%TINEHOME%\bin\FecAdmin
set APPEXE=bin\fecadmin.exe
set APPNAME=Fec Administration
ROBOCOPY %CONTROLSOURCEDIR%\apps32\FecAdmin\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\FecStatsViewer
set APPDIR=%TINEHOME%\bin\FecStatsViewer
set APPEXE=bin\fecstats.exe
set APPNAME=Fec Statistics
ROBOCOPY %CONTROLSOURCEDIR%\apps32\FecStatsViewer\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\FecChecker
set APPDIR=%TINEHOME%\bin\FecChecker
set APPEXE=bin\feccheck.exe
set APPNAME=Fec Checker
ROBOCOPY %CONTROLSOURCEDIR%\apps32\FecChecker\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%

mkdir %TINEHOME%\bin\AttachToService
set APPDIR=%TINEHOME%\bin\AttachToService
set APPEXE=bin\AttachFec.exe
set APPNAME=Attach To Service Fec
ROBOCOPY %CONTROLSOURCEDIR%\apps32\AttachToService\ %APPDIR% *.* /R:0 /S /E
CreateLink --l=%STARTUPLINK%\%APPNAME% --x=%APPDIR%\%APPEXE% --w=%APPDIR% --i=%APPDIR%\%APPEXE%
